; ======================================================;
;                                                       ;
;   ntdll.inc for Easy Code 2.0 64-bit Masm projects    ;
;                    (version 1.0.0)                    ;
;                                                       ;
;              Copyright  Ramon Sala 2020              ;
;                                                       ;
; ======================================================;

IFNDEF NTDLL_INC
NTDLL_INC     EQU     1

IFNDEF KERNEL32_INC
    include kernel32.inc
ENDIF

MAXIMUM_FILENAME_LENGTH                         EQU     256
PORT_MAXIMUM_MESSAGE_LENGTH                     EQU     256
INITIAL_PRIVILEGE_COUNT                         EQU     3

FSCTL_GET_VOLUME_INFORMATION                    EQU     90064H

DOS_PATHTYPE_UNC                                EQU     00000001H
DOS_PATHTYPE_ROOTDRIVE                          EQU     00000002H
DOS_PATHTYPE_STREAM                             EQU     00000003H
DOS_PATHTYPE_NT                                 EQU     00000004H
DOS_PATHTYPE_NAME                               EQU     00000005H
DOS_PATHTYPE_DEVICE                             EQU     00000006H
DOS_PATHTYPE_LOCALUNCROOT                       EQU     00000007H

FILE_REMOVABLE_MEDIA                            EQU     00000001H
FILE_READ_ONLY_DEVICE                           EQU     00000002H
FILE_FLOPPY_DISKETTE                            EQU     00000004H
FILE_WRITE_ONCE_MEDIA                           EQU     00000008H
FILE_REMOTE_DEVICE                              EQU     00000010H
FILE_DEVICE_IS_MOUNTED                          EQU     00000020H
FILE_VIRTUAL_VOLUME                             EQU     00000040H
FILE_AUTOGENERATED_DEVICE_NAME                  EQU     00000080H
FILE_DEVICE_SECURE_OPEN                         EQU     00000100H

FILE_SUPERSEDE                                  EQU     00000000H
FILE_OPEN                                       EQU     00000001H
FILE_CREATE                                     EQU     00000002H
FILE_OPEN_IF                                    EQU     00000003H
FILE_OVERWRITE                                  EQU     00000004H
FILE_OVERWRITE_IF                               EQU     00000005H
FILE_MAXIMUM_DISPOSITION                        EQU     00000005H

FILE_DIRECTORY_FILE                             EQU     00000001H
FILE_WRITE_THROUGH                              EQU     00000002H
FILE_SEQUENTIAL_ONLY                            EQU     00000004H
FILE_NO_INTERMEDIATE_BUFFERING                  EQU     00000008H

FILE_SYNCHRONOUS_IO_ALERT                       EQU     00000010H
FILE_SYNCHRONOUS_IO_NONALERT                    EQU     00000020H
FILE_NON_DIRECTORY_FILE                         EQU     00000040H
FILE_CREATE_TREE_CONNECTION                     EQU     00000080H

FILE_COMPLETE_IF_OPLOCKED                       EQU     00000100H
FILE_NO_EA_KNOWLEDGE                            EQU     00000200H
FILE_OPEN_FOR_RECOVERY                          EQU     00000400H
FILE_RANDOM_ACCESS                              EQU     00000800H

FILE_DELETE_ON_CLOSE                            EQU     00001000H
FILE_OPEN_BY_FILE_ID                            EQU     00002000H
FILE_OPEN_FOR_BACKUP_INTENT                     EQU     00004000H
FILE_NO_COMPRESSION                             EQU     00008000H

FILE_RESERVE_OPFILTER                           EQU     00100000H
FILE_OPEN_REPARSE_POINT                         EQU     00200000H
FILE_OPEN_NO_RECALL                             EQU     00400000H
FILE_OPEN_FOR_FREE_SPACE_QUERY                  EQU     00800000H

FILE_COPY_STRUCTURED_STORAGE                    EQU     00000041H
FILE_STRUCTURED_STORAGE                         EQU     00000441H

FILE_VALID_OPTION_FLAGS                         EQU     00ffffffH
FILE_VALID_PIPE_OPTION_FLAGS                    EQU     00000032H
FILE_VALID_MAILSLOT_OPTION_FLAGS                EQU     00000032H
FILE_VALID_SET_FLAGS                            EQU     00000036H

THREAD_STATE_INITIALIZED                        EQU     0
THREAD_STATE_READY                              EQU     1
THREAD_STATE_RUNNING                            EQU     2
THREAD_STATE_STANDBY                            EQU     3
THREAD_STATE_TERMINATED                         EQU     4
THREAD_STATE_WAIT                               EQU     5
THREAD_STATE_TRANSITION                         EQU     6
THREAD_STATE_UNKNOWN                            EQU     7

OB_TYPE_TYPE                                    EQU     1
OB_TYPE_DIRECTORY                               EQU     2
OB_TYPE_SYMBOLIC_LINK                           EQU     3
OB_TYPE_TOKEN                                   EQU     4
OB_TYPE_PROCESS                                 EQU     5
OB_TYPE_THREAD                                  EQU     6
OB_TYPE_EVENT                                   EQU     7
OB_TYPE_EVENT_PAIR                              EQU     8
OB_TYPE_MUTANT                                  EQU     9
OB_TYPE_SEMAPHORE                               EQU     10
OB_TYPE_TIMER                                   EQU     11
OB_TYPE_PROFILE                                 EQU     12
OB_TYPE_WINDOW_STATION                          EQU     13
OB_TYPE_DESKTOP                                 EQU     14
OB_TYPE_SECTION                                 EQU     15
OB_TYPE_KEY                                     EQU     16
OB_TYPE_PORT                                    EQU     17
OB_TYPE_ADAPTER                                 EQU     18
OB_TYPE_CONTROLLER                              EQU     19
OB_TYPE_DEVICE                                  EQU     20
OB_TYPE_DRIVER                                  EQU     21
OB_TYPE_IO_COMPLETION                           EQU     22
OB_TYPE_FILE                                    EQU     23

OBJ_INHERIT                                     EQU     00000002H
OBJ_PERMANENT                                   EQU     00000010H
OBJ_EXCLUSIVE                                   EQU     00000020H
OBJ_CASE_INSENSITIVE                            EQU     00000040H
OBJ_OPENIF                                      EQU     00000080H
OBJ_OPENLINK                                    EQU     00000100H
OBJ_VALID_ATTRIBUTES                            EQU     000001F2H


DIRECTORY_QUERY                                 EQU     0001H
DIRECTORY_TRAVERSE                              EQU     0002H
DIRECTORY_CREATE_OBJECT                         EQU     0004H
DIRECTORY_CREATE_SUBDIRECTORY                   EQU     0008H
DIRECTORY_ALL_ACCESS                            EQU     (STANDARD_RIGHTS_REQUIRED OR 0FH)

SYMBOLIC_LINK_QUERY                             EQU     0001H
SYMBOLIC_LINK_ALL_ACCESS                        EQU     (STANDARD_RIGHTS_REQUIRED OR 01H)

DEVICE_TYPE                                     TYPEDEF QWORD

SE_MIN_WELL_KNOWN_PRIVILEGE                     EQU     2
SE_CREATE_TOKEN_PRIVILEGE                       EQU     2
SE_ASSIGNPRIMARYTOKEN_PRIVILEGE                 EQU     3
SE_LOCK_MEMORY_PRIVILEGE                        EQU     4
SE_INCREASE_QUOTA_PRIVILEGE                     EQU     5
SE_UNSOLICITED_INPUT_PRIVILEGE                  EQU     6
SE_MACHINE_ACCOUNT_PRIVILEGE                    EQU     6
SE_TCB_PRIVILEGE                                EQU     7
SE_SECURITY_PRIVILEGE                           EQU     8
SE_TAKE_OWNERSHIP_PRIVILEGE                     EQU     9
SE_LOAD_DRIVER_PRIVILEGE                        EQU     10
SE_SYSTEM_PROFILE_PRIVILEGE                     EQU     11
SE_SYSTEMTIME_PRIVILEGE                         EQU     12
SE_PROF_SINGLE_PROCESS_PRIVILEGE                EQU     13
SE_INC_BASE_PRIORITY_PRIVILEGE                  EQU     14
SE_CREATE_PAGEFILE_PRIVILEGE                    EQU     15
SE_CREATE_PERMANENT_PRIVILEGE                   EQU     16
SE_BACKUP_PRIVILEGE                             EQU     17
SE_RESTORE_PRIVILEGE                            EQU     18
SE_SHUTDOWN_PRIVILEGE                           EQU     19
SE_DEBUG_PRIVILEGE                              EQU     20
SE_AUDIT_PRIVILEGE                              EQU     21
SE_SYSTEM_ENVIRONMENT_PRIVILEGE                 EQU     22
SE_CHANGE_NOTIFY_PRIVILEGE                      EQU     23
SE_REMOTE_SHUTDOWN_PRIVILEGE                    EQU     24
SE_MAX_WELL_KNOWN_PRIVILEGE                     EQU     SE_REMOTE_SHUTDOWN_PRIVILEGE

KAFFINITY                                       TYPEDEF ULONG_PTR
KPRIORITY                                       TYPEDEF LONG
KPROCESSOR_MODE                                 TYPEDEF BYTE

PROCESS_PARAMETERS_NORMALIZED                   EQU     1

LDR_STATIC_LINK                                 EQU     0000002H
LDR_IMAGE_DLL                                   EQU     0000004H
LDR_LOAD_IN_PROGRESS                            EQU     0001000H
LDR_UNLOAD_IN_PROGRESS                          EQU     0002000H
LDR_ENTRY_PROCESSED                             EQU     0004000H
LDR_ENTRY_INSERTED                              EQU     0008000H
LDR_CURRENT_LOAD                                EQU     0010000H
LDR_FAILED_BUILTIN_LOAD                         EQU     0020000H
LDR_DONT_CALL_FOR_THREADS                       EQU     0040000H
LDR_PROCESS_ATTACH_CALLED                       EQU     0080000H
LDR_DEBUG_SYMBOLS_LOADED                        EQU     0100000H
LDR_IMAGE_NOT_AT_BASE                           EQU     0200000H
LDR_WX86_IGNORE_MACHINETYPE                     EQU     0400000H
LDR_COR_IMAGE                                   EQU     00400000H
LDR_COR_OWNS_UNMAP                              EQU     00800000H
LDR_SYSTEM_MAPPED                               EQU     01000000H
LDR_IMAGE_VERIFYING                             EQU     02000000H
LDR_DRIVER_DEPENDENT_DLL                        EQU     04000000H
LDR_ENTRY_NATIVE                                EQU     08000000H
LDR_REDIRECTED                                  EQU     10000000H
LDR_NON_PAGED_DEBUG_INFO                        EQU     20000000H
LDR_MM_LOADED                                   EQU     40000000H
LDR_COMPAT_DATABASE_PROCESSED                   EQU     80000000H

;POOL_TYPE Enumeration
NonPagedPool                                    EQU     0
PagedPool                                       EQU     1
NonPagedPoolMustSucceed                         EQU     2
DontUseThisType                                 EQU     3
NonPagedPoolCacheAligned                        EQU     4
PagedPoolCacheAligned                           EQU     5
NonPagedPoolCacheAlignedMustS                   EQU     6
MaxPoolType                                     EQU     7

;KWAIT_REASON Enumeration
Executive                                       EQU     0
FreePage                                        EQU     1
PageIn                                          EQU     2
PoolAllocation                                  EQU     3
DelayExecution                                  EQU     4
Suspended                                       EQU     5
UserRequest                                     EQU     6
WrExecutive                                     EQU     7
WrFreePage                                      EQU     8
WrPageIn                                        EQU     9
WrPoolAllocation                                EQU     10
WrDelayExecution                                EQU     11
WrSuspended                                     EQU     12
WrUserRequest                                   EQU     13
WrEventPair                                     EQU     14
WrQueue                                         EQU     15
WrLpcReceive                                    EQU     16
WrLpcReply                                      EQU     17
WrVirtualMemory                                 EQU     18
WrPageOut                                       EQU     19
WrRendezvous                                    EQU     20
Spare2                                          EQU     21
Spare3                                          EQU     22
Spare4                                          EQU     23
Spare5                                          EQU     24
Spare6                                          EQU     25
WrKernel                                        EQU     26
MaximumWaitReason                               EQU     27

;SYSTEMINFOCLASS Enumeration
SystemBasicInformation                          EQU     0
SystemProcessorInformation                      EQU     1
SystemPerformanceInformation                    EQU     2
SystemTimeOfDayInformation                      EQU     3
SystemProcessInformation                        EQU     5
SystemCallCounts                                EQU     6
SystemConfigurationInformation                  EQU     7
SystemProcessorTimes                            EQU     8
SystemGlobalFlag                                EQU     9
SystemModuleInformation                         EQU     11
SystemLockInformation                           EQU     12
SystemHandleInformation                         EQU     16
SystemObjectInformation                         EQU     17
SystemPagefileInformation                       EQU     18
SystemInstructionEmulationCounts                EQU     19
SystemCacheInformation                          EQU     21
SystemPoolTagInformation                        EQU     22
SystemProcessorStatistics                       EQU     23
SystemDpcInformation                            EQU     24
SystemLoadImage                                 EQU     26
SystemUnloadImage                               EQU     27
SystemTimeAdjustment                            EQU     28
SystemCrashDumpInformation                      EQU     32
SystemExceptionInformation                      EQU     33
SystemCrashDumpStateInformation                 EQU     34
SystemKernelDebuggerInformation                 EQU     35
SystemContextSwitchInformation                  EQU     36
SystemRegistryQuotaInformation                  EQU     37
SystemLoadAndCallImage                          EQU     38
SystemPrioritySeparation                        EQU     39
SystemTimeZoneInformation                       EQU     44
SystemLookasideInformation                      EQU     45
SystemSetTimeSlipEvent                          EQU     46
SystemCreateSession                             EQU     47
SystemDeleteSession                             EQU     48
SystemRangeStartInformation                     EQU     50
SystemVerifierInformation                       EQU     51
SystemAddVerifier                               EQU     52
SystemSessionProcessesInformation               EQU     53

;THREAD_STATE Enumeration
StateInitialized                                EQU     0
StateReady                                      EQU     1
StateRunning                                    EQU     2
StateStandby                                    EQU     3
StateTerminated                                 EQU     4
StateWait                                       EQU     5
StateTransition                                 EQU     6
StateUnknown                                    EQU     7

;FILE_INFORMATION_CLASS Enumeration
FileDirectoryInformation                        EQU     1
FileFullDirectoryInformation                    EQU     2
FileBothDirectoryInformation                    EQU     3
FileBasicInformation                            EQU     4
FileStandardInformation                         EQU     5
FileInternalInformation                         EQU     6
FileEaInformation                               EQU     7
FileAccessInformation                           EQU     8
FileNameInformation                             EQU     9
FileRenameInformation                           EQU     10
FileLinkInformation                             EQU     11
FileNamesInformation                            EQU     12
FileDispositionInformation                      EQU     13
FilePositionInformation                         EQU     14
FileFullEaInformation                           EQU     15
FileModeInformation                             EQU     16
FileAlignmentInformation                        EQU     17
FileAllInformation                              EQU     18
FileAllocationInformation                       EQU     19
FileEndOfFileInformation                        EQU     20
FileAlternateNameInformation                    EQU     21
FileStreamInformation                           EQU     22
FilePipeInformation                             EQU     23
FilePipeLocalInformation                        EQU     24
FilePipeRemoteInformation                       EQU     25
FileMailslotQueryInformation                    EQU     26
FileMailslotSetInformation                      EQU     27
FileCompressionInformation                      EQU     28
FileObjectIdInformation                         EQU     29
FileCompletionInformation                       EQU     30
FileMoveClusterInformation                      EQU     31
FileInformationReserved32                       EQU     32
FileInformationReserved33                       EQU     33
FileNetworkOpenInformation                      EQU     34
FileMaximumInformation                          EQU     35

;KEY_INFORMATION_CLASS Enumeration
KeyBasicInformation                             EQU     0
KeyNodeInformation                              EQU     1
KeyFullInformation                              EQU     2
KeyNameInformation                              EQU     3
KeyCachedInformation                            EQU     4
KeyVirtualizationInformation                    EQU     5

;KEY_VALUE_INFORMATION_CLASS Enumeration
KeyValueBasicInformation                        EQU     0
KeyValueFullInformation                         EQU     1
KeyValuePartialInformation                      EQU     2

;PROCESSINFOCLASS Enumeration
ProcessBasicInformation                         EQU     0
ProcessQuotaLimits                              EQU     1
ProcessIoCounters                               EQU     2
ProcessVmCounters                               EQU     3
ProcessTimes                                    EQU     4
ProcessBasePriority                             EQU     5
ProcessRaisePriority                            EQU     6
ProcessDebugPort                                EQU     7
ProcessExceptionPort                            EQU     8
ProcessAccessToken                              EQU     9
ProcessLdtInformation                           EQU     10
ProcessLdtSize                                  EQU     11
ProcessDefaultHardErrorMode                     EQU     12
ProcessIoPortHandlers                           EQU     13
ProcessPooledUsageAndLimits                     EQU     14
ProcessWorkingSetWatch                          EQU     15
ProcessUserModeIOPL                             EQU     16
ProcessEnableAlignmentFaultFixup                EQU     17
ProcessPriorityClass                            EQU     18
ProcessWx86Information                          EQU     19
ProcessHandleCount                              EQU     20
ProcessAffinityMask                             EQU     21
ProcessPriorityBoost                            EQU     22
ProcessDeviceMap                                EQU     23
ProcessSessionInformation                       EQU     24
ProcessForegroundInformation                    EQU     25
ProcessWow64Information                         EQU     26
MaxProcessInfoClass                             EQU     27

;LPC_TYPE Enumeration
LPC_NEW_MESSAGE                                 EQU     0
LPC_REQUEST                                     EQU     1
LPC_REPLY                                       EQU     2
LPC_DATAGRAM                                    EQU     3
LPC_LOST_REPLY                                  EQU     4
LPC_PORT_CLOSED                                 EQU     5
LPC_CLIENT_DIED                                 EQU     6
LPC_EXCEPTION                                   EQU     7
LPC_DEBUG_EVENT                                 EQU     8
LPC_ERROR_EVENT                                 EQU     9
LPC_CONNECTION_REQUEST                          EQU     10
LPC_CONNECTION_REFUSED                          EQU     11
LPC_MAXIMUM                                     EQU     12

;SECTION_INHERIT Enumeration
ViewShare                                       EQU     1
ViewUnmap                                       EQU     2

;SECTION_INFORMATION_CLASS Enumeration
SectionBasicInformation                         EQU     0
SectionImageInformation                         EQU     1

;OBJECT_INFORMATION_CLASS Enumeration
ObjectBasicInformation                          EQU     0
ObjectNameInformation                           EQU     1
ObjectTypeInformation                           EQU     2
ObjectAllTypesInformation                       EQU     3
ObjectHandleInformation                         EQU     4

;MEMORY_INFORMATION_CLASS Enumeration
MemoryBasicInformation                          EQU     0
MemoryWorkingSetList                            EQU     1
MemorySectionName                               EQU     2
MemoryBasicVlmInformation                       EQU     3

;THREADINFOCLASS Enumeration
ThreadBasicInformation                          EQU     0
ThreadTimes                                     EQU     1
ThreadPriority                                  EQU     2
ThreadBasePriority                              EQU     3
ThreadAffinityMask                              EQU     4
ThreadImpersonationToken                        EQU     5
ThreadDescriptorTableEntry                      EQU     6
ThreadEnableAlignmentFaultFixup                 EQU     7
ThreadEventPair                                 EQU     8
ThreadQuerySetWin32StartAddress                 EQU     9
ThreadZeroTlsCell                               EQU     10
ThreadPerformanceCount                          EQU     11
ThreadAmILastThread                             EQU     12
ThreadIdealProcessor                            EQU     13
ThreadPriorityBoost                             EQU     14
ThreadSetTlsArrayAddress                        EQU     15
ThreadIsIoPending                               EQU     16
ThreadHideFromDebugger                          EQU     17
MaxThreadInfoClass                              EQU     18

;FSINFOCLASS Enumeration
FileFsVolumeInformation                         EQU     1
FileFsLabelInformation                          EQU     2
FileFsSizeInformation                           EQU     3
FileFsDeviceInformation                         EQU     4
FileFsAttributeInformation                      EQU     5
FileFsControlInformation                        EQU     6
FileFsFullSizeInformation                       EQU     7
FileFsObjectIdInformation                       EQU     8
FileFsMaximumInformation                        EQU     9

;PLUGPLAY_BUS_CLASS Enumeration
SystemBus                                       EQU     0
PlugPlayVirtualBus                              EQU     1
MaxPlugPlayBusClass                             EQU     2

;PLUGPLAY_VIRTUAL_BUS_TYPE Enumeration
Root                                            EQU     0
MaxPlugPlayVirtualBusType                       EQU     1

;INTERFACE_TYPE Enumeration
InterfaceTypeUndefined                          EQU     (-1)
Internal                                        EQU     0
Isa                                             EQU     1
Eisa                                            EQU     2
MicroChannel                                    EQU     3
TurboChannel                                    EQU     4
PCIBus                                          EQU     5
VMEBus                                          EQU     6
NuBus                                           EQU     7
PCMCIABus                                       EQU     8
CBus                                            EQU     9
MPIBus                                          EQU     10
MPSABus                                         EQU     11
ProcessorInternal                               EQU     12
InternalPowerBus                                EQU     13
PNPISABus                                       EQU     14
PNPBus                                          EQU     15
MaximumInterfaceType                            EQU     16

;SYSTEM_DOCK_STATE Enumeration
SystemDockStateUnknown                          EQU     0
SystemUndocked                                  EQU     1
SystemDocked                                    EQU     2

MAX_SYSTEM_MODULE_NAME_LENGTH                   EQU     256

LPC_MAX_MESSAGE_SIZE                            EQU     148
LPC_MAX_DATA_SIZE                               EQU     104

SIZE_OF_80387_REGISTERS                         EQU     80
MAXIMUM_SUPPORTED_EXTENSION                     EQU     512

_CONTEXT_i386                                   EQU     010000H
_CONTEXT_AMD64                                  EQU     100000H
_CONTEXT_CONTROL                                EQU     1
_CONTEXT_INTEGER                                EQU     2

IMAGE_REL_BASED_MASK                            EQU     0FFFH
IMAGE_REL_BASED_SHIFT                           EQU     12

IMAGE_SIZEOF_BASE_RELOCATION                    EQU     8

UWOP_PUSH_NONVOL                                EQU     0
UWOP_ALLOC_LARGE                                EQU     1
UWOP_ALLOC_SMALL                                EQU     2
UWOP_SET_FPREG                                  EQU     3
UWOP_SAVE_NONVOL                                EQU     4
UWOP_SAVE_NONVOL_FAR                            EQU     5
UWOP_SAVE_XMM128                                EQU     6
UWOP_SAVE_XMM128_FAR                            EQU     7
UWOP_PUSH_MACHFRAME                             EQU     8

PDI_MODULES                                     EQU     01H
PDI_BACKTRACE                                   EQU     02H
PDI_HEAPS                                       EQU     04H
PDI_HEAP_TAGS                                   EQU     08H
PDI_HEAP_BLOCKS                                 EQU     10H
PDI_LOCKS                                       EQU     20H

UNW_FLAG_NHANDLER                               EQU     0H
UNW_FLAG_EHANDLER                               EQU     1H
UNW_FLAG_UHANDLER                               EQU     2H
UNW_FLAG_CHAININFO                              EQU     4H

MAX_BUS_NAME                                    EQU     24

KRNL_NORMAL_PRIORITY_CLASS                      EQU     02H
KRNL_IDLE_PRIORITY_CLASS                        EQU     01H
KRNL_HIGH_PRIORITY_CLASS                        EQU     03H
KRNL_REALTIME_PRIORITY_CLASS                    EQU     04H

;======================================== Structures ======================================;
IFNDEF STRING_DEFINED
    STRING_DEFINED EQU 1
    STRING STRUCT ALIGNMODE
        _Length         DW   ?
        MaximumLength   DW   ?
        Buffer          XPTR ?
    STRING ENDS
    ANSI_STRING                             TYPEDEF STRING
    OEM_STRING                              TYPEDEF STRING
    PSTRING                                 TYPEDEF XPTR
    POEM_STRING                             TYPEDEF PSTRING
ENDIF

IFNDEF UNICODE_STRING_DEFINED
    UNICODE_STRING_DEFINED EQU 1
    UNICODE_STRING STRUCT ALIGNMODE
        _Length         DW   ?
        MaximumLength   DW   ?
        Buffer          XPTR ?
    UNICODE_STRING      ENDS
ENDIF

IFNDEF UNICODE_STRING32_DEFINED
    UNICODE_STRING32_DEFINED EQU 1
    UNICODE_STRING32 STRUCT ALIGNMODE
        _Length         DW ?
        MaximumLength   DW ?
        Buffer          DD ?
    UNICODE_STRING32 ENDS
ENDIF

IFNDEF UNICODE_STRING64_DEFINED
    UNICODE_STRING64_DEFINED EQU 1
    UNICODE_STRING64 STRUCT ALIGNMODE
        _Length         DW ?
        MaximumLength   DW ?
        Reserved        DD ?
        Buffer          DQ ?
    UNICODE_STRING64 ENDS
ENDIF

OBJECT_ATTRIBUTES STRUCT ALIGNMODE
    _Length                  DD    ?
    RootDirectory            XWORD ?
    ObjectName               XPTR  ?
    Attributes               DD    ?
    SecurityDescriptor       XPTR  ?
    SecurityQualityOfService XPTR  ?
OBJECT_ATTRIBUTES ENDS

CLIENT_ID STRUCT ALIGNMODE
    UniqueProcess   XWORD ?
    UniqueThread    XWORD ?
CLIENT_ID EndS

PEB_FREE_BLOCK STRUCT ALIGNMODE
    Next    XPTR ?
    _Size   DD   ?
PEB_FREE_BLOCK ENDS

CURDIR STRUCT ALIGNMODE
   DosPath  UNICODE_STRING <>
   Handle   XWORD ?
CURDIR ENDS

RTL_DRIVE_LETTER_CURDIR STRUCT ALIGNMODE
    Flags       DD ?
    _Length     DW ?
    TimeStamp   DD ?
    DosPath     STRING <>
RTL_DRIVE_LETTER_CURDIR ENDS

PROCESS_PARAMETERS STRUCT ALIGNMODE
    MaximumLength       DD    ?
    _Length             DD    ?
    Flags               DD    ?
    DebugFlags          DD    ?
    ConsoleHandle       XWORD ?
    ConsoleFlags        DD ?
    StandardInput       XWORD ?
    StandardOutput      XWORD ?
    StandardError       XWORD ?
    CurrentDirectory    CURDIR <>
    DllPath             UNICODE_STRING <>
    ImagePathName       UNICODE_STRING <>
    CommandLine         UNICODE_STRING <>
    Environment         XPTR  ?
    StartingX           DD    ?
    StartingY           DD    ?
    CountX              DD    ?
    CountY              DD    ?
    CountCharsX         DD    ?
    CountCharsY         DD    ?
    FillAttribute       DD    ?
    WindowFlags         DD    ?
    ShowWindowFlags     DD    ?
    WindowTitle         UNICODE_STRING <>
    Desktop             UNICODE_STRING <>
    ShellInfo           UNICODE_STRING <>
    RuntimeInfo         UNICODE_STRING <>
    CurrentDirectores   RTL_DRIVE_LETTER_CURDIR 32 DUP(<>)
PROCESS_PARAMETERS ENDS

RTL_BITMAP STRUCT ALIGNMODE
    SizeOfBitMap    DD   ?
    Buffer          XPTR ?
RTL_BITMAP ENDS

LDR_DATA_TABLE_ENTRY64 STRUCT ALIGNMODE
    InLoadOrderModuleList           LIST_ENTRY64 <>
    InMemoryOrderModuleList         LIST_ENTRY64 <>
    InInitializationOrderModuleList LIST_ENTRY64 <>
    DllBase                         DQ ?
    EntryPoint                      DQ ?
    SizeOfImage                     DD ?
    FullDllName                     UNICODE_STRING64 <>
    BaseDllName                     UNICODE_STRING64 <>
    Flags                           DD ?
    LoadCount                       DW ?
    TlsIndex                        DW ?
    UNION
        HashLinks                   LIST_ENTRY64 <>
        STRUCT
            SectionPointer          DQ ?
            CheckSum                DD ?
        ENDS
    ENDS
    UNION
        TimeDateStamp               DD ?
        LoadedImports               DQ ?
    ENDS
    EntryPointActivationContext     DQ ?
    PatchInformation                DQ ?
LDR_DATA_TABLE_ENTRY64 ENDS

LDR_DATA_TABLE_ENTRY32 STRUCT ALIGNMODE
    InLoadOrderModuleList           LIST_ENTRY32 <>
    InMemoryOrderModuleList         LIST_ENTRY32 <>
    InInitializationOrderModuleList LIST_ENTRY32 <>
    DllBase                         DD ?
    EntryPoint                      DD ?
    SizeOfImage                     DD ?
    FullDllName                     UNICODE_STRING32 <>
    BaseDllName                     UNICODE_STRING32 <>
    Flags                           DD ?
    LoadCount                       DW ?
    TlsIndex                        DW ?
    UNION
        HashLinks                   LIST_ENTRY32 <>
        STRUCT
            SectionPointer          DD ?
            CheckSum                DD ?
        ENDS
        UNION
            TimeDateStamp               DD ?
            LoadedImports               DD ?
        EndS
    EndS
    EntryPointActivationContext     DD ?
    PatchInformation                DD ?
LDR_DATA_TABLE_ENTRY32 ENDS

LDR_DATA_TABLE_ENTRY STRUCT ALIGNMODE
     InLoadOrderLinks           LIST_ENTRY <>
     InMemoryOrderLinks         LIST_ENTRY <>
     InInitializationOrderLinks LIST_ENTRY <>
     DllBase                    XPTR ?
     EntryPoint                 XPTR ?
     SizeOfImage                DD   ?
     FullDllName                UNICODE_STRING <>
     BaseDllName                UNICODE_STRING <>
     Flags                      DD   ?
     LoadCount                  DW   ?
     TlsIndex                   DW   ?
     UNION
          HashLinks             LIST_ENTRY <>
          STRUCT
               SectionPointer   XPTR ?
               CheckSum         DD   ?
          ENDS
     ENDS
     UNION
          TimeDateStamp         DD   ?
          LoadedImports         XPTR ?
     ENDS
     _ACTIVATION_CONTEXT        XPTR ?
     PatchInformation           XPTR ?
     ForwarderLinks             LIST_ENTRY <>
     ServiceTagLinks            LIST_ENTRY <>
     StaticLinks                LIST_ENTRY <>
LDR_DATA_TABLE_ENTRY ENDS

PEB_LDR_DATA64 STRUCT ALIGNMODE
    _Length                         DD ?
    Initialized                     DB ?
    SsHandle                        DQ ?
    InLoadOrderModuleList           LIST_ENTRY64 <>
    InMemoryOrderModuleList         LIST_ENTRY64 <>
    InInitializationOrderModuleList LIST_ENTRY64 <>
PEB_LDR_DATA64 ENDS

PEB_LDR_DATA32 STRUCT ALIGNMODE
    _Length                         DD ?
    Initialized                     DB ?
    SsHandle                        DD ?
    InLoadOrderModuleList           LIST_ENTRY32 <>
    InMemoryOrderModuleList         LIST_ENTRY32 <>
    InInitializationOrderModuleList LIST_ENTRY32 <>
PEB_LDR_DATA32 ENDS

PEB_LDR_DATA STRUCT ALIGNMODE
    _Length                         DD   ?
    Initialized                     DB   ?
    SsHandle                        XPTR ?
    InLoadOrderModuleList           LIST_ENTRY <>
    InMemoryOrderModuleList         LIST_ENTRY <>
    InInitializationOrderModuleList LIST_ENTRY <>
PEB_LDR_DATA ENDS

SYSTEM_STRINGS STRUCT ALIGNMODE
    SystemRoot          UNICODE_STRING <>
    System32Root        UNICODE_STRING <>
    BaseNamedObjects    UNICODE_STRING <>
SYSTEM_STRINGS ENDS

TEXT_INFO STRUCT ALIGNMODE
    Reserved        XPTR ?
    SystemStrings   XPTR ?
TEXT_INFO ENDS

PEB64 STRUCT ALIGNMODE
    InheritedAddressSpace    DB ?
    ReadImageFileExecOptions DB ?
    BeingDebugged            DB ?
    b003                     DB ?
    Reserved0                DD ?
    Mutant                   DQ ?
    ImageBaseAddress         DQ ?
    Ldr                      DQ ?
    ProcessParameters        DQ ?
PEB64 ENDS

PEB32 STRUCT ALIGNMODE
    InheritedAddressSpace    DB ?
    ReadImageFileExecOptions DB ?
    BeingDebugged            DB ?
    b003                     DB ?
    Mutant                   DD ?
    ImageBaseAddress         DD ?
    Ldr                      DD ?
    ProcessParameters        DD ?
PEB32 ENDS

PEB STRUCT ALIGNMODE
    InheritedAddressSpace            DB ?
    ReadImageFileExecOptions         DB ?
    BeingDebugged                    DB ?
    b003                             DB ?
    Mutant                           XPTR ?
    ImageBaseAddress                 XPTR ?
    Ldr                              XPTR ?
    ProcessParameters                XPTR ?
    SubSystemData                    XPTR ?
    ProcessHeap                      XPTR ?
    FastPebLock                      XPTR ?
    FastPebLockRoutine               XPTR ?
    FastPebUnlockRoutine             XPTR ?
    EnvironmentUpdateCount           DD   ?
    KernelCallbackTable              XPTR ?
    EventLogSection                  XPTR ?
    EventLog                         XPTR ?
    FreeList                         XPTR ?
    TlsExpansionCounter              DD   ?
    TlsBitmap                        XPTR ?
    TlsBitmapData                    DD   ?
    ReadOnlySharedMemoryBase         XPTR ?
    ReadOnlySharedMemoryHeap         XPTR ?
    ReadOnlyStaticServerData         XPTR ?
    InitAnsiCodePageData             XPTR ?
    InitOemCodePageData              XPTR ?
    InitUnicodeCaseTableData         XPTR ?
    KeNumberProcessors               DD   ?
    NtGlobalFlag                     DD   ?
    d6C                              DD   ?
    MmCriticalSectionTimeout         LARGE_INTEGER <>
    MmHeapSegmentReserve             DD   ?
    MmHeapSegmentCommit              DD   ?
    MmHeapDeCommitTotalFreeThreshold DD   ?
    MmHeapDeCommitFreeBlockThreshold DD   ?
    NumberOfHeaps                    DD   ?
    AvailableHeaps                   DD   ?
    ProcessHeapsListBuffer           XPTR ?
    GdiSharedHandleTable             XPTR ?
    ProcessStarterHelper             XPTR ?
    GdiDCAttributeList               XPTR ?
    LoaderLock                       XPTR ?
    NtMajorVersion                   DD   ?
    NtMinorVersion                   DD   ?
    NtBuildNumber                    DW   ?
    NtCSDVersion                     DW   ?
    PlatformId                       DD   ?
    Subsystem                        DD   ?
    MajorSubsystemVersion            DD   ?
    MinorSubsystemVersion            DD   ?
    AffinityMask                     KAFFINITY ?
    GdiHandleBuffer                  DD   ?
    PostProcessInitRoutine           DD   ?
    TlsExpansionBitmap               DD   ?
    TlsExpansionBitmapBits           DW   ?
    SessionId                        DD   ?
    AppCompatFlags                   ULARGE_INTEGER <>
    CSDVersion                       XPTR ?
PEB ENDS

TEB STRUCT ALIGNMODE
    Tib                          NT_TIB <>
    EnvironmentPointer           XPTR ?
    Cid                          CLIENT_ID <>
    ActiveRpcInfo                XPTR ?
    ThreadLocalStoragePointer    XPTR ?
    Peb                          XPTR ?
    LastErrorValue               DD   ?
    CountOfOwnedCriticalSections DD   ?
    CsrClientThread              XPTR ?
    Win32ThreadInfo              XPTR ?
    Win32ClientInfo              DD   01FH DUP(?)
    WOW32Reserved                XPTR ?
    CurrentLocale                DD   ?
    FpSoftwareStatusRegister     DD   ?
    SystemReserved1              XPTR ?
    Spare1                       XPTR ?
    ExceptionCode                DD   ?
    SpareBytes1                  DD   28 DUP(?)
    SystemReserved2              XPTR ?
    gdiRgn                       DD   ?
    gdiPen                       DD   ?
    gdiBrush                     DD   ?
    RealClientId                 CLIENT_ID <>
    GdiCachedProcessHandle       XPTR ?
    GdiClientPID                 DD   ?
    GdiClientTID                 DD   ?
    GdiThreadLocaleInfo          XPTR ?
    UserReserved                 XPTR 5 DUP(?)
    glDispatchTable              XPTR 118 DUP(?)
    glReserved1                  DD   01AH DUP(?)
    glReserved2                  XPTR ?
    glSectionInfo                XPTR ?
    glSection                    XPTR ?
    glTable                      XPTR ?
    glCurrentRC                  XPTR ?
    glContext                    XPTR ?
    LastStatusValue              DD   ?
    StaticUnicodeString          UNICODE_STRING <>
    StaticUnicodeBuffer          DW 105 DUP(?)
    DeallocationStack            XPTR ?
    TlsSlots                     XPTR 40 DUP(?)
    TlsLinks                     LIST_ENTRY <>
    Vdm                          XPTR ?
    ReservedForNtRpc             XPTR ?
    DbgSsReserved                XPTR 2 DUP(?)
    HardErrorDisabled            DD   ?
    Instrumentation              XPTR 10 DUP(?)
    WinSockData                  XPTR ?
    GdiBatchCount                DD   ?
    _Spare2                      DD   ?
    _Spare3                      DD   ?
    _Spare4                      DD   ?
    ReservedForOle               XPTR ?
    WaitingOnLoaderLock          DD   ?
    StackCommit                  XPTR ?
    StackCommitMax               XPTR ?
    StackReserve                 XPTR ?
TEB ENDS

DISPATCHER_HEADER STRUCT ALIGNMODE
    uType           DB ?
    uAbsolute       DB ?
    uSize           DB ?
    uInserted       DB ?
    lSignalState    DD ?
    WaitListHead    LIST_ENTRY <>
DISPATCHER_HEADER ENDS

KPROCESS STRUCT ALIGNMODE
    Header          DISPATCHER_HEADER <>
    le10            LIST_ENTRY <>
    d18             DD ?
    d1C             DD ?
    d20             DD ?
    d24             DD ?
    d28             DD ?
    d2C             DD ?
    d30             DD ?
    d34             DD ?
    dKernelTime     DD ?
    dUserTime       DD ?
    le40            LIST_ENTRY <>
    OutSwapList     LIST_ENTRY <>
    ThreadListHead  LIST_ENTRY <>
    d58             DD ?
    AffinityMask    KAFFINITY ?
    w60             DW ?
    bBasePriority   DB ?
    b63             DB ?
    w64             DW ?
    b66             DB ?
    fPriorityBoost  DB ?
KPROCESS ENDS

PORT_MESSAGE STRUCT ALIGNMODE
    DataSize            DW ?
    MessageSize         DW ?
    MessageType         DW ?
    VirtualRangesOffset DW ?
    ClientId            CLIENT_ID <>
    MessageId           DD ?
    SectionSize         DD ?
    Data                DB 2 DUP(?)
PORT_MESSAGE ENDS

SERVICE_DESCRIPTOR_TABLE STRUCT ALIGNMODE
    ServiceTable    XPTR ?
    puCounterTable  XPTR ?
    uTableSize      DD   ?
    pbArgumentTable XPTR ?
SERVICE_DESCRIPTOR_TABLE ENDS

KSEMAPHORE STRUCT ALIGNMODE
    Header  DISPATCHER_HEADER <>
    lLimit  DD ?
KSEMAPHORE ENDS

KTHREAD STRUCT ALIGNMODE
    Header                      DISPATCHER_HEADER <>
    le010                       LIST_ENTRY <>
    d018                        DD   ?
    d01C                        DD   ?
    pTeb                        XPTR ?
    d024                        DD   ?
    d028                        DD   ?
    b02C                        DB   ?
    bThreadState                DB   ?
    w02E                        DW   ?
    w030                        DW   ?
    b032                        DB   ?
    bPriority                   DB   ?
    le034                       LIST_ENTRY <>
    le03C                       LIST_ENTRY <>
    pProcess                    XPTR ?
    d048                        DD   ?
    dContextSwitches            DD   ?
    d050                        DD   ?
    w054                        DW   ?
    b056                        DB   ?
    bWaitReason                 DB   ?
    d058                        DD   ?
    ple05C                      XPTR ?
    ple060                      XPTR ?
    d064                        DD   ?
    bBasePriority               DB   ?
    b069                        DB   ?
    w06A                        DW   ?
    d06C                        DD   ?
    d070                        DD   ?
    d074                        DD   ?
    d078                        DD   ?
    d07C                        DD   ?
    d080                        DD   ?
    d084                        DD   ?
    d088                        DD   ?
    d08C                        DD   ?
    d090                        DD   ?
    d094                        DD   ?
    d098                        DD   ?
    d09C                        DD   ?
    d0A0                        DD   ?
    d0A4                        DD   ?
    d0A8                        DD   ?
    d0AC                        DD   ?
    d0B0                        DD   ?
    d0B4                        DD   ?
    d0B8                        DD   ?
    d0BC                        DD   ?
    d0C0                        DD   ?
    d0C4                        DD   ?
    d0C8                        DD   ?
    d0CC                        DD   ?
    d0D0                        DD   ?
    d0D4                        DD   ?
    d0D8                        DD   ?
    pServiceDescriptorTable     XPTR ?
    d0E0                        DD   ?
    d0E4                        DD   ?
    d0E8                        DD   ?
    d0EC                        DD   ?
    le0F0                       LIST_ENTRY <>
    d0F8                        DD   ?
    d0FC                        DD   ?
    d100                        DD   ?
    d104                        DD   ?
    d108                        DD   ?
    d10C                        DD   ?
    d110                        DD   ?
    d114                        DD   ?
    d118                        DD   ?
    b11C                        DB   ?
    b11D                        DB   ?
    w11E                        DW   ?
    d120                        DD   ?
    d124                        DD   ?
    d128                        DD   ?
    d12C                        DD   ?
    d130                        DD   ?
    w134                        DW   ?
    b136                        DB   ?
    ProcessorMode               KPROCESSOR_MODE ?
    dKernelTime                 DD   ?
    dUserTime                   DD   ?
    d140                        DD   ?
    d144                        DD   ?
    d148                        DD   ?
    d14C                        DD   ?
    d150                        DD   ?
    d154                        DD   ?
    d158                        DD   ?
    d15C                        DD   ?
    d160                        DD   ?
    d164                        DD   ?
    d168                        DD   ?
    d16C                        DD   ?
    d170                        DD   ?
    SuspendNop                  XPTR ?
    d178                        DD   ?
    d17C                        DD   ?
    d180                        DD   ?
    d184                        DD   ?
    d188                        DD   ?
    d18C                        DD   ?
    SuspendSemaphore            KSEMAPHORE <>
    ThreadList                  LIST_ENTRY <>
    d1AC                        DD   ?
KTHREAD ENDS

ETHREAD STRUCT ALIGNMODE
    Tcb                         KTHREAD <>
    liCreateTime                LARGE_INTEGER <>
    liExitTime                  LARGE_INTEGER <>
    ExitStatus                  DD   ?
    PostBlockList               LIST_ENTRY <>
    TerminationPortList         LIST_ENTRY <>
    uActiveTimerListLock        DD   ?
    ActiveTimerListHead         LIST_ENTRY <>
    Cid                         CLIENT_ID <>
    LpcReplySemaphore           KSEMAPHORE <>
    uLpcReplyMessage            DD   ?
    liLpcReplyMessageId         LARGE_INTEGER <>
    uImpersonationInfo          DD   ?
    IrpList                     LIST_ENTRY <>
    TopLevelIrp                 LIST_ENTRY <>
    uReadClusterSize            DD   ?
    fForwardClusterOnly         DB   ?
    fDisablePageFaultClustering DB   ?
    fDeadThread                 DB   ?
    fHasTerminated              DB   ?
    uEventPair                  DD   ?
    uGrantedAccess              DD   ?
    uThreadsProcess             DD   ?
    pStartAddress               XPTR ?
    Win32StartAddress           XPTR ?
    fLpcExitThreadCalled        DB   ?
    fHardErrorsAreDisabled      DB   ?
    wUknown1                    DW   ?
    dwUknown2                   DD   ?
ETHREAD ENDS

KEVENT STRUCT ALIGNMODE
    Header  DISPATCHER_HEADER <>
KEVENT ENDS

ERESOURCE_OLD STRUCT ALIGNMODE
    SystemResourcesList         LIST_ENTRY <>
    OwnerThreads                XPTR ?
    pbOwnerCounts               XPTR ?
    wTableSize                  DW   ?
    wActiveCount                DW   ?
    wFlag                       DW   ?
    wTableRover                 DW   ?
    bInitialOwnerCounts         DB   4 DUP(?)
    InitialOwnerThreads         DD   4 Dup(?)
    dwUknown1                   DD   ?
    uContentionCount            DD   ?
    wNumberOfExclusiveWaiters   DW   ?
    wNumberOfSharedWaiters      DW   ?
    SharedWaiters               KSEMAPHORE <>
    ExclusiveWaiters            KEVENT <>
    SpinLock                    XPTR ?
    uCreatorBackTraceIndex      DD   ?
    wDepth                      DW   ?
    wUknown2                    DW   ?
    pOwnerBackTrace             XPTR 4 DUP(?)
ERESOURCE_OLD ENDS

OWNER_ENTRY STRUCT ALIGNMODE
    OwnerThread DD ?
    sOwnerCount DW ?
    wTableSize  DW ?
OWNER_ENTRY ENDS

ERESOURCE_LITE STRUCT ALIGNMODE
    SystemResourcesList         LIST_ENTRY <>
    OwnerTable                  XPTR ?
    sActiveCount                DW   ?
    wFlag                       DW   ?
    SharedWaiters               XPTR ?
    ExclusiveWaiters            XPTR ?
    OwnerThreads                OWNER_ENTRY 2 DUP(<>)
    uContentionCount            DD ?
    wNumberOfSharedWaiters      DW ?
    wNumberOfExclusiveWaiters   DW ?
    UNION
        pAddress                XPTR ?
        uCreatorBackTraceIndex  DD ?
    ENDS
    SpinLock                    XPTR ?
ERESOURCE_LITE ENDS

IO_STATUS_BLOCK STRUCT ALIGNMODE
  UNION
    Status    DD ?
    Pointer   XPTR ?
  ENDS
  Information XPTR ?
IO_STATUS_BLOCK ENDS

IFNDEF QUOTA_LIMITS_DEFINED
    QUOTA_LIMITS_DEFINED EQU 1
    QUOTA_LIMITS STRUCT ALIGNMODE
        PagedPoolLimit          XPTR ?
        NonPagedPoolLimit       XPTR ?
        MinimumWorkingSetSize   XPTR ?
        MaximumWorkingSetSize   XPTR ?
        PagefileLimit           XPTR ?
        TimeLimit               LARGE_INTEGER <>
    QUOTA_LIMITS ENDS
ENDIF

IOCOUNTERS STRUCT ALIGNMODE
    uReadOperationCount     DD ?
    uWriteOperationCount    DD ?
    uOtherOperationCount    DD ?
    liReadTransferCount     LARGE_INTEGER <>
    liWriteTransferCount    LARGE_INTEGER <>
    liOtherTransferCount    LARGE_INTEGER <>
IOCOUNTERS ENDS

VM_COUNTERS STRUCT ALIGNMODE
    uPeakVirtualSize            DD ?
    uVirtualSize                DD ?
    uPageFaultCount             DD ?
    uPeakWorkingSetSize         DD ?
    uWorkingSetSize             DD ?
    uQuotaPeakPagedPoolUsage    DD ?
    uQuotaPagedPoolUsage        DD ?
    uQuotaPeakNonPagedPoolUsage DD ?
    uQuotaNonPagedPoolUsage     DD ?
    uPagefileUsage              DD ?
    uPeakPagefileUsage          DD ?
VM_COUNTERS ENDS

KERNEL_USER_TIMES STRUCT ALIGNMODE
    liCreateTime    LARGE_INTEGER <>
    liExitTime      LARGE_INTEGER <>
    liKernelTime    LARGE_INTEGER <>
    liUserTime      LARGE_INTEGER <>
KERNEL_USER_TIMES ENDS

BASE_PRIORITY_INFORMATION STRUCT ALIGNMODE
    BasePriority KPRIORITY ?
BASE_PRIORITY_INFORMATION ENDS

AFFINITY_MASK STRUCT ALIGNMODE
    AffinityMask KAFFINITY ?
AFFINITY_MASK ENDS

TIME_FIELDS STRUCT ALIGNMODE
    wYear           DW ?
    wMonth          DW ?
    wDay            DW ?
    wHour           DW ?
    wMinute         DW ?
    wSecond         DW ?
    wMilliseconds   DW ?
    wWeekday        DW ?
TIME_FIELDS ENDS

NTFS_VOLUME_DATA_BUFFER STRUCT ALIGNMODE
    liSerialNumber          LARGE_INTEGER <>
    liNumberOfSectors       LARGE_INTEGER <>
    liTotalClusters         LARGE_INTEGER <>
    liFreeClusters          LARGE_INTEGER <>
    liReserved              LARGE_INTEGER <>
    uBytesPerSector         DD ?
    uBytesPerCluster        DD ?
    uBytesPerMFTRecord      DD ?
    uClustersPerMFTRecord   DD ?
    liMFTLength             LARGE_INTEGER <>
    liMFTStart              LARGE_INTEGER <>
    liMFTMirrorStart        LARGE_INTEGER <>
    liMFTZoneStart          LARGE_INTEGER <>
    liMFTZoneEnd            LARGE_INTEGER <>
NTFS_VOLUME_DATA_BUFFER ENDS

OBJDIR_INFORMATION STRUCT ALIGNMODE
    ObjectName      UNICODE_STRING <>
    ObjectTypeName  UNICODE_STRING <>
    Data            DB 2 DUP(?)
OBJDIR_INFORMATION ENDS

FILE_FS_VOLUME_INFORMATION STRUCT ALIGNMODE
    VolumeCreationTime  LARGE_INTEGER <>
    VolumeSerialNumber  DD ?
    VolumeLabelLength   DD ?
    SupportsObjects     DB ?
    VolumeLabel         DW 2 DUP(?)
FILE_FS_VOLUME_INFORMATION ENDS

FILE_FS_LABEL_INFORMATION STRUCT ALIGNMODE
    VolumeLabelLength   DD ?
    VolumeLabel         DW 2 DUP(?)
FILE_FS_LABEL_INFORMATION ENDS

FILE_FS_SIZE_INFORMATION STRUCT ALIGNMODE
    TotalAllocationUnits        LARGE_INTEGER <>
    AvailableAllocationUnits    LARGE_INTEGER <>
    SectorsPerAllocationUnit    DD ?
    BytesPerSector              DD ?
FILE_FS_SIZE_INFORMATION ENDS

FILE_FS_DEVICE_INFORMATION STRUCT ALIGNMODE
    DeviceType      DD ?
    Characteristics DD ?
FILE_FS_DEVICE_INFORMATION ENDS

FILE_FS_ATTRIBUTE_INFORMATION STRUCT ALIGNMODE
    FileSystemAttributes        DD ?
    MaximumComponentNameLength  DD ?
    FileSystemNameLength        DD ?
    FileSystemName              DW 2 DUP(?)
FILE_FS_ATTRIBUTE_INFORMATION ENDS

FILE_FS_CONTROL_INFORMATION STRUCT ALIGNMODE
    FreeSpaceStartFiltering LARGE_INTEGER <>
    FreeSpaceThreshold      LARGE_INTEGER <>
    FreeSpaceStopFiltering  LARGE_INTEGER <>
    DefaultQuotaThreshold   LARGE_INTEGER <>
    DefaultQuotaLimit       LARGE_INTEGER <>
    FileSystemControlFlags  DD ?
FILE_FS_CONTROL_INFORMATION ENDS

FILE_FS_FULL_SIZE_INFORMATION STRUCT ALIGNMODE
    TotalQuotaAllocationUnits       LARGE_INTEGER <>
    AvailableQuotaAllocationUnits   LARGE_INTEGER <>
    AvailableAllocationUnits        LARGE_INTEGER <>
    SectorsPerAllocationUnit        DD ?
    BytesPerSector                  DD ?
FILE_FS_FULL_SIZE_INFORMATION ENDS

FILE_FS_OBJECT_ID_INFORMATION STRUCT ALIGNMODE
    VolumeObjectId              GUID <>
    VolumeObjectIdExtendedInfo  DD 12 DUP(?)
FILE_FS_OBJECT_ID_INFORMATION ENDS

SYSTEM_BASIC_INFORMATION STRUCT ALIGNMODE
    dwUnknown1                  DD   ?
    uKeMaximumIncrement         DD   ?
    uPageSize                   DD   ?
    uMmNumberOfPhysicalPages    DD   ?
    uMmLowestPhysicalPage       DD   ?
    uMmHighestPhysicalPage      DD   ?
    uAllocationGranularity      DD   ?
    pLowestUserAddress          XPTR ?
    pMmHighestUserAddress       XPTR ?
    uKeActiveProcessors         KAFFINITY ?
    bKeNumberProcessors         DB   ?
    bUnknown2                   DB   ?
    wUnknown3                   DW   ?
SYSTEM_BASIC_INFORMATION ENDS

SYSTEM_PROCESSOR_INFORMATION STRUCT ALIGNMODE
    wKeProcessorArchitecture    DW   ?
    wKeProcessorLevel           DW   ?
    wKeProcessorRevision        DW   ?
    wUnknown1                   DW   ?
    uKeFeatureBits              DD   ?
SYSTEM_PROCESSOR_INFORMATION ENDS

MM_INFO_COUNTERS STRUCT ALIGNMODE
    uPageFaults             DD ?
    uWriteCopyFaults        DD ?
    uTransistionFaults      DD ?
    uCacheTransitionCount   DD ?
    uDemandZeroFaults       DD ?
    uPagesRead              DD ?
    uPageReadIos            DD ?
    uCacheReadCount         DD ?
    uCacheIoCount           DD ?
    uPagefilePagesWritten   DD ?
    uPagefilePageWriteIos   DD ?
    uMappedFilePagesWritten DD ?
    uMappedFilePageWriteIos DD ?
MM_INFO_COUNTERS ENDS

SYSTEM_PERFORMANCE_INFORMATION STRUCT ALIGNMODE
    liIdleTime                              LARGE_INTEGER <>
    liIoReadTransferCount                   LARGE_INTEGER <>
    liIoWriteTransferCount                  LARGE_INTEGER <>
    liIoOtherTransferCount                  LARGE_INTEGER <>
    uIoReadOperationCount                   DD ?
    uIoWriteOperationCount                  DD ?
    uIoOtherOperationCount                  DD ?
    uMmAvailablePages                       DD ?
    uMmTotalCommittedPages                  DD ?
    uMmTotalCommitLimit                     DD ?
    uMmPeakCommitLimit                      DD ?
    MmInfoCounters                          MM_INFO_COUNTERS <>
    uPoolPaged                              DD ?
    uPoolNonPaged                           DD ?
    uPagedPoolAllocs                        DD ?
    uPagedPoolFrees                         DD ?
    uNonPagedPoolAllocs                     DD ?
    uNonPagedPoolFrees                      DD ?
    uMmTotalFreeSystemPages                 DD ?
    uMmSystemCodePage                       DD ?
    uMmTotalSystemDriverPages               DD ?
    uMmTotalSystemCodePages                 DD ?
    uSmallNonPagedLookasideListAllocateHits DD ?
    uSmallPagedLookasideListAllocateHits    DD ?
    dwUnknown1                              DD ?
    uMmSystemCachePage                      DD ?
    uMmPagedPoolPage                        DD ?
    uMmSystemDriverPage                     DD ?
    uCcFastReadNoWait                       DD ?
    uCcFastReadWait                         DD ?
    uCcFastReadResourceMiss                 DD ?
    uCcFastReadNotPossible                  DD ?
    uCcFastMdlReadNoWait                    DD ?
    uCcFastMdlReadWait                      DD ?
    uCcFastMdlReadResourceMiss              DD ?
    uCcFastMdlReadNotPossible               DD ?
    uCcMapDataNoWait                        DD ?
    uCcMapDataWait                          DD ?
    uCcMapDataNoWaitMiss                    DD ?
    uCcMapDataWaitMiss                      DD ?
    uCcPinMappedDataCount                   DD ?
    uCcPinReadNoWait                        DD ?
    uCcPinReadWait                          DD ?
    uCcPinReadNoWaitMiss                    DD ?
    uCcPinReadWaitMiss                      DD ?
    uCcCopyReadNoWait                       DD ?
    uCcCopyReadWait                         DD ?
    uCcCopyReadNoWaitMiss                   DD ?
    uCcCopyReadWaitMiss                     DD ?
    uCcMdlReadNoWait                        DD ?
    uCcMdlReadWait                          DD ?
    uCcMdlReadNoWaitMiss                    DD ?
    uCcMdlReadWaitMiss                      DD ?
    uCcReadAheadIos                         DD ?
    uCcLazyWriteIos                         DD ?
    uCcLazyWritePages                       DD ?
    uCcDataFlushes                          DD ?
    uCcDataPages                            DD ?
    uTotalContextSwitches                   DD ?
    uFirstLevelTbFills                      DD ?
    uSecondLevelTbFills                     DD ?
    uSystemCalls                            DD ?
SYSTEM_PERFORMANCE_INFORMATION ENDS

SYSTEM_TIME_INFORMATION STRUCT ALIGNMODE
    liKeBootTime            LARGE_INTEGER <>
    liKeSystemTime          LARGE_INTEGER <>
    liExpTimeZoneBias       LARGE_INTEGER <>
    uExpCurrentTimeZoneId   DD ?
    dwUnknown1              DD ?
SYSTEM_TIME_INFORMATION ENDS

SYSTEM_THREAD STRUCT ALIGNMODE
    liKernelTime    XPTR ?
    liUserTime      XPTR ?
    liCreateTime    XPTR ?
    WaitTime        DD   ?
    pStartAddress   XPTR ?
    Cid             CLIENT_ID <>
    Priority        KPRIORITY ?
    BasePriority    KPRIORITY ?
    ContextSwitches DD   ?
    ThreadState     DD   ?
    WaitReason      DD   ?
    dwUnknown2      DD   ?
SYSTEM_THREAD ENDS

SYSTEM_PROCESS_INFORMATION STRUCT ALIGNMODE
    uNext                           DD ?
    uThreadCount                    DD ?
    liUnknown1                      LARGE_INTEGER <>
    liUnknown2                      LARGE_INTEGER <>
    liUnknown3                      LARGE_INTEGER <>
    liCreateTime                    LARGE_INTEGER <>
    liUserTime                      LARGE_INTEGER <>
    liKernelTime                    LARGE_INTEGER <>
    usName                          UNICODE_STRING <>
    BasePriority                    KPRIORITY ?
    uUniqueProcessId                DD ?
    uInheritedFromUniqueProcessId   DD ?
    uHandleCount                    DD ?
    uSessionId                      DD ?
    dwUnknown5                      DD ?
    VmCounters                      VM_COUNTERS <>
    uCommitCharge                   DD ?
    aST                             SYSTEM_THREAD 2 DUP(<>)
SYSTEM_PROCESS_INFORMATION ENDS

IO_COUNTERSEX STRUCT ALIGNMODE
    ReadOperationCount  LARGE_INTEGER <>
    WriteOperationCount LARGE_INTEGER <>
    OtherOperationCount LARGE_INTEGER <>
    ReadTransferCount   LARGE_INTEGER <>
    WriteTransferCount  LARGE_INTEGER <>
    OtherTransferCount  LARGE_INTEGER <>
IO_COUNTERSEX ENDS

SYSTEM_PROCESS_INFORMATION_2000 STRUCT ALIGNMODE
    uNext                           DD ?
    uThreadCount                    DD ?
    liUnknown1                      LARGE_INTEGER <>
    liUnknown2                      LARGE_INTEGER <>
    liUnknown3                      LARGE_INTEGER <>
    liCreateTime                    LARGE_INTEGER <>
    liUserTime                      LARGE_INTEGER <>
    liKernelTime                    LARGE_INTEGER <>
    usName                          UNICODE_STRING <>
    BasePriority                    KPRIORITY ?
    uUniqueProcessId                DD ?
    uInheritedFromUniqueProcessId   DD ?
    uHandleCount                    DD ?
    uSessionId                      DD ?
    dwUnknown5                      DD ?
    VmCounters                      VM_COUNTERS <>
    uCommitCharge                   DD ?
    IoCounters                      IO_COUNTERSEX <>
    aST                             SYSTEM_THREAD 2 DUP(<>)
SYSTEM_PROCESS_INFORMATION_2000 ENDS

SYSTEM_CONFIGURATION_INFORMATION STRUCT ALIGNMODE
    uDiskCount      DD ?
    uFloppyCount    DD ?
    uCDRomCount     DD ?
    uTapeCount      DD ?
    uSerialCount    DD ?
    uParallelCount  DD ?
SYSTEM_CONFIGURATION_INFORMATION ENDS

SYSTEM_PROCESSOR_COUNTERS STRUCT ALIGNMODE
    liProcessorTime     LARGE_INTEGER <>
    liKernelTime        LARGE_INTEGER <>
    liUserTime          LARGE_INTEGER <>
    liDpcTime           LARGE_INTEGER <>
    liInterruptTime     LARGE_INTEGER <>
    uInterruptCount     DD ?
    dwUnknown1          DD ?
SYSTEM_PROCESSOR_COUNTERS ENDS

SYSTEM_GLOBAL_FLAG STRUCT ALIGNMODE
    NtGlobalFlag    DD ?
SYSTEM_GLOBAL_FLAG ENDS

SYSTEM_CALL_TIME_INFORMATION STRUCT ALIGNMODE
    _Length         DD ?
    TotalCalls      DD ?
    TimeOfCalls     LARGE_INTEGER 2 DUP(<>)
SYSTEM_CALL_TIME_INFORMATION ENDS

SYSTEM_MODULE STRUCT ALIGNMODE
    Reserved            DD 2 DUP(?)
    Base                DD ?
    _Size               DD ?
    Flags               DD ?
    Index               DW ?
    _Unknown            DW ?
    LoadCount           DW ?
    ModuleNameOffset    DW ?
    ImageName           DB MAX_SYSTEM_MODULE_NAME_LENGTH DUP(?)
SYSTEM_MODULE ENDS

IFNDEF SYSTEM_MODULE_INFORMATION_DEFINED
    SYSTEM_MODULE_INFORMATION_DEFINED EQU 1
    SYSTEM_MODULE_INFORMATION STRUCT ALIGNMODE
        uCount           DD   ?
        aSM              SYSTEM_MODULE 2 DUP(<>)
        Reserved         DD   2 DUP(?)
        Base             XPTR ?
        _Size            DD   ?
        Flags            DD   ?
        Index            DW   ?
        _Unknown         DW   ?
        LoadCount        DW   ?
        ModuleNameOffset DW   ?
        ImageName        DB   256 DUP(?)
    SYSTEM_MODULE_INFORMATION ENDS
ENDIF

SYSTEM_MODULE64 STRUCT ALIGNMODE
    Reserved         DD 2 DUP(?)
    Base             DQ ?
    _Size            DD ?
    Flags            DD ?
    Index            DW ?
    _Unknown         DW ?
    LoadCount        DW ?
    ModuleNameOffset DW ?
    ImageName        DB MAX_SYSTEM_MODULE_NAME_LENGTH DUP(?)
SYSTEM_MODULE64 ENDS

SYSTEM_MODULE_INFORMATION64 STRUCT ALIGNMODE
    uCount  DD ?
    aSM     SYSTEM_MODULE64 2 DUP(<>)
SYSTEM_MODULE_INFORMATION64 ENDS

SYSTEM_LOCK STRUCT ALIGNMODE
    UNION
        pEResourceOld           XPTR ?
        pEResourceLite          XPTR ?
        pEResource              XPTR ?
    ENDS
    wUnknown1                   DW   ?
    wUnknown2                   DW   ?
    ExclusiveOwnerThreadId      DD   ?
    uActiveCount                DD   ?
    uContentionCount            DD   ?
    dwUnknown3                  DD   ?
    dwUnknown4                  DD   ?
    uNumberOfSharedWaiters      DD   ?
    uNumberOfExclusiveWaiters   DD   ?
SYSTEM_LOCK ENDS

SYSTEM_LOCK_INFORMATION STRUCT ALIGNMODE
    uCount  DD ?
    aSL     SYSTEM_LOCK 2 DUP(<>)
SYSTEM_LOCK_INFORMATION ENDS

SYSTEM_HANDLE STRUCT ALIGNMODE
    uIdProcess      DD   ?
    ObjectType      DB   ?
    Flags           DB   ?
    Handle          DW   ?
    pObject         XPTR ?
    GrantedAccess   ACCESS_MASK ?
SYSTEM_HANDLE ENDS

SYSTEM_HANDLE_INFORMATION STRUCT ALIGNMODE
    uCount  DD ?
    aSH     SYSTEM_HANDLE 2 DUP(<>)
SYSTEM_HANDLE_INFORMATION ENDS

SYSTEM_OBJECTTYPE_INFORMATION STRUCT ALIGNMODE
    NextEntryOffset     DD ?
    ObjectCount         DD ?
    HandleCount         DD ?
    TypeIndex           DD ?
    InvalidAttributes   DD ?
    GenericMapping      GENERIC_MAPPING <>
    ValidAccessMask     ACCESS_MASK ?
    PoolType            DD ?
    SecurityRequired    DB ?
    WaitableObject      DB ?
    TypeName            UNICODE_STRING <>
SYSTEM_OBJECTTYPE_INFORMATION ENDS

SYSTEM_OBJECT_INFORMATION STRUCT ALIGNMODE
    NextEntryOffset         DD   ?
    Object                  XPTR ?
    CreatorProcessId        DD   ?
    CreatorBackTraceIndex   DW ?
    Flags                   DW ?
    PointerCount            DD   ?
    HandleCount             DD   ?
    PagedPoolCharge         DD   ?
    NonPagedPoolCharge      DD   ?
    ExclusiveProcessId      DD   ?
    SecurityDescriptor      XPTR ?
    ObjectName              UNICODE_STRING <>
SYSTEM_OBJECT_INFORMATION ENDS

SYSTEM_PAGE_FILE_INFORMATION STRUCT ALIGNMODE
    NextEntryOffset DD ?
    CurrentSize     DD ?
    TotalUsed       DD ?
    PeakUsed        DD ?
    FileName        UNICODE_STRING <>
SYSTEM_PAGE_FILE_INFORMATION ENDS

SYSTEM_VDM_INSTEMUL_INFO STRUCT ALIGNMODE
    fExVdmSegmentNotPresent DD ?
    uOpcode0FV86            DD ?
    uOpcodeESPrefixV86      DD ?
    uOpcodeCSPrefixV86      DD ?
    uOpcodeSSPrefixV86      DD ?
    uOpcodeDSPrefixV86      DD ?
    uOpcodeFSPrefixV86      DD ?
    uOpcodeGSPrefixV86      DD ?
    uOpcodeOPER32PrefixV86  DD ?
    uOpcodeADDR32PrefixV86  DD ?
    uOpcodeINSBV86          DD ?
    uOpcodeINSWV86          DD ?
    uOpcodeOUTSBV86         DD ?
    uOpcodeOUTSWV86         DD ?
    uOpcodePUSHFV86         DD ?
    uOpcodePOPFV86          DD ?
    uOpcodeINTnnV86         DD ?
    uOpcodeINTOV86          DD ?
    uOpcodeIRETV86          DD ?
    uOpcodeINBimmV86        DD ?
    uOpcodeINWimmV86        DD ?
    uOpcodeOUTBimmV86       DD ?
    uOpcodeOUTWimmV86       DD ?
    uOpcodeINBV86           DD ?
    uOpcodeINWV86           DD ?
    uOpcodeOUTBV86          DD ?
    uOpcodeOUTWV86          DD ?
    uOpcodeLOCKPrefixV86    DD ?
    uOpcodeREPNEPrefixV86   DD ?
    uOpcodeREPPrefixV86     DD ?
    uOpcodeHLTV86           DD ?
    uOpcodeCLIV86           DD ?
    uOpcodeSTIV86           DD ?
    uVdmBopCount            DD ?
SYSTEM_VDM_INSTEMUL_INFO ENDS

SYSTEM_CACHE_INFORMATION STRUCT ALIGNMODE
    uFileCache                  DD ?
    uFileCachePeak              DD ?
    PageFaultCount              DD ?
    MinimumWorkingSet           DD ?
    MaximumWorkingSet           DD ?
    TransitionSharedPages       DD ?
    TransitionSharedPagesPeak   DD ?
    Reserved                    DD 2 DUP(?)
SYSTEM_CACHE_INFORMATION ENDS

SYSTEM_POOL_ENTRY STRUCT ALIGNMODE
    Allocated               DB   ?
    Spare0                  DB   ?
    AllocatorBackTraceIndex DW   ?
    _Size                   DD   ?
    UNION
        Tag                 DB   4 DUP(?)
        TagUlong            DD   ?
        ProcessChargedQuota XPTR ?
    ENDS
SYSTEM_POOL_ENTRY ENDS

SYSTEM_POOL_INFORMATION STRUCT ALIGNMODE
    TotalSize       DD   ?
    FirstEntry      XPTR ?
    EntryOverhead   DW   ?
    PoolTagPresent  DB   ?
    Spare0          DB   ?
    NumberOfEntries DD   ?
    Entries         SYSTEM_POOL_ENTRY 2 DUP(<>)
SYSTEM_POOL_INFORMATION ENDS

SYSTEM_POOL_TAG STRUCT ALIGNMODE
    UNION
        Tag             DB 4 DUP(?)
        TagUlong        DD ?
    ENDS
    PagedPoolAllocs     DD ?
    PagedPoolFrees      DD ?
    PagedPoolUsage      DD ?
    NonPagedPoolAllocs  DD ?
    NonPagedPoolFrees   DD ?
    NonPagedPoolUsage   DD ?
SYSTEM_POOL_TAG ENDS

SYSTEM_POOL_TAG_INFORMATION STRUCT ALIGNMODE
    uCount  DD ?
    aSPT    SYSTEM_POOL_TAG 2 DUP(<>)
SYSTEM_POOL_TAG_INFORMATION ENDS

SYSTEM_INTERRUPT_INFORMATION STRUCT ALIGNMODE
    ContextSwitches DD ?
    DpcCount        DD ?
    DpcRate         DD ?
    TimeIncrement   DD ?
    DpcBypassCount  DD ?
    ApcBypassCount  DD ?
SYSTEM_INTERRUPT_INFORMATION ENDS

SYSTEM_DPC_INFORMATION STRUCT ALIGNMODE
    dwUnknown1           DD ?
    MaximumDpcQueueDepth DD ?
    MinimumDpcRate       DD ?
    AdjustDpcThreshold   DD ?
    IdealDpcRate         DD ?
SYSTEM_DPC_INFORMATION ENDS

SYSTEM_MEMORY_INFO STRUCT ALIGNMODE
    StringOffset    XPTR ?
    ValidCount      DW ?
    TransitionCount DW ?
    ModifiedCount   DW ?
    PageTableCount  DW ?
SYSTEM_MEMORY_INFO ENDS

SYSTEM_MEMORY_INFORMATION STRUCT ALIGNMODE
    InfoSize    DD ?
    StringStart DD ?
    Memory      SYSTEM_MEMORY_INFO 2 DUP(<>)
SYSTEM_MEMORY_INFORMATION ENDS

SYSTEM_LOAD_DRIVER STRUCT ALIGNMODE
    DriverName      UNICODE_STRING <>
    BaseAddress     XPTR ?
    SectionPointer  XPTR ?
    EntryPoint      XPTR ?
    ExportDirectory XPTR ?
SYSTEM_LOAD_DRIVER ENDS

SYSTEM_UNLOAD_DRIVER STRUCT ALIGNMODE
    SectionPointer XPTR ?
SYSTEM_UNLOAD_DRIVER ENDS

SYSTEM_QUERY_TIME_ADJUSTMENT STRUCT ALIGNMODE
    TimeAdjustment      DD ?
    MaximumIncrement    DD ?
    TimeSynchronization DB ?
SYSTEM_QUERY_TIME_ADJUSTMENT ENDS

SYSTEM_SET_TIME_ADJUSTMENT STRUCT ALIGNMODE
    TimeAdjustment      DD ?
    TimeSynchronization DB ?
SYSTEM_SET_TIME_ADJUSTMENT ENDS

SYSTEM_CRASH_DUMP_INFORMATION STRUCT ALIGNMODE
    CrashDumpSectionHandle  XWORD ?
SYSTEM_CRASH_DUMP_INFORMATION ENDS

SYSTEM_CRASH_DUMP_INFORMATION_2000 STRUCT ALIGNMODE
    CrashDumpSectionHandle  XWORD ?
    _Unknown                XWORD ?
SYSTEM_CRASH_DUMP_INFORMATION_2000 ENDS

SYSTEM_EXCEPTION_INFORMATION STRUCT ALIGNMODE
    AlignmentFixupCount     DD ?
    ExceptionDispatchCount  DD ?
    FloatingEmulationCount  DD ?
    ByteWordEmulationCount  DD ?
SYSTEM_EXCEPTION_INFORMATION ENDS

SYSTEM_CRASH_DUMP_STATE_INFORMATION STRUCT ALIGNMODE
    ValidCrashDump  DD ?
SYSTEM_CRASH_DUMP_STATE_INFORMATION ENDS

SYSTEM_CRASH_DUMP_STATE_INFORMATION_2000 STRUCT ALIGNMODE
    ValidCrashDump  DD ?
    _Unknown        DD ?
SYSTEM_CRASH_DUMP_STATE_INFORMATION_2000 ENDS

SYSTEM_DEBUGGER_INFORMATION STRUCT ALIGNMODE
    KernelDebuggerEnabled       DB ?
    KernelDebuggerNotPresent    DB ?
SYSTEM_DEBUGGER_INFORMATION ENDS

SYSTEM_CONTEXT_SWITCH_INFORMATION STRUCT ALIGNMODE
    ContextSwitches DD ?
    FindAny         DD ?
    FindLast        DD ?
    FindIdeal       DD ?
    IdleAny         DD ?
    IdleCurrent     DD ?
    IdleLast        DD ?
    IdleIdeal       DD ?
    PreemptAny      DD ?
    PreemptCurrent  DD ?
    PreemptLast     DD ?
    SwitchToIdle    DD ?
SYSTEM_CONTEXT_SWITCH_INFORMATION ENDS

SYSTEM_REGISTRY_QUOTA_INFORMATION STRUCT ALIGNMODE
    RegistryQuotaAllowed    DD ?
    RegistryQuotaUsed       DD ?
    PagedPoolSize           DD ?
SYSTEM_REGISTRY_QUOTA_INFORMATION ENDS

SYSTEM_ADD_DRIVER STRUCT ALIGNMODE
    ModuleName UNICODE_STRING <>
SYSTEM_ADD_DRIVER ENDS

SYSTEM_PRIORITY_SEPARATION_INFORMATION STRUCT ALIGNMODE
    PrioritySeparation  DD ?
SYSTEM_PRIORITY_SEPARATION_INFORMATION ENDS

PLUGPLAY_BUS_TYPE STRUCT ALIGNMODE
    BusClass                    DD ?
    UNION
        SystemBusType           DD ?
        PlugPlayVirtualBusType  DD ?
    ENDS
PLUGPLAY_BUS_TYPE ENDS

PLUGPLAY_BUS_INSTANCE STRUCT ALIGNMODE
    BusType     PLUGPLAY_BUS_TYPE <>
    BusNumber   DD ?
    BusName     DW MAX_BUS_NAME DUP(?)
PLUGPLAY_BUS_INSTANCE ENDS

SYSTEM_PLUGPLAY_BUS_INFORMATION STRUCT ALIGNMODE
    BusCount    DD ?
    BusInstance PLUGPLAY_BUS_INSTANCE 2 DUP(<>)
SYSTEM_PLUGPLAY_BUS_INFORMATION ENDS

SYSTEM_DOCK_INFORMATION STRUCT ALIGNMODE
    DockState       DD ?
    DeviceBusType   DD ?
    DeviceBusNumber DD ?
    SlotNumber      DD ?
SYSTEM_DOCK_INFORMATION ENDS

SYSTEM_POWER_INFORMATION STRUCT ALIGNMODE
    SystemSuspendSupported          DB ?
    SystemHibernateSupported        DB ?
    ResumeTimerSupportsSuspend      DB ?
    ResumeTimerSupportsHibernate    DB ?
    LidSupported                    DB ?
    TurboSettingSupported           DB ?
    TurboMode                       DB ?
    SystemAcOrDc                    DB ?
    PowerDownDisabled               DB ?
    SpindownDrives                  LARGE_INTEGER <>
SYSTEM_POWER_INFORMATION ENDS

SYSTEM_PROCESSOR_SPEED_INFORMATION STRUCT ALIGNMODE
    MaximumProcessorSpeed   DD ?
    CurrentAvailableSpeed   DD ?
    ConfiguredSpeedLimit    DD ?
    PowerLimit              DB ?
    ThermalLimit            DB ?
    TurboLimit              DB ?
SYSTEM_PROCESSOR_SPEED_INFORMATION ENDS

SYSTEM_TIME_ZONE_INFORMATION STRUCT ALIGNMODE
    Bias            DD ?
    StandardName    DW 32 DUP(?)
    StandardDate    TIME_FIELDS <>
    StandardBias    DD ?
    DaylightName    DW 32 DUP(?)
    DaylightDate    TIME_FIELDS <>
    DaylightBias    DD ?
SYSTEM_TIME_ZONE_INFORMATION ENDS

SYSTEM_LOOKASIDE STRUCT ALIGNMODE
    Depth           DW ?
    MaximumDepth    DW ?
    TotalAllocates  DD ?
    AllocateMisses  DD ?
    TotalFrees      DD ?
    FreeMisses      DD ?
    _Type           DD ?
    Tag             DD ?
    _Size           DD ?
SYSTEM_LOOKASIDE ENDS

SYSTEM_LOOKASIDE_INFORMATION STRUCT ALIGNMODE
    asl SYSTEM_LOOKASIDE <>
SYSTEM_LOOKASIDE_INFORMATION ENDS

SYSTEM_SET_TIME_SLIP_EVENT STRUCT ALIGNMODE
    TimeSlipEvent   XWORD ?
SYSTEM_SET_TIME_SLIP_EVENT ENDS

SYSTEM_CREATE_SESSION STRUCT ALIGNMODE
    Session DD ?
SYSTEM_CREATE_SESSION ENDS

SYSTEM_DELETE_SESSION STRUCT ALIGNMODE
    Session DD ?
SYSTEM_DELETE_SESSION ENDS

SYSTEM_RANGE_START_INFORMATION STRUCT ALIGNMODE
    SystemRangeStart XPTR ?
SYSTEM_RANGE_START_INFORMATION ENDS

FILE_DIRECTORY_INFORMATION STRUCT ALIGNMODE
    NextEntryOffset DD ?
    FileIndex       DD ?
    CreationTime    LARGE_INTEGER <>
    LastAccessTime  LARGE_INTEGER <>
    LastWriteTime   LARGE_INTEGER <>
    ChangeTime      LARGE_INTEGER <>
    EndOfFile       LARGE_INTEGER <>
    AllocationSize  LARGE_INTEGER <>
    FileAttributes  DD ?
    FileNameLength  DD ?
    FileName        DW 2 DUP(?)
FILE_DIRECTORY_INFORMATION ENDS

FILE_FULL_DIR_INFORMATION STRUCT ALIGNMODE
    NextEntryOffset DD ?
    FileIndex       DD ?
    CreationTime    LARGE_INTEGER <>
    LastAccessTime  LARGE_INTEGER <>
    LastWriteTime   LARGE_INTEGER <>
    ChangeTime      LARGE_INTEGER <>
    EndOfFile       LARGE_INTEGER <>
    AllocationSize  LARGE_INTEGER <>
    FileAttributes  DD ?
    FileNameLength  DD ?
    EaSize          DD ?
    FileName        DW 2 DUP(?)
FILE_FULL_DIR_INFORMATION ENDS

FILE_BOTH_DIR_INFORMATION STRUCT ALIGNMODE
    NextEntryOffset DD ?
    FileIndex       DD ?
    CreationTime    LARGE_INTEGER <>
    LastAccessTime  LARGE_INTEGER <>
    LastWriteTime   LARGE_INTEGER <>
    ChangeTime      LARGE_INTEGER <>
    EndOfFile       LARGE_INTEGER <>
    AllocationSize  LARGE_INTEGER <>
    FileAttributes  DD ?
    FileNameLength  DD ?
    EaSize          DD ?
    ShortNameLength DB ?
    ShortName       DW 12 DUP(?)
    FileName        DW 2 DUP(?)
FILE_BOTH_DIR_INFORMATION ENDS

FILE_BASIC_INFORMATION STRUCT ALIGNMODE
    CreationTime    LARGE_INTEGER <>
    LastAccessTime  LARGE_INTEGER <>
    LastWriteTime   LARGE_INTEGER <>
    ChangeTime      LARGE_INTEGER <>
    FileAttributes  DD ?
FILE_BASIC_INFORMATION ENDS

FILE_STANDARD_INFORMATION STRUCT ALIGNMODE
    AllocationSize  LARGE_INTEGER <>
    EndOfFile       LARGE_INTEGER <>
    NumberOfLinks   DD ?
    DeletePending   DB ?
    Directory       DB ?
FILE_STANDARD_INFORMATION ENDS
                                                            
FILE_INTERNAL_INFORMATION STRUCT ALIGNMODE
    IndexNumber LARGE_INTEGER <>
FILE_INTERNAL_INFORMATION ENDS

FILE_EA_INFORMATION STRUCT ALIGNMODE
    EaSize DD ?
FILE_EA_INFORMATION ENDS

FILE_ACCESS_INFORMATION STRUCT ALIGNMODE
    AccessFlags ACCESS_MASK ?
FILE_ACCESS_INFORMATION ENDS

FILE_NAME_INFORMATION STRUCT ALIGNMODE
    FileNameLength  DD ?
    FileName        DW 2 DUP(?)
FILE_NAME_INFORMATION ENDS

FILE_RENAME_INFORMATION STRUCT ALIGNMODE
    ReplaceIfExists DB ?
    RootDirectory   XWORD ?
    FileNameLength  DD ?
    FileName        DW 2 DUP(?)
FILE_RENAME_INFORMATION ENDS

FILE_LINK_INFORMATION STRUCT ALIGNMODE
    ReplaceIfExists DB ?
    RootDirectory   XWORD ?
    FileNameLength  DD ?
    FileName        DW 2 DUP(?)
FILE_LINK_INFORMATION ENDS

FILE_NAMES_INFORMATION STRUCT ALIGNMODE
    NextEntryOffset DD ?
    FileIndex       DD ?
    FileNameLength  DD ?
    FileName        DW 2 DUP(?)
FILE_NAMES_INFORMATION ENDS

FILE_ALLOCATION_INFORMATION STRUCT ALIGNMODE
    AllocationSize LARGE_INTEGER <>
FILE_ALLOCATION_INFORMATION ENDS

FILE_COMPRESSION_INFORMATION STRUCT ALIGNMODE
    CompressedFileSize   LARGE_INTEGER <>
    CompressionFormat    DW ?
    CompressionUnitShift DB ?
    ChunkShift           DB ?
    ClusterShift         DB ?
    Reserved             DB 3 DUP(?)
FILE_COMPRESSION_INFORMATION ENDS

FILE_COMPLETION_INFORMATION STRUCT ALIGNMODE
    Port    XWORD ?
    Key     DD    ?
FILE_COMPLETION_INFORMATION ENDS

KEY_VALUE_BASIC_INFORMATION STRUCT ALIGNMODE
    TitleIndex  DD ?
    _Type       DD ?
    NameLength  DD ?
    _Name       DW 2 DUP(?)
KEY_VALUE_BASIC_INFORMATION ENDS

KEY_VALUE_FULL_INFORMATION STRUCT ALIGNMODE
    TitleIndex  DD ?
    _Type       DD ?
    DataOffset  DD ?
    DataLength  DD ?
    NameLength  DD ?
    _Name       DW 2 DUP(?)
KEY_VALUE_FULL_INFORMATION ENDS

KEY_VALUE_PARTIAL_INFORMATION STRUCT ALIGNMODE
    TitleIndex  DD ?
    _Type       DD ?
    DataLength  DD ?
    Data        DB 2 DUP(?)
KEY_VALUE_PARTIAL_INFORMATION ENDS

KEY_NODE_INFORMATION STRUCT ALIGNMODE
    LastWriteTime   LARGE_INTEGER <>
    TitleIndex      DD ?
    ClassOffset     DD ?
    ClassLength     DD ?
    NameLength      DD ?
    _Name           DW 2 DUP(?)
KEY_NODE_INFORMATION ENDS

KEY_NAME_INFORMATION STRUCT ALIGNMODE
    NameLength  DD ?
    _Name       DW 2 DUP(?)
KEY_NAME_INFORMATION ENDS

PROCESS_BASIC_INFORMATION32 STRUCT ALIGNMODE
    ExitStatus                      DD ?
    PebBaseAddress                  DD ?
    AffinityMask                    DD ?
    BasePriority                    KPRIORITY ?
    uUniqueProcessId                DD ?
    uInheritedFromUniqueProcessId   DD ?
PROCESS_BASIC_INFORMATION32 ENDS

PROCESS_BASIC_INFORMATION64 STRUCT ALIGNMODE
    ExitStatus                      DD ?
    Reserved0                       DD ?
    PebBaseAddress                  DQ ?
    AffinityMask                    DQ ?
    BasePriority                    KPRIORITY ?
    Reserved1                       DD ?
    uUniqueProcessId                DQ ?
    uInheritedFromUniqueProcessId   DQ ?
PROCESS_BASIC_INFORMATION64 ENDS

PROCESS_BASIC_INFORMATION STRUCT ALIGNMODE
    ExitStatus                      DD ?
    PebBaseAddress                  XPTR ?
    AffinityMask                    KAFFINITY ?
    BasePriority                    KPRIORITY ?
    uUniqueProcessId                XPTR ?
    uInheritedFromUniqueProcessId   DD ?
PROCESS_BASIC_INFORMATION ENDS

PROCESS_RAISE_PRIORITY STRUCT ALIGNMODE
    RaisePriority KPRIORITY ?
PROCESS_RAISE_PRIORITY ENDS

PROCESS_DEBUG_PORT_INFORMATION STRUCT ALIGNMODE
    DebugPort XWORD ?
PROCESS_DEBUG_PORT_INFORMATION ENDS

PROCESS_EXCEPTION_PORT STRUCT ALIGNMODE
    ExceptionPort XWORD ?
PROCESS_EXCEPTION_PORT ENDS

PROCESS_ACCESS_TOKEN STRUCT ALIGNMODE
    Token   XWORD ?
    Thread  XWORD ?
PROCESS_ACCESS_TOKEN ENDS

PROCESS_WOW64_INFORMATION STRUCT ALIGNMODE
    Wow64PebBaseAddress XPTR ?
PROCESS_WOW64_INFORMATION ENDS

IFNDEF LDT_ENTRY_DEFINED
    LDT_ENTRY_DEFINED   EQU 1
    LDTBits RECORD  NTBaseHi:8,NTGranularity:1,NTDefault_Big:1,NTReserved_0:1,NTSys:1,NTLimitHi:4,NTPres:1,NTDpl:2,NTType:5,NTBaseMid:8

    LDT_ENTRY STRUCT ALIGNMODE
        LimitLow DW ?
        BaseLow  DW ?
        UNION
            STRUCT
                BaseMid DB ?
                Flags1  DB ?
                Flags2  DB ?
                BaseHi  DB ?
            ENDS
            STRUCT
                LDTBits <>
            ENDS
        ENDS
    LDT_ENTRY ENDS
    LDT_TABLE_SIZE Equ (8 * 1024 * SIDEOF LDT_ENTRY)
ENDIF

PROCESS_LDT_INFORMATION Struct ALIGNMODE
    Start       DD ?
    _Length     DD ?
    LdtEntries  LDT_ENTRY 2 DUP(<>)
PROCESS_LDT_INFORMATION EndS

PROCESS_LDT_SIZE Struct ALIGNMODE
    _Length DD ?
PROCESS_LDT_SIZE ENDS

PROCESS_DEFAULT_HARDERROR_MODE_INFORMATION STRUCT ALIGNMODE
    HardErrorMode DD ?
PROCESS_DEFAULT_HARDERROR_MODE_INFORMATION ENDS

PROCESS_POOLED_USAGE_AND_LIMITS_INFORMATION STRUCT ALIGNMODE
    PeakPagedPoolUsage      DD ?
    PagedPoolUsage          DD ?
    PagedPoolLimit          DD ?
    PeakNonPagedPoolUsage   DD ?
    NonPagedPoolUsage       DD ?
    NonPagedPoolLimit       DD ?
    PeakPagefileUsage       DD ?
    PagefileUsage           DD ?
    PagefileLimit           DD ?
PROCESS_POOLED_USAGE_AND_LIMITS_INFORMATION ENDS

PROCESS_WS_WATCH_INFORMATION STRUCT ALIGNMODE
    FaultingPc  XPTR ?
    FaultingVa  XPTR ?
PROCESS_WS_WATCH_INFORMATION ENDS

PROCESS_IOPL STRUCT ALIGNMODE
    Iopl DD ?
PROCESS_IOPL ENDS

PROCESS_ALLIGNMENT_FAULT_FIXUP STRUCT ALIGNMODE
    EnableAllignmentFaultFixup DB ?
PROCESS_ALLIGNMENT_FAULT_FIXUP ENDS

PROCESS_PRIORITY_CLASS_INFORMATION STRUCT ALIGNMODE
    _Unknown        DB ?
    PriorityClass   DB ?
PROCESS_PRIORITY_CLASS_INFORMATION ENDS

PROCESS_X86_INFORMATION STRUCT ALIGNMODE
    x86Info DD ?
PROCESS_X86_INFORMATION ENDS

PROCESS_HANDLE_COUNT_INFORMATION STRUCT ALIGNMODE
    HandleCount DD ?
PROCESS_HANDLE_COUNT_INFORMATION ENDS

PROCESS_PRIORITY_BOOST_INFORMATION STRUCT ALIGNMODE
    PriorityBoostEnabled DD ?
PROCESS_PRIORITY_BOOST_INFORMATION ENDS

PROCESS_DEVICE_MAP_INFORMATION STRUCT ALIGNMODE
    UNION
        STRUCT
            DirectoryHandle XWORD ?
        ENDS
        STRUCT
            DriveMap        DD    ?
            DriveType       DB    32 DUP(?)
        ENDS
    ENDS
PROCESS_DEVICE_MAP_INFORMATION ENDS

PROCESS_SESSION_INFORMATION STRUCT ALIGNMODE
    SessionId DD ?
PROCESS_SESSION_INFORMATION ENDS

USER_STACK STRUCT ALIGNMODE
    FixedStackBase          XPTR ?
    FixedStackLimit         XPTR ?
    ExpandableStackBase     XPTR ?
    ExpandableStackLimit    XPTR ?
    ExpandableStackBottom   XPTR ?
USER_STACK ENDS

THREAD_BASIC_INFORMATION STRUCT ALIGNMODE
    ExitStatus      DD   ?
    TebBaseAddress  XPTR ?
    ClientId        CLIENT_ID <>
    AffinityMask    KAFFINITY ?
    Priority        KPRIORITY ?
    BasePriority    KPRIORITY ?
THREAD_BASIC_INFORMATION ENDS

THREAD_PRIORITY STRUCT ALIGNMODE
    Priority KPRIORITY ?
THREAD_PRIORITY ENDS

THREAD_DESCRIPTOR_TABLE_ENTRY_INFORMATION STRUCT ALIGNMODE
    Selector    DD ?
    Descriptor  LDT_ENTRY <>
THREAD_DESCRIPTOR_TABLE_ENTRY_INFORMATION ENDS

THREAD_EVENTPAIR STRUCT ALIGNMODE
    EventPair XWORD ?
THREAD_EVENTPAIR ENDS

THREAD_WIN32_START_ADDRESS_INFORMATION STRUCT ALIGNMODE
    Win32StartAddress XPTR ?
THREAD_WIN32_START_ADDRESS_INFORMATION ENDS

THREAD_ZERO_TLSCELL STRUCT ALIGNMODE
    TlsIndex DD ?
THREAD_ZERO_TLSCELL ENDS

THREAD_PERFORMANCE_COUNTER_INFORMATION STRUCT ALIGNMODE
    Count1 DD ?
    Count2 DD ?
THREAD_PERFORMANCE_COUNTER_INFORMATION ENDS

THREAD_AMI_LAST_THREAD STRUCT ALIGNMODE
    AmILastThread DD ?
THREAD_AMI_LAST_THREAD ENDS

THREAD_IDEAL_PROCESSOR STRUCT ALIGNMODE
    IdealProcessor DD ?
THREAD_IDEAL_PROCESSOR ENDS

THREAD_TLS_ARRAY STRUCT ALIGNMODE
    TlsArray    XWORD ?
THREAD_TLS_ARRAY ENDS

THREAD_IS_IO_PENDING_INFORMATION STRUCT ALIGNMODE
    IsIOPending DD ?
THREAD_IS_IO_PENDING_INFORMATION ENDS

THREAD_HIDE_FROM_DEBUGGER STRUCT ALIGNMODE
    HideFromDebugger DD ?
THREAD_HIDE_FROM_DEBUGGER ENDS

SECTION_BASIC_INFORMATION STRUCT ALIGNMODE
    BaseAddress XPTR ?
    Attributes  DD   ?
    _Size       LARGE_INTEGER <>
SECTION_BASIC_INFORMATION ENDS

SECTION_IMAGE_INFORMATION STRUCT ALIGNMODE
    EntryPoint              XPTR ?
    Unknown1                DD ?
    StackReserve            DD ?
    StackCommit             DD ?
    Subsystem               DD ?
    MinorSubsystemVersion   DW ?
    MajorSubsystemVersion   DW ?
    Unknown2                DD ?
    Characteristics         DD ?
    ImageNumber             DW ?
    Executable              DB ?
    Unknown3                DB ?
    Unknown4                DD 3 DUP(?)
SECTION_IMAGE_INFORMATION ENDS

OBJECT_BASIC_INFORMATION STRUCT ALIGNMODE
    Attributes                  DD ?
    GrantedAccess               ACCESS_MASK ?
    HandleCount                 DD ?
    PointerCount                DD ?
    PagedPoolUsage              DD ?
    NonPagedPoolUsage           DD ?
    Reserved                    DD 3 DUP(?)
    NameInformationLength       DD ?
    TypeInformationLength       DD ?
    SecurityDescriptorLength    DD ?
    CreateTime                  LARGE_INTEGER <>
OBJECT_BASIC_INFORMATION ENDS

OBJECT_NAME_INFORMATION STRUCT ALIGNMODE
    _Name UNICODE_STRING <>
OBJECT_NAME_INFORMATION ENDS

OBJECT_TYPE_INFORMATION STRUCT ALIGNMODE
    _Name                   UNICODE_STRING <>
    ObjectCount             DD ?
    HandleCount             DD ?
    Reserved1               DD 4 DUP(?)
    PeakObjectCount         DD ?
    PeakHandleCount         DD ?
    Reserved2               DD 4 DUP(?)
    InvalidAttributes       DD ?
    GenericMapping          GENERIC_MAPPING <>
    ValidAccess             DD ?
    _Unknown                DB ?
    MaintainHandleDatabase  DB ?
    Reserved3               DB 2 DUP(?)
    PoolType                DD ?
    PagedPoolUsage          DD ?
    NonPagedPoolUsage       DD ?
OBJECT_TYPE_INFORMATION ENDS

OBJECT_ALL_TYPES_INFORMATION STRUCT ALIGNMODE
    NumberOfTypes   DD ?
    TypeInformation OBJECT_TYPE_INFORMATION <>
OBJECT_ALL_TYPES_INFORMATION ENDS

OBJECT_HANDLE_ATTRIBUTE_INFORMATION STRUCT ALIGNMODE
    Inherit             DB ?
    ProtectFromClose    DB ?
OBJECT_HANDLE_ATTRIBUTE_INFORMATION ENDS

IFNDEF MEMORY_BASIC_INFORMATION_DEFINED
    MEMORY_BASIC_INFORMATION_DEFINED EQU 1
    MEMORY_BASIC_INFORMATION STRUCT ALIGNMODE
        BaseAddress         XPTR ?
        AllocationBase      XPTR ?
        AllocationProtect   DD ?
        RegionSize          XPTR ?
        State               DD ?
        Protect             DD ?
        _Type               DD ?
    MEMORY_BASIC_INFORMATION ENDS
ENDIF

MEMORY_WORKING_SET_LIST STRUCT ALIGNMODE
    NumberOfPages   DD ?
    WorkingSetList  DD 2 DUP(?)
MEMORY_WORKING_SET_LIST ENDS

MEMORY_SECTION_NAME STRUCT ALIGNMODE
    SectionFileName UNICODE_STRING <>
MEMORY_SECTION_NAME ENDS

DEBUG_BUFFER STRUCT ALIGNMODE
    SectionHandle           XWORD ?
    SectionBase             XPTR  ?
    RemoteSectionBase       XPTR  ?
    SectionBaseDelta        DD    ?
    EventPairHandle         XWORD ?
    _Unknown                DD    2 DUP(?)
    RemoteThreadHandle      XWORD ?
    InfoClassMask           DD    ?
    SizeOfInfo              DD    ?
    AllocatedSize           DD    ?
    SectionSize             DD    ?
    ModuleInformation       XPTR  ?
    BackTraceInformation    XPTR  ?
    HeapInformation         XPTR  ?
    LockInformation         XPTR  ?
    Reserved                XPTR  8 DUP(?)
DEBUG_BUFFER ENDS

DEBUG_MODULE_INFORMATION STRUCT ALIGNMODE
    Reserved            DD 2 DUP(?)
    Base                DD ?
    _Size               DD ?
    Flags               DD ?
    Index               DW ?
    _Unknown            DW ?
    LoadCount           DW ?
    ModuleNameOffset    DW ?
    ImageName           DB 256 DUP(?)
DEBUG_MODULE_INFORMATION ENDS

DEBUG_HEAP_INFORMATION STRUCT ALIGNMODE
    Base        DD   ?
    Flags       DD   ?
    Granularity DW   ?
    _Unknown    DW   ?
    Allocated   DD   ?
    Committed   DD   ?
    TagCount    DD   ?
    BlockCount  DD   ?
    Reserved    DD   7 DUP(?)
    Tags        XPTR ?
    Blocks      XPTR ?
DEBUG_HEAP_INFORMATION ENDS

DEBUG_LOCK_INFORMATION STRUCT ALIGNMODE
    Address                     XPTR ?
    _Type                       DW ?
    CreatorBackTraceIndex       DW ?
    OwnerThreadId               DD ?
    ActiveCount                 DD ?
    ContentionCount             DD ?
    EntryCount                  DD ?
    RecursionCount              DD ?
    NumberOfSharedWaiters       DD ?
    NumberOfExclusiveWaiters    DD ?
DEBUG_LOCK_INFORMATION ENDS

PORT_SECTION_WRITE STRUCT ALIGNMODE
    _Length         DD    ?
    SectionHandle   XWORD ?
    SectionOffset   DD    ?
    ViewSize        DD    ?
    ViewBase        XPTR  ?
    TargetViewBase  XPTR  ?
PORT_SECTION_WRITE ENDS

PORT_SECTION_READ STRUCT ALIGNMODE
    _Length     DD ?
    ViewSize    DD ?
    ViewBase    XPTR ?
PORT_SECTION_READ ENDS

IFNDEF FLOATING_SAVE_AREA_DEFINED
    FLOATING_SAVE_AREA_DEFINED EQU 1
    FLOATING_SAVE_AREA STRUCT ALIGNMODE
        ControlWord     DD ?
        StatusWord      DD ?
        TagWord         DD ?
        ErrorOffset     DD ?
        ErrorSelector   DD ?
        DataOffset      DD ?
        DataSelector    DD ?
        RegisterArea    DB SIZE_OF_80387_REGISTERS DUP(?)
        Cr0NpxState     DD ?
    FLOATING_SAVE_AREA ENDS
ENDIF

IFNDEF CONTEXT32_DEFINED
    CONTEXT32_DEFINED   EQU 1
    CONTEXT32 STRUCT ALIGNMODE
        ContextFlags        DD ?
        _Dr0                DD ?
        _Dr1                DD ?
        _Dr2                DD ?
        _Dr3                DD ?
        _Dr6                DD ?
        _Dr7                DD ?
        FloatSave           FLOATING_SAVE_AREA <>
        SegGs               DD ?
        SegFs               DD ?
        SegEs               DD ?
        SegDs               DD ?
        _Edi                DD ?
        _Esi                DD ?
        _Ebx                DD ?
        _Edx                DD ?
        _Ecx                DD ?
        _Eax                DD ?
        _Ebp                DD ?
        _Eip                DD ?
        SegCs               DD ?
        EFlags              DD ?
        _Esp                DD ?
        SegSs               DD ?
        ExtendedRegisters   DB MAXIMUM_SUPPORTED_EXTENSION DUP(?)
    CONTEXT32 ENDS
ENDIF

SCOPE_RECORD STRUCT ALIGNMODE
    BeginAddress    DD ?
    EndAddress      DD ?
    HandlerAddress  DD ?
    JumpTarget      DD ?
SCOPE_RECORD EndS

SCOPE_TABLE STRUCT ALIGNMODE
    Count          DD ?
    ScopeRecord    SCOPE_RECORD 2 DUP(<>)
SCOPE_TABLE ENDS

EXCEPTION_DATA STRUCT ALIGNMODE
    UNION
        ExceptionHandler DD ?
        FunctionEntry    DD ?
    ENDS
    ScopeTable          SCOPE_TABLE <>
EXCEPTION_DATA ENDS

IFNDEF XMM_SAVE_AREA32_DEFINED
    XMM_SAVE_AREA32_DEFINED EQU 1
    XMM_SAVE_AREA32 Struct ALIGNMODE
        ControlWord     DW ?
        StatusWord      DW ?
        TagWord         DB ?
        Reserved1       DB ?
        ErrorOpcode     DW ?
        ErrorOffset     DD ?
        ErrorSelector   DW ?
        Reserved2       DW ?
        DataOffset      DD ?
        DataSelector    DW ?
        Reserved3       DW ?
        MxCsr           DD ?
        MxCsr_Mask      DD ?
        FloatRegisters  M128A 8 DUP(<>)
        XmmRegisters    M128A 16 DUP(<>)
        Reserved4       DB 96 DUP(?)
    XMM_SAVE_AREA32 ENDS
ENDIF

IFNDEF CONTEXT64_DEFINED
    CONTEXT64_DEFINED   EQU 1
    CONTEXT64 STRUCT ALIGNMODE
        P1Home                  DQ ?
        P2Home                  DQ ?
        P3Home                  DQ ?
        P4Home                  DQ ?
        P5Home                  DQ ?
        P6Home                  DQ ?
        ContextFlags            DD ?
        MxCsr                   DD ?
        SegCs                   DW ?
        SegDs                   DW ?
        SegEs                   DW ?
        SegFs                   DW ?
        SegGs                   DW ?
        SegSs                   DW ?
        EFlags                  DD ?
        _Dr0                    DQ ?
        _Dr1                    DQ ?
        _Dr2                    DQ ?
        _Dr3                    DQ ?
        _Dr6                    DQ ?
        _Dr7                    DQ ?
        _Rax                    DQ ?
        _Rcx                    DQ ?
        _Rdx                    DQ ?
        _Rbx                    DQ ?
        _Rsp                    DQ ?
        _Rbp                    DQ ?
        _Rsi                    DQ ?
        _Rdi                    DQ ?
        _R8                     DQ ?
        _R9                     DQ ?
        _R10                    DQ ?
        _R11                    DQ ?
        _R12                    DQ ?
        _R13                    DQ ?
        _R14                    DQ ?
        _R15                    DQ ?
        _Rip                    DQ ?
        UNION
            FltSave             XMM_SAVE_AREA32 <>
            STRUCT
                Header          M128A 2 DUP(<>)
                Legacy          M128A 8 DUP(<>)
                _Xmm0           M128A <>
                _Xmm1           M128A <>
                _Xmm2           M128A <>
                _Xmm3           M128A <>
                _Xmm4           M128A <>
                _Xmm5           M128A <>
                _Xmm6           M128A <>
                _Xmm7           M128A <>
                _Xmm8           M128A <>
                _Xmm9           M128A <>
                _Xmm10          M128A <>
                _Xmm11          M128A <>
                _Xmm12          M128A <>
                _Xmm13          M128A <>
                _Xmm14          M128A <>
                _Xmm15          M128A <>
            ENDS
        ENDS
        VectorRegister          M128A 26 DUP(<>)
        VectorControl           DQ ?
        DebugControl            DQ ?
        LastBranchToRip         DQ ?
        LastBranchFromRip       DQ ?
        LastExceptionToRip      DQ ?
        LastExceptionFromRip    DQ ?
    CONTEXT64 ENDS
ENDIF

IMAGE_BASE_RELOCATION_EX STRUCT ALIGNMODE
    VirtualAddress  DD ?
    SizeOfBlock     DD ?
    TypeOffset      DW 2 DUP(?)
IMAGE_BASE_RELOCATION_EX ENDS

;======================================== Functions =======================================;
IF (NTDDI_VERSION GE NTDDI_WINXP)
    IFDEF APP_WIN64
        IFNDEF __C_specific_handler
            __C_specific_handler PROTO :XPTR,:XPTR,:XPTR,:XPTR
        ENDIF
        IFNDEF __chkstk
            __chkstk PROTO
        ENDIF
    ENDIF
ENDIF
__isascii PROTO :QWORD
__iscsym PROTO :VARARG
__iscsymf PROTO :VARARG
__toascii PROTO :VARARG
_atoi64 PROTO :QWORD
_i64toa PROTO :QWORD,:QWORD,:QWORD
_i64tow PROTO :QWORD,:QWORD,:QWORD
_itoa PROTO :QWORD,:QWORD,:QWORD
_itow PROTO :QWORD,:QWORD,:QWORD
_lfind PROTO :VARARG
_local_unwind PROTO
_ltoa PROTO :QWORD,:QWORD,:QWORD
_ltow PROTO :QWORD,:QWORD,:QWORD
_memccpy PROTO :QWORD,:QWORD,:QWORD,:QWORD
_memicmp PROTO :QWORD,:QWORD,:QWORD
_setjmp PROTO :XPTR
_setjmpex PROTO :XPTR
_snprintf PROTO :XPTR,:XPTR,:XPTR,:VARARG
_snwprintf PROTO :VARARG
_splitpath PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
_strcmpi PROTO :QWORD,:QWORD
_stricmp PROTO :XPTR,:XPTR
_strlwr PROTO :XPTR
_strnicmp PROTO :XPTR,:XPTR,:XPTR
_strupr PROTO :XPTR
_ui64toa PROTO :QWORD,:QWORD,:QWORD
_ui64tow PROTO :QWORD,:QWORD,:QWORD
_ultoa PROTO :QWORD,:QWORD,:QWORD
_ultow PROTO :QWORD,:QWORD,:QWORD
_vscwprintf PROTO :VARARG
_vsnprintf PROTO :XPTR,:XPTR,:XPTR,:VARARG
_vsnwprintf PROTO :XPTR,:XPTR,:XPTR,:VARARG
_wcsicmp PROTO :XPTR,:XPTR
_wcslwr PROTO :XPTR
_wcsnicmp PROTO :XPTR,:XPTR,:XPTR
_wcstoui64 PROTO :VARARG
_wcsupr PROTO :XPTR
_wtoi PROTO :QWORD
_wtoi64 PROTO :QWORD
_wtol PROTO :QWORD
abs PROTO :QWORD
atan PROTO :QWORD
atoi PROTO :QWORD
atol PROTO :QWORD
bsearch PROTO :XPTR,:XPTR,D :XPTR,:XPTR,:XPTR
ceil PROTO :QWORD
cos PROTO :QWORD
CsrAllocateCaptureBuffer PROTO :QWORD,:QWORD
CsrAllocateMessagePointer PROTO :QWORD,:QWORD,:QWORD
CsrCaptureMessageBuffer PROTO :QWORD,:QWORD,:QWORD,:QWORD
CsrCaptureMessageMultiUnicodeStringsInPlace PROTO :QWORD,:QWORD,:QWORD
CsrCaptureMessageString PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
CsrCaptureTimeout PROTO :QWORD,:QWORD
CsrClientCallServer PROTO :QWORD,:QWORD,:QWORD,:QWORD
CsrClientConnectToServer PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
CsrFreeCaptureBuffer PROTO :QWORD
CsrGetProcessId PROTO
CsrIdentifyAlertableThread PROTO
CsrSetPriorityClass PROTO :QWORD,:QWORD
DbgBreakPoint PROTO
DbgPrint PROTO :VARARG
DbgPrintEx PROTO :VARARG
DbgPrintReturnControlC PROTO :VARARG
DbgPrompt PROTO :QWORD,:QWORD,:QWORD
DbgQueryDebugFilterState PROTO :QWORD,:QWORD
DbgSetDebugFilterState PROTO :QWORD,:QWORD,:QWORD
DbgUiConnectToDbg PROTO
DbgUiContinue PROTO :QWORD,:QWORD
DbgUiConvertStateChangeStructure PROTO :QWORD,:QWORD
DbgUiDebugActiveProcess PROTO :QWORD
DbgUiGetThreadDebugObject PROTO
DbgUiIssueRemoteBreakin PROTO :QWORD
DbgUiRemoteBreakin PROTO :QWORD
DbgUiSetThreadDebugObject PROTO :QWORD
DbgUiStopDebugging PROTO :QWORD
DbgUiWaitStateChange PROTO :QWORD,:QWORD
DbgUserBreakPoint PROTO
EtwCreateTraceInstanceId PROTO :XWORD,:XPTR
EtwGetTraceEnableFlags PROTO :XWORD
EtwGetTraceEnableLevel PROTO :XWORD
EtwGetTraceLoggerHandle PROTO :XPTR
EtwRegisterTraceGuidsA PROTO :XWORD,:XPTR,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XWORD
EtwRegisterTraceGuidsW PROTO :XWORD,:XPTR,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XWORD
EtwTraceMessage PROTO :XWORD,:XWORD,:XPTR,:XWORD
EtwUnregisterTraceGuids PROTO :XWORD
floor PROTO :QWORD
isalnum PROTO :XWORD
isalpha PROTO :XWORD
iscntrl PROTO :XWORD
isdigit PROTO :XWORD
isgraph PROTO :QWORD
islower PROTO :XWORD
isprint PROTO :XWORD
ispunct PROTO :XWORD
isspace PROTO :XWORD
isupper PROTO :XWORD
iswalpha PROTO :XWORD
iswctype PROTO :VARARG
iswdigit PROTO :XWORD
iswlower PROTO :QWORD
iswspace PROTO :QWORD
iswxdigit PROTO :VARARG
isxdigit PROTO :XWORD
KiRaiseUserExceptionDispatcher PROTO
KiUserApcDispatcher PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
KiUserCallbackDispatcher PROTO :QWORD,:QWORD,:QWORD
KiUserExceptionDispatcher PROTO :QWORD,:QWORD
labs PROTO :QWORD
LdrAccessResource PROTO :QWORD,:QWORD,:QWORD,:QWORD
LdrAddRefDll PROTO :QWORD,:QWORD
LdrDisableThreadCalloutsForDll PROTO :QWORD
LdrEnumerateLoadedModules PROTO :QWORD,:QWORD,:QWORD
LdrEnumResources PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
LdrFindEntryForAddress PROTO :QWORD,:QWORD
LdrFindResource_U PROTO :QWORD,:QWORD,:QWORD,:QWORD
LdrFindResourceDirectory_U PROTO :QWORD,:QWORD,:QWORD,:QWORD
LdrFindResourceEx_U PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
LdrFlushAlternateResourceModules PROTO
LdrGetDllHandle PROTO :QWORD,:QWORD,:QWORD,:QWORD
LdrGetDllHandleEx PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
LdrGetProcedureAddress PROTO :QWORD,:QWORD,:QWORD,:QWORD
LdrInitializeThunk PROTO :QWORD,:QWORD,:QWORD,:QWORD
LdrInitShimEngineDynamic PROTO :QWORD
LdrLoadAlternateResourceModule PROTO :QWORD,:QWORD
LdrLoadDll PROTO :QWORD,:QWORD,:QWORD,:QWORD
LdrLockLoaderLock PROTO :QWORD,:QWORD,:QWORD
LdrOpenImageFileOptionsKey PROTO :XPTR,:XWORD,:XPTR
LdrProcessRelocationBlock PROTO :QWORD,:QWORD,:QWORD,:QWORD
LdrQueryImageFileExecutionOptions PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
LdrQueryImageFileExecutionOptionsEx PROTO :XPTR,:XPTR,:XWORD,:XWORD,:XWORD,:XPTR,:XWORD
LdrQueryImageFileKeyOption PROTO :XWORD,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR
LdrQueryProcessModuleInformation PROTO :QWORD,:QWORD,:QWORD
LdrSetAppCompatDllRedirectionCallback PROTO :QWORD,:QWORD,:QWORD
LdrSetDllManifestProber PROTO :QWORD
LdrShutdownProcess PROTO
LdrShutdownThread PROTO
LdrUnloadAlternateResourceModule PROTO :QWORD
LdrUnloadDll PROTO :QWORD
LdrUnlockLoaderLock PROTO :QWORD,:QWORD
LdrVerifyImageMatchesChecksum PROTO :QWORD,:QWORD,:QWORD,:QWORD
log PROTO :QWORD
longjmp PROTO :XPTR,:XWORD
mbstowcs PROTO :XPTR,:XPTR,:XPTR
memchr PROTO :QWORD,:QWORD,:QWORD
memcmp PROTO :XPTR,:XPTR,:XPTR
memcpy PROTO :QWORD,:QWORD,:QWORD
memmove PROTO :QWORD,:QWORD,:QWORD
memset PROTO :QWORD,:QWORD,:QWORD
NlsAnsiCodePage PROTO :VARARG
NlsMbCodePageTag PROTO :VARARG
NlsMbOemCodePageTag PROTO :VARARG
NtAcceptConnectPort PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtAccessCheck PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtAccessCheckAndAuditAlarm PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtAccessCheckByType PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtAccessCheckByTypeAndAuditAlarm PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtAccessCheckByTypeResultList PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtAccessCheckByTypeResultListAndAuditAlarm PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtAccessCheckByTypeResultListAndAuditAlarmByHandle PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtAddAtom PROTO :QWORD,:QWORD,:QWORD
NtAddBootEntry PROTO :QWORD,:QWORD
NtAddDriverEntry PROTO :XPTR,:XWORD
NtAdjustGroupsToken PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtAdjustPrivilegesToken PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtAlertResumeThread PROTO :QWORD,:QWORD
NtAlertThread PROTO :QWORD
NtAllocateLocallyUniqueId PROTO :QWORD
NtAllocateUserPhysicalPages PROTO :QWORD,:QWORD,:QWORD
NtAllocateUuids PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtAllocateVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtApphelpCacheControl PROTO :XWORD,:XWORD
NtAreMappedFilesTheSame PROTO :QWORD,:QWORD
NtAssignProcessToJobObject PROTO :QWORD,:QWORD
NtCallbackReturn PROTO :QWORD,:QWORD,:QWORD
NtCancelIoFile PROTO :QWORD,:QWORD
NtCancelTimer PROTO :QWORD,:QWORD
NtClearEvent PROTO :QWORD
NtClose PROTO :QWORD
NtCloseObjectAuditAlarm PROTO :QWORD,:QWORD,:QWORD
NtCompactKeys PROTO :QWORD,:QWORD
NtCompareTokens PROTO :QWORD,:QWORD,:QWORD
NtCompleteConnectPort PROTO :QWORD
NtCompressKey PROTO :QWORD
NtConnectPort PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtContinue PROTO :QWORD,:QWORD
NtCreateDebugObject PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtCreateDirectoryObject PROTO :QWORD,:QWORD,:QWORD
NtCreateEvent PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtCreateEventPair PROTO :QWORD,:QWORD,:QWORD
NtCreateFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtCreateIoCompletion PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtCreateJobObject PROTO :QWORD,:QWORD,:QWORD
NtCreateJobSet PROTO :QWORD,:QWORD,:QWORD
NtCreateKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtCreateKeyedEvent PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtCreateMailslotFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtCreateMutant PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtCreateNamedPipeFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtCreatePagingFile PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtCreatePort PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtCreateProcess PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtCreateProcessEx PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtCreateProfile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtCreateSection PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtCreateSemaphore PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtCreateSymbolicLinkObject PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtCreateThread PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtCreateTimer PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtCreateToken PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtCreateWaitablePort PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtDebugActiveProcess PROTO :QWORD,:QWORD
NtDebugContinue PROTO :QWORD,:QWORD,:QWORD
NtDelayExecution PROTO :QWORD,:QWORD
NtDeleteAtom PROTO :QWORD
NtDeleteBootEntry PROTO :QWORD
NtDeleteDriverEntry PROTO :XWORD
NtDeleteFile PROTO :QWORD
NtDeleteKey PROTO :QWORD
NtDeleteObjectAuditAlarm PROTO :QWORD,:QWORD,:QWORD
NtDeleteValueKey PROTO :QWORD,:QWORD
NtDeviceIoControlFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtDisableLastKnownGood PROTO
NtDisplayString PROTO :QWORD
NtDuplicateObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtDuplicateToken PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtEnableLastKnownGood PROTO
NtEnumerateBootEntries PROTO :QWORD,:QWORD
NtEnumerateDriverEntries PROTO :XPTR,:XPTR
NtEnumerateKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtEnumerateSystemEnvironmentValuesEx PROTO :QWORD,:QWORD,:QWORD
NtEnumerateValueKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtExtendSection PROTO :QWORD,:QWORD
NtFilterToken PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtFindAtom PROTO :QWORD,:QWORD,:QWORD
NtFlushBuffersFile PROTO :QWORD,:QWORD
NtFlushInstructionCache PROTO :QWORD,:QWORD,:QWORD
NtFlushKey PROTO :QWORD
NtFlushVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtFlushWriteBuffer PROTO
NtFreeUserPhysicalPages PROTO :QWORD,:QWORD,:QWORD
NtFreeVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtFsControlFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtGetContextThread PROTO :QWORD,:QWORD
NtGetCurrentProcessorNumber PROTO
NtGetDevicePowerState PROTO :QWORD,:QWORD
NtGetTickCount PROTO
NtGetWriteWatch PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtImpersonateAnonymousToken PROTO :QWORD
NtImpersonateClientOfPort PROTO :QWORD,:QWORD
NtImpersonateThread PROTO :QWORD,:QWORD,:QWORD
NtInitializeRegistry PROTO :QWORD
NtInitiatePowerAction PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtIsProcessInJob PROTO :QWORD,:QWORD
NtIsSystemResumeAutomatic PROTO
NtListenPort PROTO :QWORD,:QWORD
NtLoadDriver PROTO :QWORD
NtLoadKey PROTO :QWORD,:QWORD
NtLoadKey2 PROTO :QWORD,:QWORD,:QWORD
NtLoadKeyEx PROTO :XPTR,:XPTR,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtLockFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtLockProductActivationKeys PROTO :QWORD,:QWORD
NtLockRegistryKey PROTO :QWORD
NtLockVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtMakePermanentObject PROTO :QWORD
NtMakeTemporaryObject PROTO :QWORD
NtMapUserPhysicalPages PROTO :QWORD,:QWORD,:QWORD
NtMapUserPhysicalPagesScatter PROTO :QWORD,:QWORD,:QWORD
NtMapViewOfSection PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtModifyBootEntry PROTO :QWORD
NtModifyDriverEntry PROTO :XPTR
NtNotifyChangeDirectoryFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtNotifyChangeKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtNotifyChangeMultipleKeys PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtOpenDirectoryObject PROTO :QWORD,:QWORD,:QWORD
NtOpenEvent PROTO :QWORD,:QWORD,:QWORD
NtOpenEventPair PROTO :QWORD,:QWORD,:QWORD
NtOpenFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtOpenIoCompletion PROTO :QWORD,:QWORD,:QWORD
NtOpenJobObject PROTO :QWORD,:QWORD,:QWORD
NtOpenKey PROTO :QWORD,:QWORD,:QWORD
NtOpenKeyedEvent PROTO :QWORD,:QWORD,:QWORD
NtOpenMutant PROTO :QWORD,:QWORD,:QWORD
NtOpenObjectAuditAlarm PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtOpenProcess PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtOpenProcessToken PROTO :QWORD,:QWORD,:QWORD
NtOpenProcessTokenEx PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtOpenSection PROTO :QWORD,:QWORD,:QWORD
NtOpenSemaphore PROTO :QWORD,:QWORD,:QWORD
NtOpenSymbolicLinkObject PROTO :QWORD,:QWORD,:QWORD
NtOpenThread PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtOpenThreadToken PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtOpenThreadTokenEx PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtOpenTimer PROTO :QWORD,:QWORD,:QWORD
NtPlugPlayControl PROTO :QWORD,:QWORD,:QWORD
NtPowerInformation PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtPrivilegeCheck PROTO :QWORD,:QWORD,:QWORD
NtPrivilegedServiceAuditAlarm PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtPrivilegeObjectAuditAlarm PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtProtectVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtPulseEvent PROTO :QWORD,:QWORD
NtQueryAttributesFile PROTO :QWORD,:QWORD
NtQueryBootEntryOrder PROTO :QWORD,:QWORD
NtQueryBootOptions PROTO :QWORD,:QWORD
NtQueryDebugFilterState PROTO :QWORD,:QWORD
NtQueryDefaultLocale PROTO :QWORD,:QWORD
NtQueryDefaultUILanguage PROTO :QWORD
NtQueryDirectoryFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryDirectoryObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryDriverEntryOrder PROTO :XPTR,:XPTR
NtQueryEaFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryEvent PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryFullAttributesFile PROTO :QWORD,:QWORD
NtQueryInformationAtom PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryInformationFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryInformationJobObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryInformationPort PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryInformationProcess PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryInformationThread PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryInformationToken PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryInstallUILanguage PROTO :QWORD
NtQueryIntervalProfile PROTO :QWORD,:QWORD
NtQueryIoCompletion PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryMultipleValueKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryMutant PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryOpenSubKeys PROTO :QWORD,:QWORD
NtQueryPerformanceCounter PROTO :QWORD,:QWORD
NtQueryPortInformationProcess PROTO
NtQueryQuotaInformationFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQuerySection PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQuerySecurityObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQuerySemaphore PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQuerySymbolicLinkObject PROTO :QWORD,:QWORD,:QWORD
NtQuerySystemEnvironmentValue PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtQuerySystemEnvironmentValueEx PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQuerySystemInformation PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtQuerySystemTime PROTO :QWORD
NtQueryTimer PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryTimerResolution PROTO :QWORD,:QWORD,:QWORD
NtQueryValueKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueryVolumeInformationFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtQueueApcThread PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtRaiseException PROTO :QWORD,:QWORD,:QWORD
NtRaiseHardError PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtReadFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtReadFileScatter PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtReadRequestData PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtReadVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtRegisterThreadTerminatePort PROTO :QWORD
NtReleaseKeyedEvent PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtReleaseMutant PROTO :QWORD,:QWORD
NtReleaseSemaphore PROTO :QWORD,:QWORD,:QWORD
NtRemoveIoCompletion PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtRemoveProcessDebug PROTO :QWORD,:QWORD
NtRenameKey PROTO :QWORD,:QWORD
NtReplaceKey PROTO :QWORD,:QWORD,:QWORD
NtReplyPort PROTO :QWORD,:QWORD
NtReplyWaitReceivePort PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtReplyWaitReceivePortEx PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtReplyWaitReplyPort PROTO :QWORD,:QWORD
NtRequestPort PROTO :QWORD,:QWORD
NtRequestWaitReplyPort PROTO :QWORD,:QWORD,:QWORD
NtResetEvent PROTO :QWORD,:QWORD
NtResetWriteWatch PROTO :QWORD,:QWORD,:QWORD
NtRestoreKey PROTO :QWORD,:QWORD,:QWORD
NtResumeProcess PROTO :QWORD
NtResumeThread PROTO :QWORD,:QWORD
NtSaveKey PROTO :QWORD,:QWORD
NtSaveKeyEx PROTO :QWORD,:QWORD,:QWORD
NtSaveMergedKeys PROTO :QWORD,:QWORD,:QWORD
NtSecureConnectPort PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtSetBootEntryOrder PROTO :QWORD,:QWORD
NtSetBootOptions PROTO :QWORD,:QWORD
NtSetContextThread PROTO :QWORD,:QWORD
NtSetDebugFilterState PROTO :QWORD,:QWORD,:QWORD
NtSetDefaultHardErrorPort PROTO :QWORD
NtSetDefaultLocale PROTO :QWORD,:QWORD
NtSetDefaultUILanguage PROTO :QWORD
NtSetDriverEntryOrder PROTO :XPTR,:XPTR
NtSetEaFile PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtSetEvent PROTO :QWORD,:QWORD
NtSetEventBoostPriority PROTO :QWORD
NtSetHighEventPair PROTO :QWORD
NtSetHighWaitLowEventPair PROTO :QWORD
NtSetInformationDebugObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtSetInformationFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtSetInformationJobObject PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtSetInformationKey PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtSetInformationObject PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtSetInformationProcess PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtSetInformationThread PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtSetInformationToken PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtSetIntervalProfile PROTO :QWORD,:QWORD
NtSetIoCompletion PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtSetLdtEntries PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtSetLowEventPair PROTO :QWORD
NtSetLowWaitHighEventPair PROTO :QWORD
NtSetQuotaInformationFile PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtSetSecurityObject PROTO :QWORD,:QWORD,:QWORD
NtSetSystemEnvironmentValue PROTO :QWORD,:QWORD
NtSetSystemEnvironmentValueEx PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtSetSystemInformation PROTO :QWORD,:QWORD,:QWORD
NtSetSystemPowerState PROTO :QWORD,:QWORD,:QWORD
NtSetSystemTime PROTO :QWORD,:QWORD
NtSetThreadExecutionState PROTO :QWORD,:QWORD
NtSetTimer PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtSetTimerResolution PROTO :QWORD,:QWORD,:QWORD
NtSetUuidSeed PROTO :QWORD
NtSetValueKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtSetVolumeInformationFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtShutdownSystem PROTO :QWORD
NtSignalAndWaitForSingleObject PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtStartProfile PROTO :QWORD
NtStopProfile PROTO :QWORD
NtSuspendProcess PROTO :QWORD
NtSuspendThread PROTO :QWORD,:QWORD
NtSystemDebugControl PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtTerminateJobObject PROTO :QWORD,:QWORD
NtTerminateProcess PROTO :QWORD,:QWORD
NtTerminateThread PROTO :QWORD,:QWORD
NtTestAlert PROTO
NtTraceEvent PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtTranslateFilePath PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtUnloadDriver PROTO :QWORD
NtUnloadKey PROTO :QWORD
NtUnloadKey2 PROTO :XWORD
NtUnloadKeyEx PROTO :QWORD,:QWORD
NtUnlockFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtUnlockVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtUnmapViewOfSection PROTO :QWORD,:QWORD
NtVdmControl PROTO :QWORD,:QWORD
NtWaitForDebugEvent PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtWaitForKeyedEvent PROTO :QWORD,:QWORD,:QWORD,:QWORD
NtWaitForMultipleObjects PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtWaitForMultipleObjects32 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR
NtWaitForSingleObject PROTO :QWORD,:QWORD,:QWORD
NtWaitHighEventPair PROTO :QWORD
NtWaitLowEventPair PROTO :QWORD
NtWriteFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtWriteFileGather PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtWriteRequestData PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtWriteVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
NtYieldExecution PROTO
PfxFindPrefix PROTO :QWORD,:QWORD
PfxInitialize PROTO :QWORD
PfxInsertPrefix PROTO :QWORD,:QWORD,:QWORD
PfxRemovePrefix PROTO :QWORD,:QWORD
pow PROTO :QWORD,:QWORD
qsort PROTO :XPTR,:XPTR,:XPTR,:XPTR
RtlAbortRXact PROTO :QWORD
RtlAbsoluteToSelfRelativeSD PROTO :QWORD,:QWORD,:QWORD
RtlAcquirePebLock PROTO
RtlAcquirePrivilege PROTO :XPTR,:XWORD,:XWORD,:XPTR
RtlAcquireResourceExclusive PROTO :QWORD,:QWORD
RtlAcquireResourceShared PROTO :QWORD,:QWORD
RtlActivateActivationContext PROTO :QWORD,:QWORD,:QWORD
RtlActivateActivationContextEx PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlActivateActivationContextUnsafeFast PROTO :QWORD,:QWORD
RtlAddAccessAllowedAce PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlAddAccessAllowedAceEx PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlAddAccessAllowedObjectAce PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlAddAccessDeniedAce PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlAddAccessDeniedAceEx PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlAddAccessDeniedObjectAce PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlAddAce PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlAddActionToRXact PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlAddAtomToAtomTable PROTO :QWORD,:QWORD,:QWORD
RtlAddAttributeActionToRXact PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlAddAuditAccessAce PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlAddAuditAccessAceEx PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlAddAuditAccessObjectAce PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlAddCompoundAce PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlAddFunctionTable PROTO :XPTR,:XWORD,:XWORD,:XWORD
RtlAddRefActivationContext PROTO :QWORD
RtlAddRefMemoryStream PROTO :QWORD
RtlAddressInSectionTable PROTO :QWORD,:QWORD,:QWORD
RtlAddVectoredContinueHandler PROTO :XWORD,:XPTR
RtlAddVectoredExceptionHandler PROTO :QWORD,:QWORD
RtlAdjustPrivilege PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlAllocateActivationContextStack PROTO :XPTR,:XPTR
RtlAllocateAndInitializeSid PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlAllocateHandle PROTO :QWORD,:QWORD
RtlAllocateHeap PROTO :QWORD,:QWORD,:QWORD
RtlAnsiCharToUnicodeChar PROTO :QWORD
RtlAnsiStringToUnicodeSize PROTO :QWORD
RtlAnsiStringToUnicodeString PROTO :QWORD,:QWORD,:QWORD
RtlAppendAsciizToString PROTO :QWORD,:QWORD
RtlAppendPathElement PROTO :QWORD,:QWORD,:QWORD
RtlAppendStringToString PROTO :QWORD,:QWORD
RtlAppendUnicodeStringToString PROTO :QWORD,:QWORD
RtlAppendUnicodeToString PROTO :QWORD,:QWORD
RtlApplicationVerifierStop PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlApplyRXact PROTO :QWORD
RtlApplyRXactNoFlush PROTO :QWORD
RtlAreAllAccessesGranted PROTO :QWORD,:QWORD
RtlAreAnyAccessesGranted PROTO :QWORD,:QWORD
RtlAreBitsClear PROTO :QWORD,:QWORD,:QWORD
RtlAreBitsSet PROTO :QWORD,:QWORD,:QWORD
RtlAssert PROTO :QWORD,:QWORD,:QWORD
RtlCancelTimer PROTO :QWORD,:QWORD
RtlCaptureContext PROTO :QWORD
RtlCaptureStackBackTrace PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlCharToInteger PROTO :QWORD,:QWORD,:QWORD
RtlCheckForOrphanedCriticalSections PROTO :QWORD
RtlCheckRegistryKey PROTO :QWORD,:QWORD
RtlClearAllBits PROTO :QWORD
RtlClearBits PROTO :QWORD,:QWORD,:QWORD
RtlCloneMemoryStream PROTO :QWORD,:QWORD
RtlCommitMemoryStream PROTO :QWORD,:QWORD
RtlCompactHeap PROTO :QWORD,:QWORD
RtlCompareMemory PROTO :QWORD,:QWORD,:QWORD
RtlCompareMemoryUlong PROTO :QWORD,:QWORD,:QWORD
RtlCompareString PROTO :QWORD,:QWORD,:QWORD
RtlCompareUnicodeString PROTO :QWORD,:QWORD,:QWORD
RtlCompressBuffer PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlComputeCrc32 PROTO :QWORD,:QWORD,:QWORD
RtlComputeImportTableHash PROTO :QWORD,:QWORD,:QWORD
RtlComputePrivatizedDllName_U PROTO :QWORD,:QWORD,:QWORD
RtlConsoleMultiByteToUnicodeN PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlConvertExclusiveToShared PROTO :QWORD
RtlConvertSharedToExclusive PROTO :QWORD
RtlConvertSidToUnicodeString PROTO :QWORD,:QWORD,:QWORD
RtlConvertToAutoInheritSecurityObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlCopyLuid PROTO :QWORD,:QWORD
RtlCopyLuidAndAttributesArray PROTO :QWORD,:QWORD,:QWORD
RtlCopyMappedMemory PROTO :XPTR,:XPTR,:XPTR
RtlCopyMemory PROTO :XPTR,:XPTR,:XWORD
RtlCopyMemoryNonTemporal PROTO :XPTR,:XPTR,:XWORD
RtlCopyMemoryStreamTo PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlCopyOutOfProcessMemoryStreamTo PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlCopySecurityDescriptor PROTO :QWORD,:QWORD
RtlCopySid PROTO :QWORD,:QWORD,:QWORD
RtlCopySidAndAttributesArray PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlCopyString PROTO :QWORD,:QWORD
RtlCopyUnicodeString PROTO :QWORD,:QWORD
RtlCreateAcl PROTO :QWORD,:QWORD,:QWORD
RtlCreateActivationContext PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlCreateAndSetSD PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlCreateAtomTable PROTO :QWORD,:QWORD
RtlCreateBootStatusDataFile PROTO
RtlCreateEnvironment PROTO :QWORD,:QWORD
RtlCreateHeap PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlCreateProcessParameters PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlCreateQueryDebugBuffer PROTO :QWORD,:QWORD
RtlCreateRegistryKey PROTO :QWORD,:QWORD
RtlCreateSecurityDescriptor PROTO :QWORD,:QWORD
RtlCreateServiceSid PROTO :XPTR,:XPTR,:XPTR
RtlCreateSystemVolumeInformationFolder PROTO :QWORD
RtlCreateTagHeap PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlCreateTimer PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlCreateTimerQueue PROTO :QWORD
RtlCreateUnicodeString PROTO :QWORD,:QWORD
RtlCreateUnicodeStringFromAsciiz PROTO :QWORD,:QWORD
RtlCreateUserProcess PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlCreateUserSecurityObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlCreateUserThread PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlCustomCPToUnicodeN PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlCutoverTimeToSystemTime PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlDeactivateActivationContext PROTO :QWORD,:QWORD
RtlDeactivateActivationContextUnsafeFast PROTO :QWORD
RtlDebugPrintTimes PROTO
RtlDecodePointer PROTO :QWORD
RtlDecodeSystemPointer PROTO :QWORD
RtlDecompressBuffer PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlDecompressFragment PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlDefaultNpAcl PROTO :QWORD
RtlDelete PROTO :QWORD
RtlDeleteAce PROTO :QWORD,:QWORD
RtlDeleteAtomFromAtomTable PROTO :QWORD,:QWORD
RtlDeleteCriticalSection PROTO :QWORD
RtlDeleteElementGenericTable PROTO :QWORD,:QWORD
RtlDeleteElementGenericTableAvl PROTO :QWORD,:QWORD
RtlDeleteFunctionTable PROTO :XPTR
RtlDeleteNoSplay PROTO :QWORD,:QWORD
RtlDeleteRegistryValue PROTO :QWORD,:QWORD,:QWORD
RtlDeleteResource PROTO :QWORD
RtlDeleteSecurityObject PROTO :QWORD
RtlDeleteTimer PROTO :QWORD,:QWORD,:QWORD
RtlDeleteTimerQueue PROTO :QWORD
RtlDeleteTimerQueueEx PROTO :QWORD,:QWORD
RtlDeNormalizeProcessParams PROTO :QWORD
RtlDeregisterWait PROTO :QWORD
RtlDeregisterWaitEx PROTO :QWORD,:QWORD
RtlDestroyAtomTable PROTO :QWORD
RtlDestroyEnvironment PROTO :QWORD
RtlDestroyHandleTable PROTO :QWORD
RtlDestroyHeap PROTO :QWORD
RtlDestroyProcessParameters PROTO :QWORD
RtlDestroyQueryDebugBuffer PROTO :QWORD
RtlDetermineDosPathNameType_U PROTO :QWORD
RtlDllShutdownInProgress PROTO
RtlDnsHostNameToComputerName PROTO :QWORD,:QWORD,:QWORD
RtlDoesFileExists_U PROTO :QWORD
RtlDosApplyFileIsolationRedirection_Ustr PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlDosPathNameToNtPathName_U PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlDosPathNameToNtPathName_U_WithStatus PROTO :XPTR,:XPTR
RtlDosPathNameToRelativeNtPathName_U PROTO :XPTR,:XPTR,:XPTR,:XPTR
RtlDosPathNameToRelativeNtPathName_U_WithStatus PROTO :XPTR,:XPTR,:XPTR,:XPTR
RtlDosSearchPath_U PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlDosSearchPath_Ustr PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlDowncaseUnicodeChar PROTO :QWORD
RtlDowncaseUnicodeString PROTO :QWORD,:QWORD,:QWORD
RtlDumpResource PROTO :QWORD
RtlDuplicateUnicodeString PROTO :QWORD,:QWORD,:QWORD
RtlEmptyAtomTable PROTO :QWORD,:QWORD
RtlEnableEarlyCriticalSectionEventCreation PROTO
RtlEncodePointer PROTO :QWORD
RtlEncodeSystemPointer PROTO :QWORD
RtlEnterCriticalSection PROTO :QWORD
RtlEnumerateGenericTable PROTO :QWORD,:QWORD
RtlEnumerateGenericTableAvl PROTO :QWORD,:QWORD
RtlEnumerateGenericTableLikeADirectory PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlEnumerateGenericTableWithoutSplaying PROTO :QWORD,:QWORD
RtlEnumerateGenericTableWithoutSplayingAvl PROTO :QWORD,:QWORD
RtlEnumProcessHeaps PROTO :QWORD,:QWORD
RtlEqualComputerName PROTO :QWORD,:QWORD
RtlEqualDomainName PROTO :QWORD,:QWORD
RtlEqualLuid PROTO :QWORD,:QWORD
RtlEqualPrefixSid PROTO :QWORD,:QWORD
RtlEqualSid PROTO :QWORD,:QWORD
RtlEqualString PROTO :QWORD,:QWORD,:QWORD
RtlEqualUnicodeString PROTO :QWORD,:QWORD,:QWORD
RtlEraseUnicodeString PROTO :QWORD
RtlExitUserThread PROTO :QWORD
RtlExpandEnvironmentStrings_U PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlFillMemory PROTO :QWORD,:QWORD,:QWORD
RtlFinalReleaseOutOfProcessMemoryStream PROTO :QWORD
RtlFindActivationContextSectionGuid PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlFindActivationContextSectionString PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlFindCharInUnicodeString PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlFindClearBits PROTO :QWORD,:QWORD,:QWORD
RtlFindClearBitsAndSet PROTO :QWORD,:QWORD,:QWORD
RtlFindClearRuns PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlFindLastBackwardRunClear PROTO :QWORD,:QWORD,:QWORD
RtlFindLeastSignificantBit PROTO :QWORD,:QWORD
RtlFindLongestRunClear PROTO :QWORD,:QWORD
RtlFindMessage PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlFindMostSignificantBit PROTO :QWORD,:QWORD
RtlFindNextForwardRunClear PROTO :QWORD,:QWORD,:QWORD
RtlFindSetBits PROTO :QWORD,:QWORD,:QWORD
RtlFindSetBitsAndClear PROTO :QWORD,:QWORD,:QWORD
RtlFirstEntrySList PROTO :QWORD
RtlFirstFreeAce PROTO :QWORD,:QWORD
RtlFlushSecureMemoryCache PROTO :QWORD,:QWORD
RtlFormatCurrentUserKeyPath PROTO :QWORD
RtlFormatMessage PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlFormatMessageEx PROTO :XPTR,:XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XWORD,:XPTR,:XWORD
RtlFreeActivationContextStack PROTO :XPTR
RtlFreeAnsiString PROTO :QWORD
RtlFreeHandle PROTO :QWORD,:QWORD
RtlFreeHeap PROTO :QWORD,:QWORD,:QWORD
RtlFreeOemString PROTO :QWORD
RtlFreeSid PROTO :QWORD
RtlFreeThreadActivationContextStack PROTO
RtlFreeUnicodeString PROTO :QWORD
RtlGenerate8dot3Name PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlGetAce PROTO :QWORD,:QWORD,:QWORD
RtlGetActiveActivationContext PROTO :QWORD
RtlGetCallersAddress PROTO :QWORD,:QWORD
RtlGetCompressionWorkSpaceSize PROTO :QWORD,:QWORD,:QWORD
RtlGetControlSecurityDescriptor PROTO :QWORD,:QWORD,:QWORD
RtlGetCriticalSectionRecursionCount PROTO 
RtlGetCurrentDirectory_U PROTO :QWORD,:QWORD
RtlGetCurrentPeb PROTO
RtlGetCurrentProcessorNumber PROTO
RtlGetDaclSecurityDescriptor PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlGetElementGenericTable PROTO :QWORD,:QWORD
RtlGetElementGenericTableAvl PROTO :QWORD,:QWORD
RtlGetFrame PROTO
RtlGetFullPathName_U PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlGetFullPathName_UstrEx PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
RtlGetFunctionTableListHead PROTO
RtlGetGroupSecurityDescriptor PROTO :QWORD,:QWORD,:QWORD
RtlGetLastNtStatus PROTO
RtlGetLastWin32Error PROTO
RtlGetLengthWithoutLastFullDosOrNtPathElement PROTO :QWORD,:QWORD,:QWORD
RtlGetLengthWithoutTrailingPathSeperators PROTO :QWORD,:QWORD,:QWORD
RtlGetLongestNtPathLength PROTO
RtlGetNativeSystemInformation PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlGetNtGlobalFlags PROTO
RtlGetNtProductType PROTO :QWORD
RtlGetNtVersionNumbers PROTO :QWORD,:QWORD,:QWORD
RtlGetOwnerSecurityDescriptor PROTO :QWORD,:QWORD,:QWORD
RtlGetProcessHeaps PROTO :QWORD,:QWORD
RtlGetSaclSecurityDescriptor PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlGetSecurityDescriptorRMControl PROTO :QWORD,:QWORD
RtlGetSetBootStatusData PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlGetThreadErrorMode PROTO
RtlGetUnloadEventTrace PROTO
RtlGetVersion PROTO :QWORD
RtlGUIDFromString PROTO :XPTR,:XPTR
RtlHashUnicodeString PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlIdentifierAuthoritySid PROTO :QWORD
RtlImageDirectoryEntryToData PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlImageNtHeader PROTO :QWORD
RtlImageNtHeaderEx PROTO :XWORD,:XPTR,:XWORD,:XPTR
RtlImageRvaToSection PROTO :QWORD,:QWORD,:QWORD
RtlImageRvaToVa PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlImpersonateSelf PROTO :QWORD
RtlInitAnsiString PROTO :QWORD,:QWORD
RtlInitAnsiStringEx PROTO :XPTR,:XPTR
RtlInitCodePageTable PROTO :QWORD,:QWORD
RtlInitializeAtomPackage PROTO :XWORD
RtlInitializeBitMap PROTO :XPTR,:XPTR,:XWORD
RtlInitializeContext PROTO :XWORD,:XPTR,:XPTR,:XPTR,:XPTR
RtlInitializeCriticalSection PROTO :QWORD
RtlInitializeCriticalSectionAndSpinCount PROTO :QWORD,:QWORD
RtlInitializeGenericTable PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlInitializeGenericTableAvl PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlInitializeHandleTable PROTO :QWORD,:QWORD,:QWORD
RtlInitializeResource PROTO :QWORD
RtlInitializeRXact PROTO :QWORD,:QWORD,:QWORD
RtlInitializeSid PROTO :QWORD,:QWORD,:QWORD
RtlInitializeSListHead PROTO :QWORD
RtlInitMemoryStream PROTO :QWORD
RtlInitNlsTables PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlInitOutOfProcessMemoryStream PROTO :QWORD
RtlInitString PROTO :QWORD,:QWORD
RtlInitUnicodeString PROTO :QWORD,:QWORD
RtlInitUnicodeStringEx PROTO :QWORD,:QWORD
RtlInsertElementGenericTable PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlInsertElementGenericTableAvl PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlInsertElementGenericTableFull PROTO :XPTR,:XPTR,:XWORD,:XPTR,:XPTR,:XWORD
RtlInsertElementGenericTableFullAvl PROTO :XPTR,:XPTR,:XWORD,:XPTR,:XPTR,:XWORD
RtlInstallFunctionTableCallback PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR
RtlInt64ToUnicodeString PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlIntegerToChar PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlIntegerToUnicodeString PROTO :QWORD,:QWORD,:QWORD
RtlInterlockedFlushSList PROTO :QWORD
RtlInterlockedPopEntrySList PROTO :QWORD
RtlInterlockedPushEntrySList PROTO :QWORD,:QWORD
RtlInterlockedPushListSList PROTO :XPTR,:XPTR,:XWORD
RtlIpv4AddressToStringA PROTO :QWORD,:QWORD
RtlIpv4AddressToStringExA PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlIpv4AddressToStringExW PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlIpv4AddressToStringW PROTO :QWORD,:QWORD
RtlIpv4StringToAddressA PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlIpv4StringToAddressExA PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlIpv4StringToAddressExW PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlIpv4StringToAddressW PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlIpv6AddressToStringA PROTO :QWORD,:QWORD
RtlIpv6AddressToStringExA PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlIpv6AddressToStringExW PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlIpv6AddressToStringW PROTO :QWORD,:QWORD
RtlIpv6StringToAddressA PROTO :QWORD,:QWORD,:QWORD
RtlIpv6StringToAddressExA PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlIpv6StringToAddressExW PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlIpv6StringToAddressW PROTO :QWORD,:QWORD,:QWORD
RtlIsActivationContextActive PROTO :QWORD
RtlIsCriticalSectionLocked PROTO :XPTR
RtlIsCriticalSectionLockedByThread PROTO :XPTR
RtlIsDosDeviceName_U PROTO :QWORD
RtlIsGenericTableEmpty PROTO :QWORD
RtlIsGenericTableEmptyAvl PROTO :QWORD
RtlIsNameLegalDOS8Dot3 PROTO :QWORD,:QWORD,:QWORD
RtlIsTextUnicode PROTO :QWORD,:QWORD,:QWORD
RtlIsThreadWithinLoaderCallout PROTO
RtlIsValidHandle PROTO :QWORD,:QWORD
RtlIsValidIndexHandle PROTO :QWORD,:QWORD,:QWORD
RtlLargeIntegerToChar PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlLeaveCriticalSection PROTO :QWORD
RtlLengthRequiredSid PROTO :QWORD
RtlLengthSecurityDescriptor PROTO :QWORD
RtlLengthSid PROTO :QWORD
RtlLocalTimeToSystemTime PROTO :QWORD,:QWORD
RtlLockBootStatusData PROTO :QWORD
RtlLockHeap PROTO :QWORD
RtlLockMemoryStreamRegion PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlLogStackBackTrace PROTO
RtlLookupAtomInAtomTable PROTO :QWORD,:QWORD,:QWORD
RtlLookupElementGenericTable PROTO :QWORD,:QWORD
RtlLookupElementGenericTableAvl PROTO :QWORD,:QWORD
RtlLookupElementGenericTableFull PROTO :XPTR,:XPTR,:XPTR,:XPTR
RtlLookupElementGenericTableFullAvl PROTO :XPTR,:XPTR,:XPTR,:XPTR
RtlLookupFunctionEntry PROTO :XWORD,:XPTR,:XPTR
RtlLookupFunctionTable PROTO  :XWORD,:XPTR,:XPTR
RtlMakeSelfRelativeSD PROTO :QWORD,:QWORD,:QWORD
RtlMapGenericMask PROTO :QWORD,:QWORD
RtlMapSecurityErrorToNtStatus PROTO :QWORD
RtlMoveMemory PROTO :QWORD,:QWORD,:QWORD
RtlMultiAppendUnicodeStringBuffer PROTO :QWORD,:QWORD,:QWORD
RtlMultiByteToUnicodeN PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlMultiByteToUnicodeSize PROTO :QWORD,:QWORD,:QWORD
RtlMultipleAllocateHeap PROTO :XPTR,:XWORD,:XPTR
RtlMultipleFreeHeap PROTO :XPTR,:XWORD,:XWORD,:XPTR
RtlNewInstanceSecurityObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlNewSecurityGrantedAccess PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlNewSecurityObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlNewSecurityObjectEx PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlNewSecurityObjectWithMultipleInheritance PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlNormalizeProcessParams PROTO :QWORD
RtlNtPathNameToDosPathName PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlNtStatusToDosError PROTO :QWORD
RtlNtStatusToDosErrorNoTeb PROTO :QWORD
RtlNumberGenericTableElements PROTO :QWORD
RtlNumberGenericTableElementsAvl PROTO :QWORD
RtlNumberOfClearBits PROTO :QWORD
RtlNumberOfSetBits PROTO :QWORD
RtlOemStringToUnicodeSize PROTO :QWORD
RtlOemStringToUnicodeString PROTO :QWORD,:QWORD,:QWORD
RtlOemToUnicodeN PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlOpenCurrentUser PROTO :QWORD,:QWORD
RtlpApplyLengthFunction PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlPcToFileHeader PROTO :QWORD,:QWORD
RtlpEnsureBufferSize PROTO :QWORD,:QWORD,:QWORD
RtlPinAtomInAtomTable PROTO :QWORD,:QWORD
RtlpNotOwnerCriticalSection PROTO :QWORD
RtlpNtCreateKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlpNtEnumerateSubKey PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlpNtMakeTemporaryKey PROTO :QWORD
RtlpNtOpenKey PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlpNtQueryValueKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlpNtSetValueKey PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlPopFrame PROTO :QWORD
RtlPrefixString PROTO :QWORD,:QWORD,:QWORD
RtlPrefixUnicodeString PROTO :QWORD,:QWORD,:QWORD
RtlProtectHeap PROTO :QWORD,:QWORD
RtlpUnWaitCriticalSection PROTO :QWORD
RtlPushFrame PROTO :QWORD
RtlpWaitForCriticalSection PROTO :QWORD
RtlQueryAtomInAtomTable PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlQueryDepthSList PROTO :QWORD
RtlQueryEnvironmentVariable_U PROTO :QWORD,:QWORD,:QWORD
RtlQueryHeapInformation PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlQueryInformationAcl PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlQueryInformationActivationContext PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlQueryInformationActiveActivationContext PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlQueryInterfaceMemoryStream PROTO :QWORD,:QWORD,:QWORD
RtlQueryProcessBackTraceInformation PROTO :QWORD
RtlQueryProcessDebugInformation PROTO :QWORD,:QWORD,:QWORD
RtlQueryProcessHeapInformation PROTO :QWORD
RtlQueryProcessLockInformation PROTO :QWORD
RtlQueryRegistryValues PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlQuerySecurityObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlQueryTagHeap PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlQueryTimeZoneInformation PROTO :QWORD
RtlQueueWorkItem PROTO :QWORD,:QWORD,:QWORD
RtlRaiseException PROTO :QWORD
RtlRaiseStatus PROTO :QWORD
RtlRandom PROTO :QWORD
RtlRandomEx PROTO :QWORD
RtlReadMemoryStream PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlReadOutOfProcessMemoryStream PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlReAllocateHeap PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlRealPredecessor PROTO :QWORD
RtlRealSuccessor PROTO :QWORD
RtlRegisterSecureMemoryCacheCallback PROTO :QWORD
RtlRegisterWait PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlReleaseActivationContext PROTO :QWORD
RtlReleaseMemoryStream PROTO :QWORD
RtlReleasePebLock PROTO
RtlReleasePrivilege PROTO :XPTR
RtlReleaseRelativeName PROTO :XPTR
RtlReleaseResource PROTO :QWORD
RtlRemoteCall PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlRemoveVectoredContinueHandler PROTO :XPTR
RtlRemoveVectoredExceptionHandler PROTO :QWORD
RtlResetRtlTranslations PROTO :QWORD
RtlRestoreContext PROTO :XPTR,:XPTR
RtlRestoreLastWin32Error PROTO :XWORD
RtlRevertMemoryStream PROTO :QWORD
RtlRunDecodeUnicodeString PROTO :QWORD,:QWORD
RtlRunEncodeUnicodeString PROTO :QWORD,:QWORD
RtlSecondsSince1970ToTime PROTO :QWORD,:QWORD
RtlSecondsSince1980ToTime PROTO :QWORD,:QWORD
RtlSeekMemoryStream PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlSelfRelativeToAbsoluteSD PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlSelfRelativeToAbsoluteSD2 PROTO :QWORD,:QWORD
RtlSetAllBits PROTO :QWORD
RtlSetAttributesSecurityDescriptor PROTO :QWORD,:QWORD,:QWORD
RtlSetBits PROTO :QWORD,:QWORD,:QWORD
RtlSetControlSecurityDescriptor PROTO :QWORD,:QWORD,:QWORD
RtlSetCriticalSectionSpinCount PROTO :QWORD,:QWORD
RtlSetCurrentDirectory_U PROTO :QWORD
RtlSetCurrentEnvironment PROTO :QWORD,:QWORD
RtlSetDaclSecurityDescriptor PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlSetEnvironmentStrings PROTO ;XPTR,:XWORD
RtlSetEnvironmentVariable PROTO :QWORD,:QWORD,:QWORD
RtlSetGroupSecurityDescriptor PROTO :QWORD,:QWORD,:QWORD
RtlSetHeapInformation PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlSetInformationAcl PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlSetIoCompletionCallback PROTO :QWORD,:QWORD,:QWORD
RtlSetLastWin32Error PROTO :QWORD
RtlSetLastWin32ErrorAndNtStatusFromNtStatus PROTO :QWORD
RtlSetMemoryStreamSize PROTO :QWORD,:QWORD,:QWORD
RtlSetOwnerSecurityDescriptor PROTO :QWORD,:QWORD,:QWORD
RtlSetProcessIsCritical PROTO :VARARG
RtlSetSaclSecurityDescriptor PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlSetSecurityDescriptorRMControl PROTO :QWORD,:QWORD
RtlSetSecurityObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlSetSecurityObjectEx PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlSetThreadErrorMode PROTO :XWORD,:XPTR
RtlSetThreadIsCritical PROTO :VARARG
RtlSetThreadPoolStartFunc PROTO :QWORD,:QWORD
RtlSetTimer PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlSetTimeZoneInformation PROTO :QWORD
RtlSetUnhandledExceptionFilter PROTO :XPTR
RtlSizeHeap PROTO :QWORD,:QWORD,:QWORD
RtlSplay PROTO :QWORD
RtlStartRXact PROTO :QWORD
RtlStatMemoryStream PROTO :QWORD,:QWORD,:QWORD
RtlStringFromGUID PROTO :QWORD,:QWORD
RtlSubAuthorityCountSid PROTO :QWORD
RtlSubAuthoritySid PROTO :QWORD,:QWORD
RtlSubtreePredecessor PROTO :QWORD
RtlSubtreeSuccessor PROTO :QWORD
RtlSystemTimeToLocalTime PROTO :QWORD,:QWORD
RtlTimeFieldsToTime PROTO :QWORD,:QWORD
RtlTimeToElapsedTimeFields PROTO :QWORD,:QWORD
RtlTimeToSecondsSince1970 PROTO :QWORD,:QWORD
RtlTimeToSecondsSince1980 PROTO :QWORD,:QWORD
RtlTimeToTimeFields PROTO :QWORD,:QWORD
RtlTraceDatabaseAdd PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlTraceDatabaseCreate PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlTraceDatabaseDestroy PROTO :QWORD
RtlTraceDatabaseEnumerate PROTO :QWORD,:QWORD,:QWORD
RtlTraceDatabaseFind PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlTraceDatabaseLock PROTO :QWORD
RtlTraceDatabaseUnlock PROTO :QWORD
RtlTraceDatabaseValidate PROTO :QWORD
RtlTryEnterCriticalSection PROTO :QWORD
RtlUnhandledExceptionFilter PROTO :QWORD
RtlUnhandledExceptionFilter2 PROTO :QWORD,:QWORD
RtlUnicodeStringToAnsiSize PROTO :QWORD
RtlUnicodeStringToAnsiString PROTO :QWORD,:QWORD,:QWORD
RtlUnicodeStringToCountedOemString PROTO :QWORD,:QWORD,:QWORD
RtlUnicodeStringToInteger PROTO :QWORD,:QWORD,:QWORD
RtlUnicodeStringToOemSize PROTO :QWORD
RtlUnicodeStringToOemString PROTO :QWORD,:QWORD,:QWORD
RtlUnicodeToCustomCPN PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlUnicodeToMultiByteN PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlUnicodeToMultiByteSize PROTO :QWORD,:QWORD,:QWORD
RtlUnicodeToOemN PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlUniform PROTO :QWORD
RtlUnlockBootStatusData PROTO :QWORD
RtlUnlockHeap PROTO :QWORD
RtlUnlockMemoryStreamRegion PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlUnwind PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlUnwindEx PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
RtlUpcaseUnicodeChar PROTO :QWORD
RtlUpcaseUnicodeString PROTO :QWORD,:QWORD,:QWORD
RtlUpcaseUnicodeStringToAnsiString PROTO :QWORD,:QWORD,:QWORD
RtlUpcaseUnicodeStringToCountedOemString PROTO :QWORD,:QWORD,:QWORD
RtlUpcaseUnicodeStringToOemString PROTO :QWORD,:QWORD,:QWORD
RtlUpcaseUnicodeToCustomCPN PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlUpcaseUnicodeToMultiByteN PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlUpcaseUnicodeToOemN PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlUpdateTimer PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlUpperChar PROTO :QWORD
RtlUpperString PROTO :QWORD,:QWORD
RtlValidAcl PROTO :QWORD
RtlValidateHeap PROTO :QWORD,:QWORD,:QWORD
RtlValidateProcessHeaps PROTO
RtlValidateUnicodeString PROTO :QWORD,:QWORD
RtlValidRelativeSecurityDescriptor PROTO :QWORD,:QWORD,:QWORD 
RtlValidSecurityDescriptor PROTO :QWORD
RtlValidSid PROTO :QWORD
RtlVerifyVersionInfo PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlVirtualUnwind PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
RtlWalkFrameChain PROTO :QWORD,:QWORD,:QWORD
RtlWalkHeap PROTO :QWORD,:QWORD
RtlWow64EnableFsRedirectionEx PROTO :XPTR,:XPTR
RtlWriteMemoryStream PROTO :QWORD,:QWORD,:QWORD,:QWORD
RtlWriteRegistryValue PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
RtlxAnsiStringToUnicodeSize PROTO :QWORD
RtlxOemStringToUnicodeSize PROTO :QWORD
RtlxUnicodeStringToAnsiSize PROTO :QWORD
RtlxUnicodeStringToOemSize PROTO :QWORD
RtlZeroHeap PROTO :QWORD,:QWORD
RtlZeroMemory PROTO :QWORD,:QWORD
RtlZombifyActivationContext PROTO :QWORD
sin PROTO :QWORD
sprintf PROTO :QWORD,:QWORD,:VARARG
sqrt PROTO :QWORD
sscanf PROTO :QWORD,:QWORD,:QWORD
strcat PROTO :QWORD,:QWORD
strchr PROTO :QWORD,:QWORD
strcmp PROTO :QWORD,:QWORD
strcpy PROTO :QWORD,:QWORD
strcspn PROTO :QWORD,:QWORD
strlen PROTO :QWORD
strncat PROTO :QWORD,:QWORD,:QWORD
strncmp PROTO :QWORD,:QWORD,:QWORD
strncpy PROTO :QWORD,:QWORD,:QWORD
strpbrk PROTO :QWORD,:QWORD
strrchr PROTO :QWORD,:QWORD
strspn PROTO :QWORD,:QWORD
strstr PROTO :QWORD,:QWORD
strtol PROTO :QWORD,:QWORD,:QWORD
strtoul PROTO :QWORD,:QWORD,:QWORD
swprintf PROTO :QWORD,:QWORD,:VARARG
tan PROTO :QWORD
tolower PROTO :XWORD
toupper PROTO :XWORD
towlower PROTO :XWORD
towupper PROTO :XWORD
vDbgPrintEx PROTO :XWORD,:XWORD,:XPTR,:VARARG
vDbgPrintExWithPrefix PROTO :XPTR,:XWORD,:XWORD,:XPTR,:VARARG
VerSetConditionMask PROTO :XWORD,:XWORD,:XWORD
vsprintf PROTO :XPTR,:XPTR,:VARARG
wcscat PROTO :QWORD,:QWORD
wcschr PROTO :QWORD,:QWORD
wcscmp PROTO :QWORD,:QWORD
wcscpy PROTO :QWORD,:QWORD
wcscspn PROTO :QWORD,:QWORD
wcslen PROTO :QWORD
wcsncat PROTO :QWORD,:QWORD,:QWORD
wcsncmp PROTO :QWORD,:QWORD,:QWORD
wcsncpy PROTO :QWORD,:QWORD,:QWORD
wcspbrk PROTO :QWORD,:QWORD
wcsrchr PROTO :QWORD,:QWORD
wcsspn PROTO :QWORD,:QWORD
wcsstr PROTO :QWORD,:QWORD
wcstol PROTO :QWORD,:QWORD,:QWORD
wcstombs PROTO :XPTR,:XPTR,:XPTR
wcstoul PROTO :QWORD,:QWORD,:QWORD
ZwAcceptConnectPort PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwAccessCheck PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwAccessCheckAndAuditAlarm PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwAccessCheckByType PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwAccessCheckByTypeAndAuditAlarm PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwAccessCheckByTypeResultList PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwAccessCheckByTypeResultListAndAuditAlarm PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwAccessCheckByTypeResultListAndAuditAlarmByHandle PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwAddAtom PROTO :QWORD,:QWORD,:QWORD
ZwAddBootEntry PROTO :QWORD,:QWORD
ZwAddDriverEntry PROTO :XPTR,:XPTR
ZwAdjustGroupsToken PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwAdjustPrivilegesToken PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwAlertResumeThread PROTO :QWORD,:QWORD
ZwAlertThread PROTO :QWORD
ZwAllocateLocallyUniqueId PROTO :QWORD
ZwAllocateUserPhysicalPages PROTO :QWORD,:QWORD,:QWORD
ZwAllocateUuids PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwAllocateVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwAreMappedFilesTheSame PROTO :QWORD,:QWORD
ZwAssignProcessToJobObject PROTO :QWORD,:QWORD
ZwCallbackReturn PROTO :QWORD,:QWORD,:QWORD
ZwCancelIoFile PROTO :QWORD,:QWORD
ZwCancelTimer PROTO :QWORD,:QWORD
ZwClearEvent PROTO :QWORD
ZwClose PROTO :QWORD
ZwCloseObjectAuditAlarm PROTO :QWORD,:QWORD,:QWORD
ZwCompactKeys PROTO :QWORD,:QWORD
ZwCompareTokens PROTO :QWORD,:QWORD,:QWORD
ZwCompleteConnectPort PROTO :QWORD
ZwCompressKey PROTO :QWORD
ZwConnectPort PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwContinue PROTO :QWORD,:QWORD
ZwCreateDebugObject PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwCreateDirectoryObject PROTO :QWORD,:QWORD,:QWORD
ZwCreateEvent PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwCreateEventPair PROTO :QWORD,:QWORD,:QWORD
ZwCreateFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwCreateIoCompletion PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwCreateJobObject PROTO :QWORD,:QWORD,:QWORD
ZwCreateJobSet PROTO :QWORD,:QWORD,:QWORD
ZwCreateKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwCreateKeyedEvent PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwCreateMailslotFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwCreateMutant PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwCreateNamedPipeFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwCreatePagingFile PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwCreatePort PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwCreateProcess PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwCreateProcessEx PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwCreateProfile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwCreateSection PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwCreateSemaphore PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwCreateSymbolicLinkObject PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwCreateThread PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwCreateTimer PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwCreateToken PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwCreateWaitablePort PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwDebugActiveProcess PROTO :QWORD,:QWORD
ZwDebugContinue PROTO :QWORD,:QWORD,:QWORD
ZwDelayExecution PROTO :QWORD,:QWORD
ZwDeleteAtom PROTO :QWORD
ZwDeleteBootEntry PROTO :QWORD
ZwDeleteDriverEntry PROTO :XWORD
ZwDeleteFile PROTO :QWORD
ZwDeleteKey PROTO :QWORD
ZwDeleteObjectAuditAlarm PROTO :QWORD,:QWORD,:QWORD
ZwDeleteValueKey PROTO :QWORD,:QWORD
ZwDeviceIoControlFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwDisplayString PROTO :QWORD
ZwDuplicateObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwDuplicateToken PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwEnumerateBootEntries PROTO :QWORD,:QWORD
ZwEnumerateDriverEntries PROTO :XPTR,:XPTR
ZwEnumerateKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwEnumerateSystemEnvironmentValuesEx PROTO :QWORD,:QWORD,:QWORD
ZwEnumerateValueKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwExtendSection PROTO :QWORD,:QWORD
ZwFilterToken PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwFindAtom PROTO :QWORD,:QWORD,:QWORD
ZwFlushBuffersFile PROTO :QWORD,:QWORD
ZwFlushInstructionCache PROTO :QWORD,:QWORD,:QWORD
ZwFlushKey PROTO :QWORD
ZwFlushVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwFlushWriteBuffer PROTO
ZwFreeUserPhysicalPages PROTO :QWORD,:QWORD,:QWORD
ZwFreeVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwFsControlFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwGetCurrentProcessorNumber PROTO
ZwGetContextThread PROTO :QWORD,:QWORD
ZwGetDevicePowerState PROTO :QWORD,:QWORD
ZwGetWriteWatch PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwImpersonateAnonymousToken PROTO :QWORD
ZwImpersonateClientOfPort PROTO :QWORD,:QWORD
ZwImpersonateThread PROTO :QWORD,:QWORD,:QWORD
ZwInitializeRegistry PROTO :QWORD
ZwInitiatePowerAction PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwIsProcessInJob PROTO :QWORD,:QWORD
ZwIsSystemResumeAutomatic PROTO
ZwListenPort PROTO :QWORD,:QWORD
ZwLoadDriver PROTO :QWORD
ZwLoadKey PROTO :QWORD,:QWORD
ZwLoadKey2 PROTO :QWORD,:QWORD,:QWORD
ZwLoadKeyEx PROTO :XPTR,:XPTR,:XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XPTR
ZwLockFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwLockProductActivationKeys PROTO :QWORD,:QWORD
ZwLockRegistryKey PROTO :QWORD
ZwLockVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwMakePermanentObject PROTO :QWORD
ZwMakeTemporaryObject PROTO :QWORD
ZwMapUserPhysicalPages PROTO :QWORD,:QWORD,:QWORD
ZwMapUserPhysicalPagesScatter PROTO :QWORD,:QWORD,:QWORD
ZwMapViewOfSection PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwModifyBootEntry PROTO :QWORD
ZwModifyDriverEntry PROTO :XPTR
ZwNotifyChangeDirectoryFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwNotifyChangeKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwNotifyChangeMultipleKeys PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwOpenDirectoryObject PROTO :QWORD,:QWORD,:QWORD
ZwOpenEvent PROTO :QWORD,:QWORD,:QWORD
ZwOpenEventPair PROTO :QWORD,:QWORD,:QWORD
ZwOpenFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwOpenIoCompletion PROTO :QWORD,:QWORD,:QWORD
ZwOpenJobObject PROTO :QWORD,:QWORD,:QWORD
ZwOpenKey PROTO :QWORD,:QWORD,:QWORD
ZwOpenKeyedEvent PROTO :QWORD,:QWORD,:QWORD
ZwOpenMutant PROTO :QWORD,:QWORD,:QWORD
ZwOpenObjectAuditAlarm PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwOpenProcess PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwOpenProcessToken PROTO :QWORD,:QWORD,:QWORD
ZwOpenProcessTokenEx PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwOpenSection PROTO :QWORD,:QWORD,:QWORD
ZwOpenSemaphore PROTO :QWORD,:QWORD,:QWORD
ZwOpenSymbolicLinkObject PROTO :QWORD,:QWORD,:QWORD
ZwOpenThread PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwOpenThreadToken PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwOpenThreadTokenEx PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwOpenTimer PROTO :QWORD,:QWORD,:QWORD
ZwPlugPlayControl PROTO :QWORD,:QWORD,:QWORD
ZwPowerInformation PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwPrivilegeCheck PROTO :QWORD,:QWORD,:QWORD
ZwPrivilegedServiceAuditAlarm PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwPrivilegeObjectAuditAlarm PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwProtectVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwPulseEvent PROTO :QWORD,:QWORD
ZwQueryAttributesFile PROTO :QWORD,:QWORD
ZwQueryBootEntryOrder PROTO :QWORD,:QWORD
ZwQueryBootOptions PROTO :QWORD,:QWORD
ZwQueryDebugFilterState PROTO :QWORD,:QWORD
ZwQueryDefaultLocale PROTO :QWORD,:QWORD
ZwQueryDefaultUILanguage PROTO :QWORD
ZwQueryDirectoryFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryDirectoryObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryDriverEntryOrder PROTO :XPTR,:XPTR
ZwQueryEaFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryEvent PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryFullAttributesFile PROTO :QWORD,:QWORD
ZwQueryInformationAtom PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryInformationFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryInformationJobObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryInformationPort PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryInformationProcess PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryInformationThread PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryInformationToken PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryInstallUILanguage PROTO :QWORD
ZwQueryIntervalProfile PROTO :QWORD,:QWORD
ZwQueryIoCompletion PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryMultipleValueKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryMutant PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryOpenSubKeys PROTO :QWORD,:QWORD
ZwQueryOpenSubKeysEx PROTO :XPTR,:XWORD,:XPTR,:XPTR
ZwQueryPerformanceCounter PROTO :QWORD,:QWORD
ZwQueryPortInformationProcess PROTO
ZwQueryQuotaInformationFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQuerySection PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQuerySecurityObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQuerySemaphore PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQuerySymbolicLinkObject PROTO :QWORD,:QWORD,:QWORD
ZwQuerySystemEnvironmentValue PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwQuerySystemEnvironmentValueEx PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQuerySystemInformation PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwQuerySystemTime PROTO :QWORD
ZwQueryTimer PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryTimerResolution PROTO :QWORD,:QWORD,:QWORD
ZwQueryValueKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueryVolumeInformationFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwQueueApcThread PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwRaiseException PROTO :QWORD,:QWORD,:QWORD
ZwRaiseHardError PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwReadFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwReadFileScatter PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwReadRequestData PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwReadVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwRegisterThreadTerminatePort PROTO :QWORD
ZwReleaseKeyedEvent PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwReleaseMutant PROTO :QWORD,:QWORD
ZwReleaseSemaphore PROTO :QWORD,:QWORD,:QWORD
ZwRemoveIoCompletion PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwRemoveProcessDebug PROTO :QWORD,:QWORD
ZwRenameKey PROTO :QWORD,:QWORD
ZwReplaceKey PROTO :QWORD,:QWORD,:QWORD
ZwReplyPort PROTO :QWORD,:QWORD
ZwReplyWaitReceivePort PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwReplyWaitReceivePortEx PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwReplyWaitReplyPort PROTO :QWORD,:QWORD
ZwRequestPort PROTO :QWORD,:QWORD
ZwRequestWaitReplyPort PROTO :QWORD,:QWORD,:QWORD
ZwResetEvent PROTO :QWORD,:QWORD
ZwResetWriteWatch PROTO :QWORD,:QWORD,:QWORD
ZwRestoreKey PROTO :QWORD,:QWORD,:QWORD
ZwResumeProcess PROTO :QWORD
ZwResumeThread PROTO :QWORD,:QWORD
ZwSaveKey PROTO :QWORD,:QWORD
ZwSaveKeyEx PROTO :QWORD,:QWORD,:QWORD
ZwSaveMergedKeys PROTO :QWORD,:QWORD,:QWORD
ZwSecureConnectPort PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwSetBootEntryOrder PROTO :QWORD,:QWORD
ZwSetBootOptions PROTO :QWORD,:QWORD
ZwSetContextThread PROTO :QWORD,:QWORD
ZwSetDebugFilterState PROTO :QWORD,:QWORD,:QWORD
ZwSetDefaultHardErrorPort PROTO :QWORD
ZwSetDefaultLocale PROTO :QWORD,:QWORD
ZwSetDefaultUILanguage PROTO :QWORD
ZwSetDriverEntryOrder PROTO :XPTR,:XWORD
ZwSetEaFile PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwSetEvent PROTO :QWORD,:QWORD
ZwSetEventBoostPriority PROTO :QWORD
ZwSetHighEventPair PROTO :QWORD
ZwSetHighWaitLowEventPair PROTO :QWORD
ZwSetInformationDebugObject PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwSetInformationFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwSetInformationJobObject PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwSetInformationKey PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwSetInformationObject PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwSetInformationProcess PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwSetInformationThread PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwSetInformationToken PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwSetIntervalProfile PROTO :QWORD,:QWORD
ZwSetIoCompletion PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwSetLdtEntries PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwSetLowEventPair PROTO :QWORD
ZwSetLowWaitHighEventPair PROTO :QWORD
ZwSetQuotaInformationFile PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwSetSecurityObject PROTO :QWORD,:QWORD,:QWORD
ZwSetSystemEnvironmentValue PROTO :QWORD,:QWORD
ZwSetSystemEnvironmentValueEx PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwSetSystemInformation PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwSetSystemPowerState PROTO :QWORD,:QWORD,:QWORD
ZwSetSystemTime PROTO :QWORD,:QWORD
ZwSetThreadExecutionState PROTO :QWORD,:QWORD
ZwSetTimer PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwSetTimerResolution PROTO :QWORD,:QWORD,:QWORD
ZwSetUuidSeed PROTO :QWORD
ZwSetValueKey PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwSetVolumeInformationFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwShutdownSystem PROTO :QWORD
ZwSignalAndWaitForSingleObject PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwStartProfile PROTO :QWORD
ZwStopProfile PROTO :QWORD
ZwSuspendProcess PROTO :QWORD
ZwSuspendThread PROTO :QWORD,:QWORD
ZwSystemDebugControl PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwTerminateJobObject PROTO :QWORD,:QWORD
ZwTerminateProcess PROTO :QWORD,:QWORD
ZwTerminateThread PROTO :QWORD,:QWORD
ZwTestAlert PROTO
ZwTraceEvent PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwTranslateFilePath PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwUnloadDriver PROTO :QWORD
ZwUnloadKey PROTO :QWORD
ZwUnloadKey2 PROTO :XPTR,:XWORD
ZwUnloadKeyEx PROTO :QWORD,:QWORD
ZwUnlockFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwUnlockVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwUnmapViewOfSection PROTO :QWORD,:QWORD
ZwVdmControl PROTO :QWORD,:QWORD
ZwWaitForDebugEvent PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwWaitForKeyedEvent PROTO :QWORD,:QWORD,:QWORD,:QWORD
ZwWaitForMultipleObjects PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwWaitForMultipleObjects32 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR
ZwWaitForSingleObject PROTO :QWORD,:QWORD,:QWORD
ZwWaitHighEventPair PROTO :QWORD
ZwWaitLowEventPair PROTO :QWORD
ZwWriteFile PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwWriteFileGather PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwWriteRequestData PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwWriteVirtualMemory PROTO :QWORD,:QWORD,:QWORD,:QWORD,:QWORD
ZwYieldExecution PROTO
IF (NTDDI_VERSION GE NTDDI_VISTA)
    A_SHAFinal PROTO :XPTR,:XWORD
    A_SHAInit PROTO :XPTR
    A_SHAUpdate PROTO :XPTR,:XPTR,:XWORD
    AlpcAdjustCompletionListConcurrencyCount PROTO :XWORD,:XWORD
    AlpcFreeCompletionListMessage PROTO :XPTR,:XPTR
    AlpcGetCompletionListLastMessageInformation PROTO :XPTR,:XPTR,:XPTR
    AlpcGetCompletionListMessageAttributes PROTO :XPTR,:XPTR
    AlpcGetHeaderSize PROTO :XWORD
    AlpcGetMessageAttribute PROTO :XPTR,:XWORD
    AlpcGetMessageFromCompletionList PROTO :XPTR,:XPTR
    AlpcGetOutstandingCompletionListMessageCount PROTO :XPTR
    AlpcInitializeMessageAttribute PROTO :XWORD,:XPTR,:XWORD
    AlpcMaxAllowedMessageLength PROTO
    AlpcRegisterCompletionList PROTO :XWORD,:XPTR,:XWORD,:XWORD,:XWORD
    AlpcRegisterCompletionListWorkerThread PROTO :XPTR
    AlpcRundownCompletionList PROTO :XWORD
    AlpcUnregisterCompletionList PROTO :XWORD
    AlpcUnregisterCompletionListWorkerThread PROTO :XWORD
    CsrVerifyRegion PROTO :XWORD,:XWORD
    EtwDeliverDataBlock PROTO :XWORD
    EtwEnumerateProcessRegGuids PROTO :XWORD,:XWORD,:XWORD
    EtwEventActivityIdControl PROTO :XWORD,:XWORD
    EtwEventEnabled PROTO :XWORD,:XPTR
    EtwEventProviderEnabled PROTO :XWORD,:XWORD,:XWORD
    EtwEventRegister PROTO :XPTR,:XPTR,:XPTR,:XPTR
    EtwEventUnregister PROTO :XWORD
    EtwEventWrite PROTO :XWORD,:XPTR,:XPTR,:XWORD,:XPTR
    EtwEventWriteEndScenario PROTO :XWORD,:XPTR,:XWORD,:XPTR
    EtwEventWriteFull PROTO :XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XWORD,:XPTR
    EtwEventWriteStartScenario PROTO :XWORD,:XPTR,:XWORD,:XPTR
    EtwEventWriteString PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XPTR
    EtwEventWriteTransfer PROTO :XWORD,:XPTR,:XPTR,:XPTR,:XWORD,:XPTR
    EtwLogTraceEvent PROTO :XOWRD,:XOWRD,:XOWRD
    EtwNotificationRegister PROTO :XOWRD,:XOWRD,:XOWRD,:XOWRD
    EtwNotificationUnregister PROTO :XOWRD,:XOWRD,:XOWRD
    EtwProcessPrivateLoggerRequest PROTO :XWORD
    EtwRegisterSecurityProvider PROTO
    EtwReplyNotification PROTO :XWORD
    EtwSendNotification PROTO :XOWRD,:XOWRD,:XOWRD,:XOWRD,:XOWRD
    EtwSetMark PROTO :XOWRD,:XOWRD,:XOWRD,:XOWRD
    EtwTraceEventInstance PROTO :XOWRD,:XOWRD,:XOWRD,:XOWRD,:XOWRD
    EtwWriteUMSecurityEvent PROTO :XPTR,:XOWRD,:XOWRD,:XPTR
    EtwpCreateEtwThread PROTO :XWORD,:XWORD
    EtwpGetCpuSpeed PROTO :XWORD,:XWORD
    LdrAddLoadAsDataTable PROTO :XOWRD,:XOWRD,:XOWRD,:XOWRD,:XOWRD
    LdrGetFailureData PROTO
    LdrGetFileNameFromLoadAsDataTable PROTO :XWORD,:XWORD
    LdrGetProcedureAddressEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrLoadAlternateResourceModuleEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrQueryModuleServiceTags PROTO :XWORD,:XWORD,:XWORD
    LdrRegisterDllNotification PROTO :XWORD,:XWORD,:XWORD,:XWORD
    LdrRemoveLoadAsDataTable PROTO :XWORD,:XWORD,:XWORD,:XWORD
    LdrResFindResource PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrResFindResourceDirectory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrResRelease PROTO :XWORD,:XWORD,:XWORD
    LdrResSearchResource PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrSetMUICacheType PROTO :XWORD
    LdrUnloadAlternateResourceModuleEx PROTO :XWORD,:XWORD
    LdrUnregisterDllNotification PROTO :XWORD
    LdrVerifyImageMatchesChecksumEx PROTO :XWORD,:XWORD
    LdrpResGetMappingSize PROTO :XWORD,:XWORD,:XWORD,:XWORD
    LdrpResGetResourceDirectory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    MD4Final PROTO :XWORD
    MD4Init PROTO :XWORD
    MD4Update PROTO :XWORD,:XWORD,:XWORD
    MD5Final PROTO :XWORD
    MD5Init PROTO :XWORD
    MD5Update PROTO :XWORD,:XWORD,:XWORD
    NtAlpcAcceptConnectPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcCancelMessage PROTO :XWORD,:XWORD,:XWORD
    NtAlpcConnectPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,,:XWORD
    NtAlpcCreatePort PROTO :XWORD,:XWORD,:XWORD
    NtAlpcCreatePortSection PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcCreateResourceReserve PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcCreateSectionView PROTO :XWORD,:XWORD,:XWORD
    NtAlpcCreateSecurityContext PROTO :XWORD,:XWORD,:XWORD
    NtAlpcDeletePortSection PROTO :XWORD,:XWORD,:XWORD
    NtAlpcDeleteResourceReserve PROTO :XWORD,:XWORD,:XWORD
    NtAlpcDeleteSectionView PROTO :XWORD,:XWORD,:XWORD
    NtAlpcDeleteSecurityContext PROTO :XWORD,:XWORD,:XWORD
    NtAlpcDisconnectPort PROTO :XWORD,:XWORD
    NtAlpcImpersonateClientOfPort PROTO :XWORD,:XWORD,:XWORD
    NtAlpcOpenSenderProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcOpenSenderThread PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcQueryInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcQueryInformationMessage PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcRevokeSecurityContext PROTO :XWORD,:XWORD,:XWORD
    NtAlpcSendWaitReceivePort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcSetInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtCancelIoFileEx PROTO :XWORD,:XWORD,:XWORD
    NtCancelSynchronousIoFile PROTO :XWORD,:XWORD,:XWORD
    NtCommitComplete PROTO :XWORD,:XWORD
    NtCommitEnlistment PROTO :XWORD,:XWORD
    NtCommitTransaction PROTO :XWORD,:XWORD
    NtCreateEnlistment PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreateKeyTransacted PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreatePrivateNamespace PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtCreateResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreateThreadEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreateTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreateTransactionManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreateUserProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreateWorkerFactory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtDeletePrivateNamespace PROTO :XWORD
    NtEnumerateTransactionObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtFlushInstallUILanguage PROTO :XWORD,:XWORD
    NtFlushProcessWriteBuffers PROTO
    NtFreezeRegistry PROTO :XWORD
    NtFreezeTransactions PROTO :XWORD,:XWORD
    NtGetMUIRegistryInfo PROTO :XWORD,:XWORD,:XWORD
    NtGetNextProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtGetNextThread PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtGetNlsSectionPtr PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtGetNotificationResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtInitializeNlsFiles PROTO :XWORD,:XWORD,:XWORD
    NtIsUILanguageComitted PROTO
    NtMapCMFModule PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtOpenEnlistment PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtOpenKeyTransacted PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtOpenPrivateNamespace PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtOpenResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtOpenSession PROTO :XWORD,:XWORD,:XWORD
    NtOpenTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtOpenTransactionManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtPrePrepareComplete PROTO :XWORD,:XWORD
    NtPrePrepareEnlistment PROTO :XWORD,:XWORD
    NtPrepareComplete PROTO :XWORD,:XWORD
    NtPrepareEnlistment PROTO :XWORD,:XWORD
    NtPropagationComplete PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtPropagationFailed PROTO :XWORD,:XWORD,:XWORD
    NtQueryInformationEnlistment PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQueryInformationResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQueryInformationTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQueryInformationTransactionManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQueryInformationWorkerFactory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQueryLicenseValue PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtReadOnlyEnlistment PROTO :XWORD,:XWORD
    NtRecoverEnlistment PROTO :XWORD,:XWORD
    NtRecoverResourceManager PROTO :XWORD
    NtRecoverTransactionManager PROTO :XWORD
    NtRegisterProtocolAddressInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtReleaseWorkerFactoryWorker PROTO :XWORD
    NtRemoveIoCompletionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtRenameTransactionManager PROTO :XWORD,:XWORD
    NtReplacePartitionUnit PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtRollbackComplete PROTO :XWORD,:XWORD
    NtRollbackEnlistment PROTO :XWORD,:XWORD
    NtRollbackTransaction PROTO :XWORD,:XWORD
    NtRollforwardTransactionManager PROTO :XWORD,:XWORD
    NtSetInformationEnlistment PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtSetInformationResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtSetInformationTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtSetInformationTransactionManager PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtSetInformationWorkerFactory PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtShutdownWorkerFactory PROTO :XWORD,:XWORD
    NtSinglePhaseReject PROTO :XWORD,:XWORD
    NtThawRegistry PROTO
    NtThawTransactions PROTO
    NtTraceControl PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtWaitForWorkViaWorkerFactory PROTO :XWORD,:XWORD
    NtWorkerFactoryWorkerReady PROTO :XWORD
    NtdllDefWindowProc_A PROTO
    NtdllDefWindowProc_W PROTO
    NtdllDialogWndProc_A PROTO
    NtdllDialogWndProc_W PROTO
    RtlAcquireSRWLockExclusive PROTO :XWORD
    RtlAcquireSRWLockShared PROTO :XWORD
    RtlAddMandatoryAce PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlAddSIDToBoundaryDescriptor PROTO :XWORD,:XWORD
    RtlAllocateMemoryBlockLookaside PROTO :XWORD,:XWORD,:XWORD
    RtlAllocateMemoryZone PROTO :XWORD,:XWORD,:XWORD
    RtlBarrier PROTO :XWORD,:XWORD
    RtlBarrierForDelete PROTO :XWORD,:XWORD
    RtlCleanUpTEBLangLists PROTO
    RtlCloneUserProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlCmDecodeMemIoResource PROTO :XWORD,:XWORD
    RtlCmEncodeMemIoResource PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlCommitDebugInfo PROTO :XWORD,:XWORD
    RtlCompareAltitudes PROTO :XWORD
    RtlCompareUnicodeStrings PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlConnectToSm PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlConvertLCIDToString PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlCreateBoundaryDescriptor PROTO :XWORD,:XWORD
    RtlCreateEnvironmentEx PROTO :XWORD,:XWORD,:XWORD
    RtlCreateMemoryBlockLookaside PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlCreateMemoryZone PROTO :XWORD,:XWORD,:XWORD
    RtlCreateProcessParametersEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlCreateUserStack PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlCultureNameToLCID PROTO :XWORD,:XWORD
    RtlDeCommitDebugInfo PROTO :XWORD,:XWORD,:XWORD
    RtlDeleteBarrier PROTO :XWORD
    RtlDeleteBoundaryDescriptor PROTO :XWORD
    RtlDeregisterSecureMemoryCacheCallback PROTO :XWORD
    RtlDestroyMemoryBlockLookaside PROTO :XWORD
    RtlDestroyMemoryZone PROTO :XWORD
    RtlExitUserProcess PROTO :XWORD
    RtlExpandEnvironmentStrings PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlExtendMemoryBlockLookaside PROTO :XWORD,:XWORD
    RtlExtendMemoryZone PROTO :XWORD,:XWORD
    RtlFindAceByType PROTO :XWORD,:XWORD,:XWORD
    RtlFindClosestEncodableLength PROTO :XWORD,:XWORD,:XWORD
    RtlFlsAlloc PROTO :XWORD,:XWORD
    RtlFlsFree PROTO :XWORD
    RtlFreeMemoryBlockLookaside PROTO :XWORD,:XWORD
    RtlFreeUserStack PROTO :XWORD
    RtlGetCurrentTransaction PROTO
    RtlGetFileMUIPath PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlGetIntegerAtom PROTO :XWORD,:XWORD
    RtlGetParentLocaleName PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlGetProductInfo PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlGetSystemPreferredUILanguages PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlGetThreadLangIdByIndex PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlGetThreadPreferredUILanguages PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlGetUILanguageInfo PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlGetUnloadEventTraceEx PROTO :XWORD,:XWORD,:XWORD
    RtlGetUserPreferredUILanguages PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlHeapTrkInitialize PROTO :XWORD
    RtlIdnToAscii PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlIdnToNameprepUnicode PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlIdnToUnicode PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlImpersonateSelfEx PROTO :XWORD,:XWORD,:XWORD
    RtlInitBarrier PROTO :XWORD,:XWORD,:XWORD
    RtlInitializeConditionVariable PROTO :XWORD
    RtlInitializeCriticalSectionEx PROTO :XWORD,:XWORD,:XWORD
    RtlInitializeNtUserPfn PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlInitializeSRWLock PROTO :XWORD
    RtlIoDecodeMemIoResource PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlIoEncodeMemIoResource PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlIsCurrentThreadAttachExempt PROTO
    RtlIsNormalizedString PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlIsValidLocaleName PROTO :XWORD,:XWORD
    RtlLCIDToCultureName PROTO :XWORD,:XWORD
    RtlLcidToLocaleName PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlLocaleNameToLcid PROTO :XWORD,:XWORD,:XWORD
    RtlLockCurrentThread PROTO
    RtlLockMemoryBlockLookaside PROTO :XWORD
    RtlLockMemoryZone PROTO :XWORD
    RtlLockModuleSection PROTO :XWORD
    RtlNormalizeString PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlNumberOfSetBitsUlongPtr PROTO :XWORD
    RtlOwnerAcesPresent PROTO :XWORD
    RtlProcessFlsData PROTO :XWORD
    RtlQueryActivationContextApplicationSettings PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueryDynamicTimeZoneInformation PROTO :XWORD
    RtlQueryElevationFlags PROTO :XWORD
    RtlQueryEnvironmentVariable PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueryModuleInformation PROTO :XWORD,:XWORD,:XWORD
    RtlRegisterThreadWithCsrss PROTO
    RtlReleaseSRWLockExclusive PROTO :XWORD
    RtlReleaseSRWLockShared PROTO :XWORD
    RtlRemovePrivileges PROTO :XWORD,:XWORD,:XWORD
    RtlReportException PROTO :XWORD,:XWORD,:XWORD
    RtlResetMemoryBlockLookaside PROTO :XWORD
    RtlResetMemoryZone PROTO :XWORD
    RtlRetrieveNtUserPfn PROTO :XWORD,:XWORD,:XWORD
    RtlRunOnceBeginInitialize PROTO :XWORD,:XWORD,:XWORD
    RtlRunOnceComplete PROTO :XWORD,:XWORD,:XWORD
    RtlRunOnceExecuteOnce PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlRunOnceInitialize PROTO :XWORD
    RtlSendMsgToSm PROTO :XWORD,:XWORD
    RtlSetCurrentTransaction PROTO :XWORD
    RtlSetDynamicTimeZoneInformation PROTO :XWORD
    RtlSetEnvironmentVar PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlSetProcessDebugInformation PROTO :XWORD,:XWORD,:XWORD
    RtlSetThreadPreferredUILanguages PROTO :XWORD,:XWORD,:XWORD
    RtlSetUserFlagsHeap PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlSetUserValueHeap PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlSidDominates PROTO :XWORD,:XWORD,:XWORD
    RtlSidEqualLevel PROTO :XWORD,:XWORD,:XWORD
    RtlSidHashInitialize PROTO :XWORD,:XWORD,:XWORD
    RtlSidHashLookup PROTO XWORD,:XWORD
    RtlSidIsHigherLevel PROTO :XWORD,:XWORD,:XWORD
    RtlSleepConditionVariableCS PROTO :XWORD,:XWORD,:XWORD
    RtlSleepConditionVariableSRW PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlTestBit PROTO :XWORD,:XWORD
    RtlTryAcquirePebLock PROTO
    RtlUnlockCurrentThread PROTO
    RtlUnlockMemoryBlockLookaside PROTO :XWORD
    RtlUnlockMemoryZone PROTO :XWORD
    RtlUnlockModuleSection PROTO :XWORD
    RtlUpdateClonedCriticalSection PROTO :XWORD
    RtlUpdateClonedSRWLock PROTO :XWORD,:XWORD
    RtlUserThreadStart PROTO :XWORD,:XWORD
    RtlWakeAllConditionVariable PROTO :XWORD
    RtlWakeConditionVariable PROTO :XWORD
    RtlWerpReportException PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlWow64CallFunction64 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlWow64EnableFsRedirection PROTO :XWORD
    RtlpCheckDynamicTimeZoneInformation PROTO :XWORD,:XWORD
    RtlpCleanupRegistryKeys PROTO
    RtlpConvertCultureNamesToLCIDs PROTO :XWORD,:XWORD
    RtlpConvertLCIDsToCultureNames PROTO :XWORD,:XWORD
    RtlpCreateProcessRegistryInfo PROTO :XWORD
    RtlpGetLCIDFromLangInfoNode PROTO :XWORD,:XWORD,:XWORD
    RtlpGetNameFromLangInfoNode PROTO :XWORD,:XWORD,:XWORD
    RtlpGetSystemDefaultUILanguage PROTO :XWORD,:XWORD
    RtlpGetUserOrMachineUILanguage4NLS PROTO :XWORD,:XWORD,:XWORD
    RtlpInitializeLangRegistryInfo PROTO :XWORD
    RtlpIsQualifiedLanguage PROTO :XWORD,:XWORD,:XWORD
    RtlpLoadMachineUIByPolicy PROTO :XWORD,:XWORD,:XWORD
    RtlpLoadUserUIByPolicy PROTO :XWORD,:XWORD,:XWORD
    RtlpMuiFreeLangRegistryInfo PROTO :XWORD
    RtlpMuiRegCreateRegistryInfo PROTO
    RtlpMuiRegFreeRegistryInfo PROTO :XWORD,:XWORD
    RtlpMuiRegLoadRegistryInfo PROTO :XWORD,:XWORD
    RtlpQueryDefaultUILanguage PROTO :XWORD,:XWORD
    RtlpRefreshCachedUILanguage PROTO :XWORD,:XWORD
    RtlpSetInstallLanguage PROTO :XWORD,:XWORD
    RtlpSetPreferredUILanguages PROTO :XWORD,:XWORD,:XWORD
    RtlpSetUserPreferredUILanguages PROTO :XWORD,:XWORD,:XWORD
    RtlpVerifyAndCommitUILanguageSettings PROTO :XWORD
    ShipAssert PROTO :XWORD,:XWORD
    ShipAssertGetBufferInfo PROTO :XWORD,:XWORD
    ShipAssertMsgA PROTO :XWORD,:XWORD,:XWORD
    ShipAssertMsgW PROTO :XWORD,:XWORD,:XWORD
    TpAllocAlpcCompletion PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    TpAllocCleanupGroup PROTO :XWORD
    TpAllocIoCompletion PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    TpAllocPool PROTO :XWORD,:XWORD
    TpAllocTimer PROTO :XWORD,:XWORD,:XWORD,:XWORD
    TpAllocWait PROTO :XWORD,:XWORD,:XWORD,:XWORD
    TpAllocWork PROTO :XWORD,:XWORD,:XWORD,:XWORD
    TpCallbackLeaveCriticalSectionOnCompletion PROTO :XWORD,:XWORD
    TpCallbackMayRunLong PROTO :XWORD
    TpCallbackReleaseMutexOnCompletion PROTO :XWORD,:XWORD
    TpCallbackReleaseSemaphoreOnCompletion PROTO :XWORD,:XWORD,:XWORD
    TpCallbackSetEventOnCompletion PROTO :XWORD,:XWORD
    TpCallbackUnloadDllOnCompletion PROTO :XWORD,:XWORD
    TpCancelAsyncIoOperation PROTO :XWORD
    TpCaptureCaller PROTO :XWORD
    TpCheckTerminateWorker PROTO :XWORD
    TpDbgDumpHeapUsage PROTO :XWORD,:XWORD,:XWORD
    TpDbgSetLogRoutine PROTO :XWORD
    TpDisassociateCallback PROTO :XWORD
    TpIsTimerSet PROTO :XWORD
    TpPostWork PROTO :XWORD
    TpReleaseAlpcCompletion PROTO :XWORD
    TpReleaseCleanupGroup PROTO :XWORD
    TpReleaseCleanupGroupMembers PROTO :XWORD,:XWORD,:XWORD
    TpReleaseIoCompletion PROTO :XWORD
    TpReleasePool PROTO :XWORD
    TpReleaseTimer PROTO :XWORD
    TpReleaseWait PROTO :XWORD
    TpReleaseWork PROTO :XWORD
    TpSetPoolMaxThreads PROTO :XWORD,:XWORD
    TpSetPoolMinThreads PROTO :XWORD,:XWORD
    TpSetTimer PROTO :XWORD,:XWORD,:XWORD,:XWORD
    TpSetWait PROTO :XWORD,:XWORD,:XWORD
    TpSimpleTryPost PROTO :XWORD,:XWORD,:XWORD
    TpStartAsyncIoOperation PROTO :XWORD
    TpWaitForAlpcCompletion PROTO :XWORD
    TpWaitForIoCompletion PROTO :XWORD,:XWORD
    TpWaitForTimer PROTO :XWORD,:XWORD
    TpWaitForWait PROTO :XWORD,:XWORD
    TpWaitForWork PROTO :XWORD,:XWORD
    WerReportSQMEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD
    WinSqmAddToStream PROTO :XWORD,:XWORD,:XWORD,:XWORD
    WinSqmEndSession PROTO :XWORD
    WinSqmEventEnabled PROTO :XWORD,:XWORD
    WinSqmEventWrite PROTO :XWORD,:XWORD,:XWORD
    WinSqmIsOptedIn PROTO
    WinSqmSetString PROTO :XWORD,:XWORD,:XWORD
    WinSqmStartSession PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcAcceptConnectPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcCancelMessage PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcConnectPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcCreatePort PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcCreatePortSection PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcCreateResourceReserve PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcCreateSectionView PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcCreateSecurityContext PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcDeletePortSection PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcDeleteResourceReserve PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcDeleteSectionView PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcDeleteSecurityContext PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcDisconnectPort PROTO :XWORD,:XWORD
    ZwAlpcImpersonateClientOfPort PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcOpenSenderProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcOpenSenderThread PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcQueryInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcQueryInformationMessage PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcRevokeSecurityContext PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcSendWaitReceivePort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcSetInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwCancelIoFileEx PROTO :XWORD,:XWORD,:XWORD
    ZwCancelSynchronousIoFile PROTO :XWORD,:XWORD,:XWORD
    ZwCommitComplete PROTO :XWORD,:XWORD
    ZwCommitEnlistment PROTO :XWORD,:XWORD
    ZwCommitTransaction PROTO :XWORD,:XWORD
    ZwCreateEnlistment PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateKeyTransacted PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreatePrivateNamespace PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateThreadEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateTransactionManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateUserProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateWorkerFactory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwDeletePrivateNamespace PROTO :XWORD
    ZwEnumerateTransactionObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwFlushInstallUILanguage PROTO :XWORD,:XWORD
    ZwFlushProcessWriteBuffers PROTO
    ZwFreezeRegistry PROTO :XWORD
    ZwFreezeTransactions PROTO :XWORD,:XWORD
    ZwGetMUIRegistryInfo PROTO :XWORD,:XWORD,:XWORD
    ZwGetNextProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwGetNextThread PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwGetNlsSectionPtr PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwGetNotificationResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwInitializeNlsFiles PROTO :XWORD,:XWORD,:XWORD
    ZwIsUILanguageComitted PROTO
    ZwMapCMFModule PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenEnlistment PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenKeyTransacted PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenPrivateNamespace PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenSession PROTO :XWORD,:XWORD,:XWORD
    ZwOpenTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenTransactionManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwPrePrepareComplete PROTO :XWORD,:XWORD
    ZwPrePrepareEnlistment PROTO :XWORD,:XWORD
    ZwPrepareComplete PROTO :XWORD,:XWORD
    ZwPrepareEnlistment PROTO :XWORD,:XWORD
    ZwPropagationComplete PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwPropagationFailed PROTO :XWORD,:XWORD,:XWORD
    ZwQueryInformationEnlistment PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQueryInformationResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQueryInformationTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQueryInformationTransactionManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQueryInformationWorkerFactory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQueryLicenseValue PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwReadOnlyEnlistment PROTO :XWORD,:XWORD
    ZwRecoverEnlistment PROTO :XWORD,:XWORD
    ZwRecoverResourceManager PROTO :XWORD
    ZwRecoverTransactionManager PROTO :XWORD
    ZwRegisterProtocolAddressInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwReleaseWorkerFactoryWorker PROTO :XWORD
    ZwRemoveIoCompletionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwRenameTransactionManager PROTO :XWORD,:XWORD
    ZwReplacePartitionUnit PROTO :XWORD,:XWORD,:XWORD
    ZwRollbackComplete PROTO :XWORD,:XWORD
    ZwRollbackEnlistment PROTO :XWORD,:XWORD
    ZwRollbackTransaction PROTO :XWORD,:XWORD
    ZwRollforwardTransactionManager PROTO :XWORD,:XWORD
    ZwSetInformationEnlistment PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwSetInformationResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwSetInformationTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwSetInformationTransactionManager PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwSetInformationWorkerFactory PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwShutdownWorkerFactory PROTO :XWORD,:XWORD
    ZwSinglePhaseReject PROTO :XWORD,:XWORD
    ZwThawRegistry PROTO
    ZwThawTransactions PROTO
    ZwTraceControl PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwWaitForWorkViaWorkerFactory PROTO :XWORD,:XWORD
    ZwWorkerFactoryWorkerReady PROTO :XWORD
    _swprintf PROTO :XPTR,:XPTR,:XPTR,:VARARG
    _vswprintf PROTO :XPTR,:XPTR,:XPTR,:VARARG
  
	NtdllDefWindowProcA EQU <NtdllDefWindowProc_A>
	NtdllDialogWndProcA EQU <NtdllDialogWndProc_A>
	NtdllDefWindowProcW EQU <NtdllDefWindowProc_W>
	NtdllDialogWndProcW EQU <NtdllDialogWndProc_W>

    IFDEF APP_UNICODE
        NtdllDefWindowProc EQU <NtdllDefWindowProc_W>
        NtdllDialogWndProc EQU <NtdllDialogWndProc_W>
        ShipAssertMsg EQU <ShipAssertMsgW>
    ELSE
        NtdllDefWindowProc EQU <NtdllDefWindowProc_A>
        NtdllDialogWndProc EQU <NtdllDialogWndProc_A>
        ShipAssertMsg EQU <ShipAssertMsgA>
    ENDIF
ENDIF

IF (NTDDI_VERSION GE NTDDI_WIN7)
    EtwEventSetInformation PROTO :XWORD,:XWORD,:XPTR,:XWORD
    EtwEventWriteEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    EtwEventWriteNoRegistration PROTO :XWORD,:XWORD,:XWORD,:XWORD
    EvtIntReportAuthzEventAndSourceAsync PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    EvtIntReportEventAndSourceAsync PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrGetDllHandleByMapping PROTO :XWORD,:XWORD
    LdrGetDllHandleByName PROTO :XWORD,:XWORD,:XWORD
    LdrGetKnownDllSectionHandle PROTO :XPTR,:XWORD,:XPTR
    LdrResGetRCConfig PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrRscIsTypeExist PROTO :XWORD,:XWORD,:XWORD,:XWORD
    LdrLoadEnclaveModule PROTO :XWORD,:XWORD,:XWORD
    LdrSystemDllInitBlock PROTO
    memcpy_s PROTO :QWORD,:QWORD,:QWORD,:QWORD
    memmove_s PROTO :QWORD,:QWORD,:QWORD,:QWORD
    NtAllocateReserveObject PROTO :XWORD,:XWORD,:XWORD
    NtCreateProfileEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtDrawText PROTO :XWORD
    NtNotifyChangeDirectoryFileEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtNotifyChangeSession PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtOpenKeyEx PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtOpenKeyTransactedEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQuerySecurityAttributesToken PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQuerySystemInformationEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQueueApcThreadEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtSerializeBoot PROTO
    NtSetIoCompletionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtSetTimerEx PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtUmsThreadYield PROTO :XWORD
    RtlAcquireReleaseSRWLockExclusive PROTO :XWORD
    RtlAddIntegrityLabelToBoundaryDescriptor PROTO :XWORD,:XWORD
    IF (NTDDI_VERSION NE NTDDI_WIN81)
        RtlCheckSandboxedToken PROTO :XWORD,:XPTR
    ENDIF
    RtlContractHashTable PROTO :XWORD
    RtlCopyContext PROTO :XWORD,:XWORD,:XWORD
    RtlCopyExtendedContext PROTO :XWORD,:XWORD,:XWORD
    RtlCreateHashTable PROTO :XWORD,:XWORD,:XWORD
    RtlCreateProcessReflection PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlCreateVirtualAccountSid PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlDeleteHashTable PROTO :XWORD
    RtlDetectHeapLeaks PROTO
    RtlDisableThreadProfiling PROTO :XWORD
    RtlEnableThreadProfiling PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlEndEnumerationHashTable PROTO :XWORD,:XWORD
    RtlEndWeakEnumerationHashTable PROTO :XWORD,:XWORD
    RtlEnumerateEntryHashTable PROTO :XWORD,:XWORD
    RtlEthernetAddressToStringA PROTO :XWORD,:XWORD
    RtlEthernetAddressToStringW PROTO :XWORD,:XWORD
    RtlEthernetStringToAddressA PROTO :XWORD,:XWORD,:XWORD
    RtlEthernetStringToAddressW PROTO :XWORD,:XWORD,:XWORD
    RtlExpandHashTable PROTO :XWORD
    RtlGetCurrentProcessorNumberEx PROTO :XWORD
    RtlGetEnabledExtendedFeatures PROTO :XWORD,:XWORD
    RtlGetExtendedContextLength PROTO :XWORD,:XWORD
    RtlGetExtendedFeaturesMask PROTO :XWORD
    RtlGetFullPathName_UEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlGetLocaleFileMappingAddress PROTO :XWORD,:XWORD,:XWORD
    RtlGetNextEntryHashTable PROTO XWORD,:XWORD
    RtlGetProcessPreferredUILanguages PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlInitializeExtendedContext PROTO :XWORD,:XWORD,:XWORD
    RtlInitEnumerationHashTable PROTO :XWORD,:XWORD
    RtlInitWeakEnumerationHashTable PROTO :XWORD,:XWORD
    RtlInsertEntryHashTable PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlInterlockedClearBitRun PROTO :XWORD,:XWORD,:XWORD
    RtlInterlockedSetBitRun PROTO :XWORD,:XWORD,:XWORD
    RtlIsNameInExpression PROTO :XPTR,:XPTR,:XWORD,:XPTR
    RtlKnownExceptionFilter PROTO :XWORD
    RtlLoadStringA PROTO :XWORD,:XWORD,:XPTR,:XWORD
    RtlLoadStringW PROTO :XWORD,:XWORD,:XPTR,:XWORD
    RtlLocateExtendedFeature PROTO :XWORD,:XWORD,:XWORD
    RtlLocateLegacyContext PROTO :XWORD,:XWORD
    RtlLookupEntryHashTable PROTO :XWORD,:XWORD,:XWORD
    RtlQueryCriticalSectionOwner PROTO :XWORD
    RtlQueryPerformanceCounter PROTO :XWORD
    RtlQueryPerformanceFrequency PROTO :XWORD
    RtlQueryThreadProfiling PROTO :XWORD,:XWORD
    RtlReadThreadProfilingData PROTO :XWORD,:XWORD,:XWORD
    RtlRemoveEntryHashTable PROTO :XWORD,:XWORD,:XWORD
    RtlReplaceSidInSd PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlReportSilentProcessExit PROTO :XWORD,:XWORD
    RtlReportSqmEscalation PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlSetExtendedFeaturesMask PROTO :XWORD,:XWORD,:XWORD
    RtlSetProcessPreferredUILanguages PROTO :XWORD,:XWORD,:XWORD
    RtlTryAcquireSRWLockExclusive PROTO :XWORD
    RtlTryAcquireSRWLockShared PROTO :XWORD
    RtlUnicodeToUTF8N PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlUTF8ToUnicodeN PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlWeaklyEnumerateEntryHashTable PROTO :XWORD,:XWORD
    RtlWow64GetThreadContext PROTO :XWORD,:XPTR
    RtlWow64LogMessageInEventLogger PROTO :XWORD,:XWORD,:XWORD
    RtlWow64SetThreadContext PROTO :XWORD,:XPTR
    SbExecuteProcedure PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    SbSelectProcedure PROTO :XWORD,:XWORD,:XWORD,:XWORD
    sprintf_s PROTO :QWORD,:QWORD,:QWORD,:VARARG
    sscanf_s PROTO :VARARG
    strcat_s PROTO :XWORD,:XWORD,:XWORD
    strcpy_s PROTO :XWORD,:XWORD,:XWORD
    strncat_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    strncpy_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    strnlen PROTO :XWORD,:XWORD
    strtok_s PROTO :XWORD,:XWORD,:XWORD
    swprintf_s PROTO :XWORD,:XWORD,:XWORD,:VARARG
    swscanf_s PROTO :VARARG
    TpAllocAlpcCompletionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    TpAlpcRegisterCompletionList PROTO :XWORD
    TpAlpcUnregisterCompletionList PROTO :XWORD
    TpCallbackIndependent PROTO :XWORD
    TpDisablePoolCallbackChecks PROTO :XWORD
    TpQueryPoolStackInformation PROTO :XWORD,:XWORD
    TpSetDefaultPoolMaxThreads PROTO :XWORD
    TpSetDefaultPoolStackInformation PROTO :XWORD
    TpSetPoolStackInformation PROTO :XWORD,:XWORD
    vsprintf_s PROTO :XPTR,:XPTR,:XPTR,:VARARG
    vswprintf_s PROTO :XPTR,:XPTR,:XPTR,:VARARG
    wcscat_s PROTO :XWORD,:XWORD,:XWORD
    wcscpy_s PROTO :XWORD,:XWORD,:XWORD
    wcsncat_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    wcsncpy_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    wcsnlen PROTO :XWORD,:XWORD
    WinSqmAddToAverageDWORD PROTO :XWORD,:XWORD,:XWORD
    WinSqmAddToStreamEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    WinSqmCheckEscalationAddToStreamEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    WinSqmCheckEscalationSetDWORD PROTO :XWORD,:XWORD,:XWORD,:XWORD
    WinSqmCheckEscalationSetDWORD64 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    WinSqmCheckEscalationSetString PROTO :XWORD,:XWORD,:XWORD,:XWORD
    WinSqmCommonDatapointDelete PROTO :XWORD
    WinSqmCommonDatapointSetDWORD PROTO :XWORD,:XWORD,:XWORD
    WinSqmCommonDatapointSetDWORD64 PROTO :XWORD,:XWORD,:XWORD,:XWORD
    WinSqmCommonDatapointSetStreamEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    WinSqmCommonDatapointSetString PROTO :XWORD,:XWORD,:XWORD
    WinSqmGetEscalationRuleStatus PROTO XWORD,:XWORD
    WinSqmGetInstrumentationProperty PROTO :XWORD,:XWORD,:XWORD,:XWORD
    WinSqmIncrementDWORD PROTO :XWORD,:XWORD,:XWORD
    WinSqmIsOptedInEx PROTO :XWORD
    WinSqmSetDWORD PROTO :XWORD,:XWORD,:XWORD
    WinSqmSetDWORD64 PROTO :XWORD,:XWORD,:XWORD,:XWORD
    WinSqmSetEscalationInfo PROTO :XWORD,:XWORD,:XWORD,:XWORD
    WinSqmSetIfMaxDWORD PROTO :XWORD,:XWORD,:XWORD
    WinSqmSetIfMinDWORD PROTO :XWORD,:XWORD,:XWORD
    ZwAllocateReserveObject PROTO :XWORD,:XWORD,:XWORD
    ZwCreateProfileEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwDisableLastKnownGood PROTO
    ZwDrawText PROTO :XWORD
    ZwEnableLastKnownGood PROTO
    ZwNotifyChangeSession PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenKeyEx PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenKeyTransactedEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQuerySecurityAttributesToken PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQuerySystemInformationEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQueueApcThreadEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwSerializeBoot PROTO
    ZwSetIoCompletionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwSetTimerEx PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwUmsThreadYield PROTO :XWORD
    _i64toa_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _i64tow_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _itoa_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _itow_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _ltoa_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _ltow_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _makepath_s PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    _snprintf_s PROTO :XPTR,:XPTR,:XPTR,:XPTR,:VARARG
    _snscanf_s PROTO :VARARG
    _snwprintf_s PROTO :VARARG
    _snwscanf_s PROTO :VARARG
    _splitpath_s PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    _strnset_s PROTO :XPTR,:XPTR,:XWORD,:XPTR
    _strset_s PROTO :XPTR,:XPTR,:XWORD
    _ui64toa_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _ui64tow_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _ultoa_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _ultow_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _vsnprintf_s PROTO :XPTR,:XPTR,:XPTR,:XPTR,:VARARG
    _vsnwprintf_s PROTO :XPTR,:XPTR,:XPTR,:XPTR,:VARARG
    _wcsnset_s PROTO :XPTR,:XPTR,:XWORD,:XPTR
    _wcsset_s PROTO :XPTR,:XPTR,:XWORD
    _wmakepath_s PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    _wsplitpath_s PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    IFDEF APP_UNICODE
        RtlEthernetAddressToString EQU <RtlEthernetAddressToStringW>
        RtlEthernetStringToAddress EQU <RtlEthernetStringToAddressW>
        RtlLoadString EQU <RtlLoadStringW>
    ELSE
        RtlEthernetAddressToString EQU <RtlEthernetAddressToStringA>
        RtlEthernetStringToAddress EQU <RtlEthernetStringToAddressA>
        RtlLoadString EQU <RtlLoadStringA>
    ENDIF
ENDIF

IF (NTDDI_VERSION GE NTDDI_WIN8)
    ApiSetQueryApiSetPresence PROTO :XPTR,:XPTR
    LdrAddDllDirectory PROTO :XPTR,:XPTR
    LdrAppxHandleIntegrityFailure PROTO 
    LdrGetDllDirectory PROTO :XPTR
    LdrGetDllFullName PROTO :XPTR,:XPTR
    LdrGetDllPath PROTO :XWORD,:XWORD,:XWORD,:XWORD
    LdrGetProcedureAddressForCaller PROTO :XPTR,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR
    LdrProcessRelocationBlockEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrQueryOptionalDelayLoadedAPI PROTO 
    LdrRemoveDllDirectory PROTO :XPTR
    LdrResolveDelayLoadedAPI PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XWORD
    LdrResolveDelayLoadsFromDll PROTO :XPTR,:XPTR,:XWORD
    LdrSetDefaultDllDirectories PROTO :XWORD
    LdrSetDllDirectory PROTO :XPTR
    LdrStandardizeSystemPath PROTO :XPTR
    NtAddAtomEx PROTO :XPTR,:XWORD,:XPTR,:XWORD
    NtAdjustTokenClaimsAndDeviceGroups PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR
    NtAlertThreadByThreadId PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcConnectPortEx PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XWORD,:XPTR,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR
    NtAssociateWaitCompletionPacket PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XWORD,:XWORD,:XPTR
    NtCancelWaitCompletionPacket PROTO :XWORD,:XWORD
    NtCreateDirectoryObjectEx PROTO :XPTR,:XWORD,:XPTR,:XWORD,:XWORD
    NtCreateIRTimer PROTO :XPTR,:XWORD
    NtCreateLowBoxToken PROTO :XPTR,:XWORD,:XWORD,:XPTR,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR
    NtCreateTokenEx PROTO :XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    NtCreateWaitCompletionPacket PROTO :XPTR,:XWORD,:XPTR
    NtCreateWnfStateName PROTO :XPTR,:XWORD,:XWORD,:XWORD,:XPTR,:XWORD,:XPTR
    NtDeleteWnfStateData PROTO :XWORD,:XPTR
    NtDeleteWnfStateName PROTO :XPTR
    NtFilterBootOption PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XWORD
    NtFilterTokenEx PROTO :XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    NtFlushBuffersFileEx PROTO :XWORD,:XWORD,:XPTR,:XWORD,:XPTR
    NtGetCachedSigningLevel PROTO :XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    NtQueryWnfStateData PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    NtQueryWnfStateNameInformation PROTO :XPTR,:XWORD,:XPTR,:XPTR,:XWORD
    NtSetCachedSigningLevel PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtSetIRTimer PROTO :XWORD,:XPTR
    NtSetInformationVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XWORD
    NtSubscribeWnfStateChange PROTO :XPTR,:XWORD,:XWORD,:XPTR
    NtUnmapViewOfSectionEx PROTO :XWORD,:XPTR,:XWORD
    NtUnsubscribeWnfStateChange PROTO :XPTR
    NtUpdateWnfStateData PROTO :XPTR,:XWORD,:XWORD,:XPTR,:XPTR,:XWORD,:XWORD
    NtWaitForAlertByThreadId PROTO :XWORD,:XWORD
    RtlAddGrowableFunctionTable PROTO :XPTR,:XPTR,:XWORD,:XWORD,:XWORD,:XWORD
    RtlAddResourceAttributeAce PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlAddScopedPolicyIDAce PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlAllocateWnfSerializationGroup PROTO
    RtlAppxIsFileOwnedByTrustedInstaller PROTO :XWORD,:XPTR
    RtlAvlInsertNodeEx PROTO :XPTR,:XWORD,:XWORD,:XWORD
    RtlAvlRemoveNode PROTO :XPTR,:XWORD
    RtlCanonicalizeDomainName PROTO :XWORD,:XWORD,:XWORD
    RtlCheckPortableOperatingSystem PROTO :XPTR
    RtlCheckTokenCapability PROTO :XWORD,:XPTR,:XWORD
    RtlCheckTokenMembership PROTO :XWORD,:XPTR,:XPTR
    RtlCheckTokenMembershipEx PROTO :XWORD,:XPTR,:XWORD,:XPTR
    RtlClearBit PROTO :XPTR,:XWORD
    RtlCopyBitMap PROTO :XPTR,:XPTR,:XWORD
    RtlCrc32 PROTO :XPTR,:XWORD,:XWORD
    RtlCrc64 PROTO :XPTR,:XWORD,:XWORD
    RtlCreateHashTableEx PROTO :XPTR,:XWORD,:XWORD,:XWORD
    RtlDecompressBufferEx PROTO :XWORD,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR
    RtlDeleteElementGenericTableAvlEx PROTO :XWORD,:XWORD
    RtlDeleteGrowableFunctionTable PROTO :XPTR
    RtlEqualWnfChangeStamps PROTO :XWORD,:XWORD
    RtlExtractBitMap PROTO :XPTR,:XPTR,:XWORD,:XWORD
    RtlFlushHeaps PROTO
    RtlGetAppContainerNamedObjectPath PROTO :XWORD,:XPTR,:XWORD,:XPTR
    RtlGetExePath PROTO
    RtlGetSearchPath PROTO :XPTR
    RtlGetSystemTimePrecise PROTO :XPTR,:XPTR
    RtlGrowFunctionTable PROTO :XPTR,:XWORD
    RtlInterlockedPushListSListEx PROTO :XPTR
    RtlIsCapabilitySid PROTO :XPTR
    RtlIsPackageSid PROTO :XPTR
    RtlIsUntrustedObject PROTO :XWORD,:XPTR,:XPTR
    RtlLengthSidAsUnicodeString PROTO :XPTR,:XPTR
    RtlNumberOfClearBitsInRange PROTO :XPTR,:XWORD,:XWORD
    RtlNumberOfSetBitsInRange PROTO :XPTR,:XWORD,:XWORD
    RtlpConvertAbsoluteToRelativeSecurityAttribute PROTO :XWORD,:XWORD,:XWORD
    RtlpConvertRelativeToAbsoluteSecurityAttribute PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlpFreezeTimeBias PROTO
    RtlpMergeSecurityAttributeInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlPublishWnfStateData PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueryPackageIdentity PROTO :XWORD,:XPTR
    RtlQueryRegistryValuesEx PROTO :XWORD,:XPTR,:XPTR,:XPTR,:XPTR
    RtlQueryUnbiasedInterruptTime PROTO :XWORD
    RtlQueryValidationRunlevel PROTO :XPTR
    RtlQueryWnfMetaNotification PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueryWnfStateData PROTO :XPTR,:XWORD,:XPTR,:XPTR,:XPTR
    RtlQueryWnfStateDataWithExplicitScope PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueueApcWow64Thread PROTO :XWORD,:XPTR,:XPTR,:XWORD,:XWORD
    RtlRbInsertNodeEx PROTO :XPTR,:XPTR,:XWORD,:XPTR
    RtlRbRemoveNode PROTO :XPTR,:XPTR
    RtlRegisterForWnfMetaNotification PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlReleasePath PROTO :XWORD
    RtlResetNtUserPfn PROTO
    RtlSetBit PROTO :XPTR,:XWORD
    RtlSetPortableOperatingSystem PROTO :XWORD
    RtlSetSearchPathMode PROTO :XWORD
    RtlSubscribeWnfStateChangeNotification PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlTryConvertSRWLockSharedToExclusiveOrRelease PROTO :XWORD
    RtlTestAndPublishWnfStateData PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlUnsubscribeWnfNotificationWaitForCompletion PROTO :XWORD
    RtlUnsubscribeWnfNotificationWithCompletionCallback PROTO :XWORD,:XWORD,:XWORD
    RtlUnsubscribeWnfStateChangeNotification PROTO :XWORD
    RtlWaitOnAddress PROTO :XPTR,:XPTR,:XPTR,:XPTR
    RtlWaitForWnfMetaNotification PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlWakeAddressAll PROTO :XPTR
    RtlWakeAddressSingle PROTO :XPTR
    RtlWakeAddressSingleNoFence PROTO :XWORD
    RtlWakeAddressAllNoFence PROTO :XWORD
    RtlWnfCompareChangeStamp PROTO :XWORD,:XWORD
    RtlWnfDllUnloadCallback PROTO :XWORD
    TpSetTimerEx PROTO :XPTR,:XPTR,:XWORD,:XWORD
    TpSetWaitEx PROTO :XPTR,:XWORD,:XPTR,:XPTR
    TpTimerOutstandingCallbackCount PROTO :XWORD
    WinSqmIsSessionDisabled PROTO :XWORD
    TpAllocJobNotification PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    TpCallbackDetectedUnrecoverableError PROTO :XWORD
    TpReleaseJobNotification PROTO :XWORD
    TpSetPoolThreadBasePriority PROTO :XWORD,:XWORD
    TpWaitForJobNotification PROTO :XWORD
    ZwAddAtomEx PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwAdjustTokenClaimsAndDeviceGroups PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR
    ZwAlertThreadByThreadId PROTO :XWORD
    ZwAlpcConnectPortEx PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    ZwAssociateWaitCompletionPacket PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XWORD,:XWORD,:XPTR
    ZwCancelWaitCompletionPacket PROTO :XWORD,:XWORD
    ZwCreateDirectoryObjectEx PROTO :XPTR,:XWORD,:XPTR,:XWORD,:XWORD
    ZwCreateIRTimer PROTO :XWORD,:XPTR
    ZwCreateLowBoxToken PROTO :XWORD,:XPTR
    ZwCreateTokenEx PROTO :XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    ZwCreateWaitCompletionPacket PROTO :XPTR,:XWORD,:XPTR
    ZwCreateWnfStateName PROTO :XPTR,:XWORD,:XWORD,:XWORD,:XPTR,:XWORD,:XPTR
    ZwDeleteWnfStateData PROTO :XPTR,:XPTR
    ZwDeleteWnfStateName PROTO :XPTR
    ZwFilterBootOption PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XWORD
    ZwFilterTokenEx PROTO :XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    ZwFlushBuffersFileEx PROTO :XWORD,:XWORD,:XPTR,:XWORD,:XPTR
    ZwGetCachedSigningLevel PROTO :XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    ZwQueryWnfStateData PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    ZwQueryWnfStateNameInformation PROTO :XPTR,:XWORD,:XPTR,:XPTR,:XWORD
    ZwSetCachedSigningLevel PROTO :XWORD,:XWORD,:XPTR,:XWORD,:XPTR
    ZwSetIRTimer PROTO :XWORD,:XPTR
    ZwSetInformationVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XWORD
    ZwSubscribeWnfStateChange PROTO :XPTR,:XWORD,:XWORD,:XPTR
    ZwUnmapViewOfSectionEx PROTO :XWORD,:XPTR,:XWORD
    ZwUnsubscribeWnfStateChange PROTO :XPTR
    ZwUpdateWnfStateData PROTO :XPTR,:XPTR,:XWORD,:XPTR,:XPTR,:XWORD,:XWORD
    ZwWaitForAlertByThreadId PROTO :XPTR,:XPTR
    _errno PROTO :VARARG
    _strlwr_s PROTO :VARARG
    _strupr_s PROTO :VARARG
    _wcslwr_s PROTO :VARARG
    _wcstoi64 PROTO :VARARG
    _wcsupr_s PROTO :VARARG
    iswalnum PROTO :XWORD
    iswascii PROTO :VARARG
    iswgraph PROTO :XWORD
    iswprint PROTO :XWORD
    qsort_s PROTO :VARARG
    wcstok_s PROTO :XWORD,:XWORD,:XWORD
ENDIF

IF (NTDDI_VERSION GE NTDDI_WIN81)
    NtCancelTimer2 PROTO :XWORD,:XPTR
    NtCreateTimer2 PROTO :XPTR,:XPTR,:XPTR,:XWORD,:XWORD
    NtGetCompleteWnfStateSubscription PROTO :XPTR,:XWORD,:XWORD,:XWORD,:XPTR,:XWORD
    NtSetTimer2 PROTO :XWORD,:XPTR,:XPTR,:XPTR
    NtSetWnfProcessNotificationEvent PROTO :XWORD
    LdrSetImplicitPathOptions PROTO :XWORD,:XWORD
    PssNtCaptureSnapshot PROTO :XWORD,:XWORD,:XWORD,:XWORD
    PssNtDuplicateSnapshot PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    PssNtFreeRemoteSnapshot PROTO :XWORD,:XWORD
    PssNtFreeSnapshot PROTO :XWORD
    PssNtFreeWalkMarker PROTO :XWORD
    PssNtQuerySnapshot PROTO :XWORD,:XWORD,:XWORD,:XWORD
    PssNtValidateDescriptor PROTO :XWORD,:XWORD
    PssNtWalkSnapshot PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlAddProcessTrustLabelAce PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlAllocateAndInitializeSidEx PROTO :XPTR,:XWORD,:XPTR,:XPTR
    RtlGetAppContainerParent PROTO :XPTR,:XPTR
    RtlGetAppContainerSidType PROTO :XPTR,:XPTR
    RtlIsParentOfChildAppContainer PROTO :XPTR,:XPTR
    RtlIsValidProcessTrustLabelSid PROTO :XPTR
    RtlQueryPackageIdentityEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueryResourcePolicy PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlSidDominatesForTrust PROTO :XPTR,:XPTR,:XPTR
    RtlStringFromGUIDEx PROTO :XPTR,:XPTR,:XWORD
    RtlTestProtectedAccess PROTO :XWORD,:XWORD
    RtlValidProcessProtection PROTO :XWORD
    TpCallbackSendAlpcMessageOnCompletion PROTO :XWORD,:XWORD,:XWORD,:XWORD
    TpCallbackSendPendingAlpcMessage PROTO :XWORD
    TpTrimPools PROTO
    WinSqmStartSessionForPartner PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwCancelTimer2 PROTO :XWORD,:XPTR
    ZwCreateTimer2 PROTO :XPTR,:XPTR,:XPTR,:XWORD,:XWORD
    ZwGetCompleteWnfStateSubscription PROTO :XPTR,:XPTR,:XWORD,:XWORD,:XPTR,:XWORD
    ZwSetTimer2 PROTO :XWORD,:XPTR,:XPTR,:XPTR
    ZwSetWnfProcessNotificationEvent PROTO :XWORD
ENDIF

IF (NTDDI_VERSION GE NTDDI_WIN10)
    ApiSetQueryApiSetPresenceEx PROTO :XWORD,:XWORD,:XWORD
    DbgUiConvertStateChangeStructureEx PROTO :XWORD,:XWORD
    LdrCallEnclave PROTO :XWORD,:XWORD,:XWORD
    LdrControlFlowGuardEnforced PROTO
    LdrCreateEnclave PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrDeleteEnclave PROTO :XWORD
    LdrFastFailInLoaderCallout PROTO
    LdrInitializeEnclave PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrIsModuleSxsRedirected PROTO :XWORD
    LdrUpdatePackageSearchPath PROTO :XWORD
    NtAcquireProcessActivityReference PROTO :XWORD,:XWORD,:XWORD,:
    NtAllocateVirtualMemoryEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcImpersonateClientContainerOfPort PROTO :XWORD,:XWORD,:XWORD
    NtCallEnclave PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtCommitRegistryTransaction PROTO :XWORD,:XWORD
    NtCompareObjects PROTO :XWORD,:XWORD
    NtCompareSigningLevels PROTO :XWORD,:XWORD
    NtConvertBetweenAuxiliaryCounterAndPerformanceCounter PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtCreateCrossVmEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreateEnclave PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreatePartition PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtCreateRegistryTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtCreateSectionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtGetCurrentProcessorNumberEx PROTO :XWORD
    NtInitializeEnclave PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtLoadEnclaveData PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtManageHotPatch PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtManagePartition PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtMapViewOfSectionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtOpenPartition PROTO :XWORD,:XWORD,:XWORD
    NtOpenRegistryTransaction PROTO :XWORD,:XWORD,:XWORD
    NtQueryAuxiliaryCounterFrequency PROTO :XWORD
    NtQueryDirectoryFileEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQueryInformationByName PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQuerySecurityPolicy PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtRevertContainerImpersonation PROTO
    NtRollbackRegistryTransaction PROTO :XWORD,:XWORD
    NtSetCachedSigningLevel2 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtSetInformationSymbolicLink PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtTerminateEnclave PROTO :XWORD,:XWORD
    RtlAddAccessFilterAce PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlAreLongPathsEnabled PROTO
    RtlCapabilityCheck PROTO :XWORD,:XWORD,:XWORD
    RtlCapabilityCheckForSingleSessionSku PROTO :XWORD,:XWORD,:XWORD
    RtlCheckBootStatusIntegrity PROTO :XWORD,:XWORD
    RtlCheckSystemBootStatusIntegrity PROTO :XWORD
    RtlClearThreadWorkOnBehalfTicket PROTO
    RtlConstructCrossVmEventPath PROTO :XWORD,:XWORD,:XWORD
    RtlConvertDeviceFamilyInfoToString PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlConvertSRWLockExclusiveToShared PROTO :XWORD
    RtlCreateProcessParametersWithTemplate PROTO :XWORD,:XWORD,:XWORD
    RtlCreateUserProcessEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlDecodeRemotePointer PROTO :XWORD,:XWORD,:XWORD
    RtlDeriveCapabilitySidsFromName PROTO :XWORD,:XWORD,:XWORD
    RtlDoesNameContainWildCards PROTO :XWORD
    RtlDosLongPathNameToNtPathName_U_WithStatus PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlDosLongPathNameToRelativeNtPathName_U_WithStatus PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlDrainNonVolatileFlush PROTO :XPTR
    RtlEncodeRemotePointer PROTO :XWORD,:XWORD,:XWORD
    RtlEndStrongEnumerationHashTable PROTO :XWORD,:XWORD
    RtlExtendCorrelationVector PROTO :XWORD
    RtlFillMemoryNonTemporal PROTO :XPTR,:XWORD,:XWORD
    RtlFillNonVolatileMemory PROTO :XPTR,:XPTR,:XWORD,:XWORD,:XWORD
    RtlFindExportedRoutineByName PROTO :XWORD,:XWORD
    RtlFindUnicodeSubstring PROTO :XWORD,:XWORD,:XWORD
    RtlFlsGetValue PROTO :XWORD,:XWORD
    RtlFlsSetValue PROTO :XWORD,:XWORD
    RtlFlushNonVolatileMemory PROTO :XPTR,:XPTR,:XPTR,:XWORD
    RtlFlushNonVolatileMemoryRanges PROTO :XPTR,:XPTR,:XPTR,:XWORD
    RtlFreeNonVolatileToken PROTO :XPTR
    RtlGetActiveConsoleId PROTO
    RtlGetConsoleSessionForegroundProcessId PROTO
    RtlGetCurrentServiceSessionId PROTO
    RtlGetDeviceFamilyInfoEnum PROTO :XWORD,:XWORD,:XWORD
    RtlGetExtendedContextLength2 PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlGetInterruptTimePrecise PROTO :XWORD
    RtlGetMultiTimePrecise PROTO :XWORD,:XWORD,:XWORD
    RtlGetNonVolatileToken PROTO :XWORD
    RtlGetNtSystemRoot PROTO
    RtlGetPersistedStateLocation PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlGetSessionProperties PROTO :XWORD,:XWORD
    RtlGetSuiteMask PROTO
    RtlGetSystemBootStatus PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlGetSystemBootStatusEx PROTO :XWORD,:XWORD,:XWORD
    RtlGetThreadWorkOnBehalfTicket PROTO :XWORD,:XWORD
    RtlGetTokenNamedObjectPath PROTO :XWORD,:XWORD,:XWORD
    RtlGuardCheckLongJumpTarget PROTO :XWORD,:XWORD,:XWORD
    RtlIncrementCorrelationVector PROTO :XWORD
    RtlInitializeCorrelationVector PROTO :XWORD,:XWORD,:XWORD
    RtlInitializeExtendedContext2 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlInitializeSidEx PROTO
    RtlInitStringEx PROTO :XWORD,:XWORD
    RtlInitStrongEnumerationHashTable PROTO :XWORD,:XWORD
    RtlIsCloudFilesPlaceholder PROTO :XWORD,:XWORD
    RtlIsCurrentProcess PROTO :XWORD
    RtlIsCurrentThread PROTO :XWORD
    RtlIsElevatedRid PROTO :XWORD
    RtlIsMultiSessionSku PROTO
    RtlIsMultiUsersInSessionSku PROTO
    RtlIsNameInUnUpcasedExpression PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlIsNonEmptyDirectoryReparsePointAllowed PROTO :XWORD
    RtlIsPartialPlaceholder PROTO :XWORD,:XWORD
    RtlIsPartialPlaceholderFileHandle PROTO :XWORD,:XWORD
    RtlIsPartialPlaceholderFileInfo PROTO :XWORD,:XWORD,:XWORD
    RtlIsProcessorFeaturePresent PROTO :XWORD
    RtlIsStateSeparationEnabled PROTO
    RtlLocateExtendedFeature2 PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlLookupFirstMatchingElementGenericTableAvl PROTO :XWORD,:XWORD,:XWORD
    RtlOsDeploymentState PROTO :XWORD
    RtlQueryImageMitigationPolicy PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueryPackageClaims PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueryProcessPlaceholderCompatibilityMode PROTO
    RtlQueryProtectedPolicy PROTO :XWORD,:XWORD
    RtlQueryRegistryValueWithFallback PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueryThreadPlaceholderCompatibilityMode PROTO
    RtlQueryTokenHostIdAsUlong64 PROTO :XWORD,:XWORD
    RtlRaiseCustomSystemEventTrigger PROTO :XWORD
    RtlReplaceSystemDirectoryInPath PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlReportExceptionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlRestoreBootStatusDefaults PROTO :XWORD
    RtlRestoreSystemBootStatusDefaults PROTO
    RtlSetImageMitigationPolicy PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlSetProcessPlaceholderCompatibilityMode PROTO :XWORD
    RtlSetProtectedPolicy PROTO :XWORD,:XWORD,:XWORD
    RtlSetProxiedProcessId PROTO :XWORD
    RtlSetSystemBootStatus PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlSetSystemBootStatusEx PROTO :XWORD,:XWORD,:XWORD
    RtlSetThreadPlaceholderCompatibilityMode PROTO :XWORD
    RtlSetThreadSubProcessTag PROTO :XWORD
    RtlSetThreadWorkOnBehalfTicket PROTO :XWORD
    RtlStronglyEnumerateEntryHashTable PROTO :XWORD,:XWORD
    RtlSwitchedVVI PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlUdiv128 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlValidateCorrelationVector PROTO :XWORD
    RtlWow64GetCpuAreaInfo PROTO :XPTR,:XWORD,:XPTR
    RtlWow64GetCurrentMachine PROTO
    RtlWow64GetEquivalentMachineCHPE PROTO :XWORD
    RtlWow64GetProcessMachines PROTO :XWORD,:XWORD,:XWORD
    RtlWow64GetSharedInfoProcess PROTO :XWORD,:XWORD,:XWORD
    RtlWow64IsWowGuestMachineSupported PROTO :XWORD,:XWORD
    RtlWriteNonVolatileMemory PROTO :XPTR,:XPTR,:XPTR,:XWORD
    RtlpGetDeviceFamilyInfoEnum PROTO :XWORD,:XWORD,:XWORD
    RtlpTimeFieldsToTime PROTO :XWORD,:XWORD,:XWORD
    RtlpTimeToTimeFields PROTO :XWORD,:XWORD,:XWORD
    TpSetPoolMaxThreadsSoftLimit PROTO :XWORD,:XWORD
    TpSetPoolThreadCpuSets PROTO :XWORD,:XWORD,:XWORD
    TpSetPoolWorkerThreadIdleTimeout PROTO :XWORD,:XWORD,:XWORD
    WerReportExceptionWorker PROTO :XWORD
    WinSqmStartSqmOptinListener PROTO
    ZwAcquireProcessActivityReference PROTO :XWORD,:XWORD,:XWORD
    ZwAllocateVirtualMemoryEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcImpersonateClientContainerOfPort PROTO :XWORD,:XWORD,:XWORD
    ZwCallEnclave PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwCommitRegistryTransaction PROTO :XWORD,:XWORD
    ZwCompareObjects PROTO :XWORD,:XWORD
    ZwCompareSigningLevels PROTO :XWORD,:XWORD
    ZwConvertBetweenAuxiliaryCounterAndPerformanceCounter PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateCrossVmEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateEnclave PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreatePartition PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateRegistryTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateSectionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwGetCurrentProcessorNumberEx PROTO :XWORD
    ZwInitializeEnclave PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwLoadEnclaveData PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwManageHotPatch PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwManagePartition PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwMapViewOfSectionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwNotifyChangeDirectoryFileEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenPartition PROTO :XWORD,:XWORD,:XWORD
    ZwOpenRegistryTransaction PROTO :XWORD,:XWORD,:XWORD
    ZwQueryAuxiliaryCounterFrequency PROTO :XWORD
    ZwQueryInformationByName PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQuerySecurityPolicy PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwRevertContainerImpersonation PROTO
    ZwRollbackRegistryTransaction PROTO :XWORD,:XWORD
    ZwSetCachedSigningLevel2 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwSetInformationSymbolicLink PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwTerminateEnclave PROTO :XWORD,:XWORD
    _vscprintf PROTO :VARARG
    atan2 PROTO :VARARG
    bsearch_s PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR
ENDIF

IFDEF APP_UNICODE
    EtwRegisterTraceGuids EQU <EtwRegisterTraceGuidsW>
    RtlIpv4AddressToStringEx EQU <RtlIpv4AddressToStringExW>
    RtlIpv4AddressToString EQU <RtlIpv4AddressToStringW>
    RtlIpv4StringToAddressEx EQU <RtlIpv4StringToAddressExW>
    RtlIpv4StringToAddress EQU <RtlIpv4StringToAddressW>
    RtlIpv6AddressToStringEx EQU <RtlIpv6AddressToStringExW>
    RtlIpv6AddressToString EQU <RtlIpv6AddressToStringW>
    RtlIpv6StringToAddressEx EQU <RtlIpv6StringToAddressExW>
    RtlIpv6StringToAddress EQU <RtlIpv6StringToAddressW>
ELSE
    EtwRegisterTraceGuids EQU <EtwRegisterTraceGuidsA>
    EtwRegisterTraceGuids EQU <EtwRegisterTraceGuidsA>
    RtlIpv4AddressToStringEx EQU <RtlIpv4AddressToStringExA>
    RtlIpv4AddressToString EQU <RtlIpv4AddressToStringA>
    RtlIpv4StringToAddressEx EQU <RtlIpv4StringToAddressExA>
    RtlIpv4StringToAddress EQU <RtlIpv4StringToAddressA>
    RtlIpv6AddressToStringEx EQU <RtlIpv6AddressToStringExA>
    RtlIpv6AddressToString EQU <RtlIpv6AddressToStringA>
    RtlIpv6StringToAddressEx EQU <RtlIpv6StringToAddressExA>
    RtlIpv6StringToAddress EQU <RtlIpv6StringToAddressA>
ENDIF

;======================= Undocumented functions (unknown arguments) =======================;
;EtwTraceMessageVa PROTO
;ExpInterlockedPopEntrySListEnd PROTO
;ExpInterlockedPopEntrySListFault PROTO
;ExpInterlockedPopEntrySListResume PROTO
;LdrProcessInitializationComplete PROTO
;_fltused PROTO
;ZwApphelpCacheControl PROTO
;IFNDEF __misaligned_access
;    __misaligned_access PROTO
;ENDIF
;IF (NTDDI_VERSION GE NTDDI_VISTA)
;    RtlCompleteProcessCloning PROTO
;ENDIF
;IF (NTDDI_VERSION GE NTDDI_WIN7)
;    RtlCreateUmsCompletionList PROTO
;    RtlCreateUmsThreadContext PROTO
;    RtlDeleteUmsCompletionList PROTO
;    RtlDeleteUmsThreadContext PROTO
;    RtlDequeueUmsCompletionListItems PROTO
;    RtlEnterUmsSchedulingMode PROTO
;    RtlExecuteUmsThread PROTO
;    RtlGetCurrentUmsThread PROTO
;    RtlGetNextUmsListItem PROTO
;    RtlGetUmsCompletionListEvent PROTO
;    RtlpUmsExecuteYieldThreadEnd PROTO
;    RtlpUmsThreadYield PROTO
;    RtlNtdllName PROTO
;    RtlpExecuteUmsThread PROTO
;    RtlPrepareForProcessCloning PROTO
;    RtlpQueryProcessDebugInformationFromWow64 PROTO
;    RtlQueryUmsThreadInformation PROTO
;    RtlSetUmsThreadInformation PROTO
;    RtlUmsThreadYield PROTO
;    RtlWow64GetThreadSelectorEntry PROTO
;    RtlWow64SuspendThread PROTO
;ENDIF
;IF (NTDDI_VERSION GE NTDDI_WIN81)
;    KiUserInvertedFunctionTable PROTO
;ENDIF
;IF (NTDDI_VERSION GE NTDDI_WIN10)
;    EtwCheckCoverage PROTO
;    RtlCallEnclaveReturn PROTO
;    RtlCreateUserFiberShadowStack PROTO
;    RtlEnclaveCallDispatch PROTO
;    RtlEnclaveCallDispatchReturn PROTO
;    RtlFreeUserFiberShadowStack PROTO
;    RtlInitializeBitMapEx PROTO
;    RtlTestBitEx PROTO
;    RtlUserFiberStart PROTO
;    RtlWow64GetCurrentCpuArea PROTO
;    RtlWow64SuspendProcess PROTO
;    RtlpQueryProcessDebugInformationRemote PROTO
;    RtlpWow64CtxFromAmd64 PROTO
;    RtlpWow64GetContextOnAmd64 PROTO
;    RtlpWow64SetContextOnAmd64 PROTO
;    RtlWow64PopAllCrossProcessWorkFromWorkList PROTO
;    RtlWow64PopCrossProcessWorkFromFreeList PROTO
;    RtlWow64PushCrossProcessWorkOntoFreeList PROTO
;    RtlWow64PushCrossProcessWorkOntoWorkList PROTO
;    RtlWow64RequestCrossProcessHeavyFlush PROTO
;ENDIF

ENDIF ;NTDLL_INC
